/*!
 * IxF Plugins 
 * @description This file is a collection of jquery plugins and modernizr used by IxF.
 * @version     1.1.3 - 2012/3/28
 * @copyright   Copyright © 2012 by Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * global       ixf, $, window
 */

var ixf = ixf || {};

/*!
 * fixSelect
 * @description	Allows us to style the select box across browsers
 * @version     1.1.3 - 2011/8/11
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires    ui.core.js (1.8+)
 */
(function(a){a.widget("ixf.fixSelect",{options:{selectClass:"select",arrowSpanClass:"arrow",textSpanClass:"text",hoverClass:"hover",focusClass:"focus",activeClass:"active",disabledClass:"disabled",padding:0,wrapperTag:"span",deriveWidth:!1},_create:function(b){var c=this.options,d=this.element,e=this,f=a("<"+c.wrapperTag+" />"),g=a('<span class="'+c.textSpanClass+'" />'),h=a('<span class="'+c.arrowSpanClass+'" />'),i=d.find(":selected:first"),j=c.activeClass,k=c.hoverClass,l=c.focusClass,m=e.widgetName;d.parent("."+c.selectClass).length&&d.fixSelect("destroy"),c.spanTag=g,c.arrowSpanTag=h;if(d.is("[multiple]"))return;f.addClass(c.selectClass).css({position:"relative"}),c.useID&&f.attr("id",c.idPrefix+"-"+d.attr("id")),i.length===0&&(i=d.find("option:first")),e.updateSpanTag(g,i.text()),d.css("opacity",.001),d.wrap(f),d.before(g),d.before(h);var f=d.parent("span"),g=d.siblings("span."+c.textSpanClass);h=d.siblings("span."+c.arrowSpanClass),e.updateWidths(),d.css({position:"absolute",top:0,left:0});if(!d.is(":visible")&&!c.deriveWidth){var n=parseInt(f.css("padding-left"),10)+parseInt(f.css("padding-right"),10),o=f.clone(),p;o.css({position:"absolute",top:"-1000em"}).appendTo("body"),p=o.find("select").outerWidth()-n,f.css({width:p}),c.spanTag.css({width:p}),o.remove()}d.css("opacity",.001),d.bind("change."+m,function(){e.updateSpanTag(g,d.find(":selected").text()),f.removeClass(c.activeClass),c.deriveWidth&&e.updateWidths(!0)}).bind("focus."+m,function(){f.addClass(l)}).bind("blur."+m,function(){f.removeClass(l),f.removeClass(j)}).bind("mousedown."+m,function(){f.addClass(j)}).bind("mouseup."+m,function(){f.removeClass(j)}).bind("click."+m,function(a){f.removeClass(j)}).bind("mouseover."+m,function(){f.addClass(k)}).bind("mouseout."+m,function(){f.removeClass(k)}).bind("keyup."+m,function(){e.updateSpanTag(g,d.find(":selected").text())}),a(d).attr("disabled")&&f.addClass(c.disabledClass),a(d).attr("readonly")&&e.readonly("true"),e.updateWidths()},disable:function(){this.element.parent("span").addClass(this.options.disabledClass)},enable:function(){this.element.parent("span").removeClass(this.options.disabledClass)},readonly:function(a){this.options.readonly=a||!0},destroy:function(){a.Widget.prototype.destroy.apply(this,arguments);var b=this.element;b.parent().find("span").remove(),b.unwrap().css({opacity:"",position:"",top:"",left:""}).unbind("."+this.widgetName)},updateWidths:function(a){var b=this.element,c=this.options,d=b.parent(c.wrapperTag);a||b.trigger("change."+this.widgetName),b.is(":visible")&&(c.deriveWidth?b.css({width:d.outerWidth(),height:d.outerHeight(),position:"absolute",top:0,left:0}):(d.css({width:b.outerWidth()-(d.outerWidth()-d.width())+parseInt(c.padding,10)}),c.spanTag.css({width:d.width()})))},updateSpanTag:function(a,b){b?a.text(b):a.html("&nbsp;")}}),a.extend(a.ixf.fixSelect,{version:"1.1.3"})})(jQuery);
/*!
 * fillHeight
 * @description	allows one of X siblings to take up all available space that the other siblings are not taking up.
 * @version     1.0 beta 2  - 2010/10/08
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	  ui.core.js (1.8+)
 * @Notes		    call it on the element you want to fill the height. Requires the immediate parent to have a height set. It's expected (but not required) that the target element has an overflow:auto or something to allow scrolling if needed for excess content.
 */
(function(a){a.widget("ixf.fillHeight",{options:{autoUpdate:!1},_create:function(){var b=this.options,c=this.element;b.autoUpdate&&a(window).bind("resize.fillHeight",function(){setTimeout(function(){c.fillHeight("setHeight")},10)}),this.setHeight()},setHeight:function(){var b=this.element,c=0;b.siblings(":visible").each(function(){c+=a(this).outerHeight(!0)}),b.height(b.parent().height()-c-1),this._trigger("resize",0,this)},destroy:function(){a.Widget.prototype.destroy.apply(this,arguments),a(window).unbind("resize.fillHeight")}}),a.extend(a.ixf.fillHeight,{version:"1.0 beta 2"})})(jQuery);
/*!
 * fixHeader
 * @description	Fixes the header at the top of the page/scrollable element when it reaches the top. Scrolls of page with the end of the table.
 * @version		1.4  - 2011/04/11
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	ui.core.js (1.8+)
 * @optional	jCaret (http://plugins.jquery.com/project/jCaret)
 */
(function(a){a.widget("ixf.fixHeader",{options:{classFilter:/margin\-bottom\-\w+/,removeID:!0,cloneBuffer:100},_create:function(){var b=this.options,c=this,d=this.element,e=c.widgetName,f;b.uniqueID=Math.floor(Math.random()*99999);if(!d.find("tbody").length)return!1;b.container=a(window),f=a("body"),d.parents().each(function(){if((a(this).css("overflow")==="scroll"||a(this).css("overflow")==="auto"||a(this).css("overflowY")==="scroll"||a(this).css("overflowY")==="auto")&&!b.inScrollable&&!a(this).is("body"))return b.container=a(this),f=b.container,b.inScrollable=!0,!1}),b.copy=a('<div class="fixed-head"><p class="invisible">You can safely ignore the following table</p></div>'),f.append(b.copy),b.container.bind("scroll.fixHead"+b.uniqueID,function(){c.update()}),a(window).bind("resize.fixHead"+b.uniqueID,function(){c.update()}),a("thead input, thead select",d).bind("focus."+e,function(d){b.lastCol=a(this).closest("td").index(),c.getCaret(this)}).bind("click."+e,function(){c.getCaret(this)}).bind("blur."+e,function(){b.lastCol=undefined}),a("thead input",d).bind("keyup."+e,function(e){var f=a("thead input",d).index(a(this));!b.copyVisible&&b.cloneMade&&a("thead input",b.copy.find("table")).eq(f).val(a(this).val()),c.getCaret(this)})},cloneThead:function(b){var c=this.options,d=this,e=this.element,f,g,h,i,j=d.widgetName,k="thead select";!c.cloneMade&&d.shouldCloneBeVisible(c.cloneBuffer)&&(f=a("<table></table>").attr("class",e.attr("class")).addClass("fixHeaderApplied"),h=e.find("thead").clone(!1),i=f.append(h),c.copy.append(i),c.cloneMade=!0),g=c.copy.find("table");if(!g.length)return;if(!c.headSetup||b){g.children().remove(),h=a("thead",e).clone(!1),g.append(h);var l=g.attr("class").match(c.classFilter);l&&g.removeClass(l[0]),a("thead input",g).unbind("keyup").bind("keyup",function(b){if(c.copyVisible){var f=a("thead input",g).index(a(this));a("thead input",e).eq(f).val(a(this).val()).trigger("keyup"),d.getCaret(this)}}),a("thead th",g).unbind("click").bind("click",function(b){var c=a("thead th",g).index(a(this));return a("thead th",e).eq(c).trigger("click"),!1}),a("thead th",e).unbind("click."+j).bind("click."+j,function(a){d.cloneThead(!0)}),a(k,g).unbind("change").each(function(b){a(this).val(a(k,e).eq(b).val()),ixf.fixSelectAllowed&&a(this).fixSelect()}).bind("change",function(b){var c=a(k,g).index(a(this));a(k,e).eq(c).val(a(this).val()).trigger("change")}),a(k,e).unbind("change."+j).bind("change."+j,function(b){var c=a(k,e).index(a(this));a(k,g).eq(c).val(a(this).val()).trigger("keyup").each(function(){ixf.fixSelectAllowed&&a(this).fixSelect("updateWidths")})}),a("thead input, thead select",g).unbind("focus."+j).bind("focus."+j,function(b){c.lastCol=a(this).closest("td").index()}),c.headSetup=!0}c.copy.width(a(e).outerWidth()),a("thead:eq(0)>tr th",e).each(function(b){a("thead:eq(0)>tr th:eq("+b+")",g).width(a(this).width()).removeClass().addClass(a(this).attr("class"))}),a("thead:eq(0)>tr td",e).each(function(b){a("thead:eq(0)>tr td:eq("+b+")",g).width(a(this).width()).removeClass().addClass(a(this).attr("class"))}),d.update()},getCaret:function(b){var c=this.options;a.fn.caret&&(c.cursorStart=a(b).caret().start,c.cursorEnd=a(b).caret().end)},update:function(){var a=this.options,b=this,c=this.element,d,e=a.copy;if(!a.cloneMade&&b.shouldCloneBeVisible(a.cloneBuffer)){b.cloneThead();return}if(b.shouldCloneBeVisible()){c.parents(".dataTables_wrapper").length&&(c=c.parents(".dataTables_wrapper")),d=b.getHeadLocation();if(d.elemBottomYBuffer<=0&&d.elemBottomY>0)e.is(":hidden")&&(e.show(),a.copyVisible=!0),e.css("position")!=="absolute"&&b.setCursor(e),e.css({position:"absolute",top:d.elemBottomY-d.copyHeight+a.container.scrollTop(),left:d.elemPosition.left});else{if(d.elemBottomY<=0){e.is(":visible")&&(e.hide(),a.copyVisible=!1);return}d.elemPosition.top<0&&(e.is(":hidden")&&(e.show(),b.setCursor(e),a.copyVisible=!0),e.css("position")!=="fixed"&&b.setCursor(e),e.css({position:"fixed",top:a.inScrollable?a.container.offset().top:0,left:c.offset().left}))}}else a.cloneMade&&e.is(":visible")&&(e.hide(),a.scrollDir==="up"&&b.setCursor(c),a.copyVisible=!1)},shouldCloneBeVisible:function(a){a=a||0;var b=this,c=b.getHeadLocation();return c.elemBottomYBuffer<=-a&&c.elemBottomY>-a?!0:c.elemBottomY<=0?!1:c.elemPosition.top<a?!0:!1},getHeadLocation:function(){var b=this.options,c=this.element,d,e=c.find("thead"),f={},g=c,h,i;window.innerHeight?i=window.pageYOffset:document.body&&(i=document.body.scrollTop),c.parents(".dataTables_wrapper").length&&(c=c.parents(".dataTables_wrapper")),f.elemPosition=b.inScrollable?c.position():c.offset(),b.inScrollable||(f.elemPosition.top=f.elemPosition.top-i);var j=a(window).height(),k=i,l=k+j;return f.copyHeight=e.outerHeight(),f.elemBottomY=f.elemPosition.top+g.height(),f.elemBottomYBuffer=f.elemBottomY-f.copyHeight,h=b.container.scrollTop(),b.scrollDir=h<b.scrollY?"up":"down",b.scrollY=h,f},setCursor:function(b){var c=this.options;c.lastCol!==undefined&&setTimeout(function(){var d=a("td:eq("+c.lastCol+")",b).find("input,select");a.fn.caret&&d.is("input")&&d.is("input:visible")&&d.caret({start:c.cursorStart,end:c.cursorEnd})},10)},destroy:function(){var b=this.options;a.Widget.prototype.destroy.apply(this,arguments),b.copy.remove(),b.container.unbind("scroll.fixHead"+b.uniqueID),a(window).unbind("resize.fixHead"+b.uniqueID)}}),a.extend(a.ixf.fixHeader,{version:"1.4"})})(jQuery);
/*!
 * jQuery UI Watermark 1.8.ixf.6
 *
 * Copyright (c) 2009 AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT (MIT-LICENSE.txt)
 * and GPL (GPL-LICENSE.txt) licenses.
 *
 * http://docs.jquery.com/UI/Watermark
 *
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf

 * Depends:
 *	ui.core.js
 * Not officially released jQuery UI version (http://jqueryui.pbworks.com/Watermark) modified to work with jQuery UI 1.8+ - AB
 */
(function(a){a.widget("ixf.watermark",{options:{placeholder:function(){var b=a(this).attr("placeholder");return a(this).data("placeholder",b),a(this).removeAttr("placeholder"),b},opacity:0,allowNative:!0,animate:!0},_create:function(){if(this.options.allowNative&&"placeholder"in document.createElement("input"))return;var b=this.options,c=this.element,d=this.widgetName,e=a.isFunction(b.placeholder)?b.placeholder.apply(this.element[0]):b.placeholder;if(!e)return;c.wrap("<span/>").parent().addClass("ui-watermark-container ui-watermark-"+c[0].tagName.toLowerCase());var f=this.label=a('<label for="'+c.attr("id")+'">'+e+"</label>").insertBefore(c);f.addClass("ui-watermark-label"),f.css({left:parseInt(c.css("borderLeftWidth"),10)+parseInt(c.css("paddingLeft"),10),top:parseInt(c.css("borderTopWidth"),10)+parseInt(c.css("paddingTop"),10),overflow:"hidden",width:c.width()}),c.val()&&f.hide(),c.bind("focus."+d,function(){!b.disabled&&!this.value&&(b.animate?f.fadeTo("fast",b.opacity):f.hide())}).bind("blur."+d,function(){!b.disabled&&!this.value&&(b.animate?f.fadeTo("fast",1):f.show())}).bind("keyup."+d+" change."+d,function(a){this.value?f.hide():f.show()})},destroy:function(){var b=this.element;b.data("placeholder")&&b.attr("placeholder",b.data("placeholder")),b.siblings("label").remove(),b.unwrap().unbind("."+this.widgetName).removeData("placeholder"),a.Widget.prototype.destroy.apply(this,arguments)}}),a.extend(a.ixf.watermark,{version:"1.8.ixf.5"})})(jQuery);
/*!
 * makeVisible
 * @description Scrolls the target element into view when out of the screen (above or below), doesn't scroll if it is onscreen.
 * @version     1.0.5  - 2011/01/11
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires    ui.core.js (1.8+), scrollTo plugin
 * @optional    easing plugin
 */
(function(a){function b(){return window.innerHeight?pos=window.pageYOffset:document.documentElement&&document.documentElement.scrollTop?pos=document.documentElement.scrollTop:document.body&&(pos=document.body.scrollTop),pos}function c(){var a;return self.innerHeight?a=self.innerHeight:document.documentElement&&document.documentElement.clientHeight?a=document.documentElement.clientHeight:document.body&&(a=document.body.clientHeight),a}a.fn.makeVisible=function(b){if(!a.scrollTo){alert("scrollTo plugin is required");return}var c=a.extend({},a.fn.makeVisible.defaults,b);return c.padTop||(c.padTop=c.pad),c.padBottom||(c.padBottom=c.pad),this.each(function(b){var d=this;if(this.nodeName=="A"&&!c.goNow){if(!a(d).data("set.makeVisible")){var e=d.href,d=a(a(this).attr("href"));a(this).bind("click.makeVisible",function(){return a.fn.makeVisible.doScroll(d,c),!1}).bind("remove.makeVisible",function(){a(this).unbind(".makeVisible").removeData("set.makeVisible")}),a(d).data("set.makeVisible",!0)}}else a.fn.makeVisible.doScroll(d,c)})},a.fn.makeVisible.defaults={placeIt:"any",pad:0,padTop:!1,padBottom:!1,onComplete:!1,includePad:!1,easing:"linear",speed:1e3},a.fn.makeVisible.doScroll=function(d,e){var f=!0,g=!1,h=!1;d=a(d);var i=c(),j=b(),k=j+i,l=d.outerHeight(),m=d.offset().top,n=m+l,o=a(a.browser.safari?"body":"html");a(d).parents().each(function(){(a(this).css("overflow")=="scroll"||a(this).css("overflow")=="auto"||a(this).css("overflowY")=="scroll"||a(this).css("overflowY")=="auto")&&!h&&(h=a(this))}),h&&(o=h[0],j=a(h).offset().top,i=h.outerHeight(),k=j+i),l>i&&(g=!0),e.placeIt=="bot"&&(newOffset=l+e.padBottom-i),e.placeIt=="mid"&&(newOffset=l/2-i/2);if(e.placeIt=="top"||g)newOffset=-e.padTop;var p=0;e.includePad&&(m-=e.padTop,n+=e.padBottom),m<j?e.placeIt=="any"&&!g&&(newOffset=-e.padTop):n>k?e.placeIt=="any"&&!g&&(newOffset=l+e.padBottom-i):e.placeIt=="any"&&(f=!1,e.onComplete&&e.onComplete.call(d)),f&&a(o).stop().scrollTo(d,e.speed,{easing:e.easing,offset:newOffset,onAfter:function(){e.onComplete&&e.onComplete.call(d)}})}})(jQuery);
/*!
 * MultiSelect
 * @description	Take a multiple select element and breakes it into individual selects
 * @version		  2.0.7 - 2011/08/16
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	  ui.core.js (1.8+)
 */
(function(a){a.widget("ixf.multiSelect",{options:{addWhere:"bottom",maxFields:0,removePath:"",addPath:"",removeTitle:"Remove this row",addTitle:"Add additional row",adderClass:"sprite icon add",removerClass:"sprite icon delete",removeConfirm:"Are you sure you want to remove this?",matchWidths:!0,onAdd:function(){},onDelete:function(){},onChange:function(){}},_create:function(){var b=this.options,c=this,d=this.element,e,f;d.hide();if(!d.attr("multiple"))return;a.extend(!0,b,d.data("ms-options")),this.element.find(":selected").each(function(){this.setAttribute("selected","selected")}),e="ui-multiSelect-"+Math.floor(Math.random()*999999),c._setOption("uniqueClass",e),b.maxFields||(b.maxFields=d.find("option[value]").length),d.find("option:first").val()!==""&&d.prepend("<option></option>"),d.find("option").each(function(b){a(this).attr("msIndex",b)}),f=d.find("option:selected"),f&&f.length?f.each(function(){c.addSelect(a(this).attr("msIndex"))}):c.addSelect(0),b.setupDone=!0},makeSelect:function(b){var c=this,d=this.element.clone(!1);return a.support.leadingWhitespace||(d.find(":selected").removeAttr("selected"),this.element.find(":selected").each(function(){d.find("[msIndex="+a(this).attr("msIndex")+"]").attr("selected","selected")})),d.find(":selected").filter(function(){return a(this).attr("msIndex")==b||a(this).attr("msIndex")=="0"?!1:!0}).remove(),d.attr({size:"1",id:"ui-multiSelect-"+Math.floor(Math.random()*999999),name:""}).show().removeAttr("multiple").attr("onchange","").bind("change.multiSelect",function(){c._updateValues(d),c.element.trigger("change")}).bind("removeIt.multiSelect",function(){var b=a(this).parents(".wrapper"),d;d=b.next(".wrapper").length?b.next():b.prev(),c._updateValues(a(this)),a(b).remove(),c.updateControls(),d.find(":input:visible").eq(0).focus()}),d},addSelect:function(b){var c=this.options,d=c.uniqueClass,e=this,f=this.element,g,h,i,j;if(c.disabled)return!1;g=this.makeSelect(b),h=f.siblings("."+d+":last"),h.length?a(h).after(g):f.after(g),g.wrap('<div class="wrapper ui-multiSelect ui-widget '+d+'"></div>'),i=a(' <a href="#d" class="remover"><span class="'+c.removerClass+'">'+c.removeTitle+"</span></a>").bind("click.multiSelect",function(){return a(this).data("canRemove")&&(typeof c.removeConfirm=="string"&&e.removeSelect(g),typeof c.removeConfirm=="function"&&c.removeConfirm.call(g)),!1}).data("canRemove",!0),c.removePath&&i.find("span").html('<img src="'+c.removePath+'" alt="'+c.removeTitle+'"/>'),j=a('<a href="#d" class="adder"><span class="'+c.adderClass+'">'+c.addTitle+"</span></a>").bind("click.multiSelect",function(){return e.addSelect(0),!1}),c.addPath&&j.find("span").html('<img src="'+c.addPath+'" alt="'+c.addTitle+'"/>'),g.parents(".wrapper").append(i).append(j),c.setupDone&&g.focus(),g.data("oldIndex",b),e.updateControls(),c.onAdd&&c.onAdd.call(g)},_updateValues:function(b){if(this.options.disabled)return!1;var c=this.options,d=c.uniqueClass,e=a(this.element).siblings("."+d).find("select"),f=this.element,g,h,i;g=b.find(":selected").attr("msIndex"),h=b.data("oldIndex"),b.data("oldIndex",g),h&&f.find("option[msIndex="+h+"]").removeAttr("selected")[0].removeAttribute("selected"),h!=g&&g&&f.find("option[msIndex="+g+"]").attr("selected","selected")[0].setAttribute("selected","selected"),a(e).each(function(){var c=a(this);if(c.attr("id")!=a(b).attr("id")){g&&g!="0"&&c.find("option[msIndex="+g+"]").remove();if(h!="0"){i=b.find("option[msIndex="+h+"]").clone(!0),i.removeAttr("selected");for(var d=h;d>=0;d--)if(c.find("option[msIndex="+d+"]").length){c.find("option[msIndex="+d+"]").after(i);break}}}}),this.updateControls(),c.onChange&&c.setupDone&&c.onChange.call(this)},removeSelect:function(a){var b=this.options,c=!0;if(b.disabled)return!1;b.removeConfirm&&(c=confirm(b.removeConfirm)),c&&(a.trigger("removeIt"),b.onDelete&&b.onDelete.call())},updateControls:function(){var b=this.options,c=b.uniqueClass,d=this.element,e=d.siblings("."+c).find("select:visible"),f=d.siblings("."+c).find(".adder"),g,h,i;e.length<b.maxFields||b.maxFields=="0"?b.addWhere=="bottom"?(f.slice(0,f.length-1).hide(),f.eq(f.length-1).show()):b.addWhere=="top"&&(f.slice(1,f.length).hide(),f.slice(0,1).show()):f.hide(),g=d.siblings("."+c).find(".remover"),g.length=="1"?(g.addClass("disabled").fadeTo(1,.6),g.data("canRemove",!1)):(g.removeClass("disabled"),g.fadeTo(0,1),g.data("canRemove",!0)),b.matchWidths&&(h=0,a(e).each(function(){a(this).width(""),a(this).width()>h&&(h=a(this).width())}),i=30,b.matchWidths>1&&(i=b.matchWidths),a(e).width(h+i))},destroy:function(){var b=this.options,c=b.uniqueClass;a.Widget.prototype.destroy.apply(this,arguments),this.element.removeClass("ui-widget ui-helper-reset").removeAttr("role").unbind(".multiSelect").removeData("multiSelect").show(),a(this.element).siblings("."+c).remove(),this.element.find("option").each(function(b){a(this).removeAttr("msIndex")})}}),a.extend(a.ixf.multiSelect,{version:"2.0.7"})})(jQuery);
/*!
 * finder
 * @description	Mimics the OS X finder. A different way to look at a tree view
 * @version		  1.2.3  - 2010/12/03
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	  ui.core.js (1.8+), scrollTo plugin
 * @optional	  easing plugin
 */
(function(a){a.widget("ixf.finder",{options:{easing:"linear",duration:500,columnHeight:300,columnWidth:200,columnScroll:"auto",width:600,scroll:!0,loadingText:"Loading...",gotoClass:"goto",focusClass:"ui-state-focus",hoverClass:"ui-state-hover",activeClass:"ui-state-active",activeNowClass:"ui-state-active-now",finderClass:"ui-finder"},_create:function(){var b=this.options,c=this,d=this.element,e,f=b.source,g=d.find(">ul"),h=a("<div class='"+b.finderClass+"-container'></div>"),i=a("<div class='"+b.finderClass+"-wrapper'></div>").append(h).appendTo(d);d.addClass(b.finderClass),b.origContent=g,b.container=h,b.wrapper=i,b.scroll&&i.bind("scroll."+b.widgetName,function(){c.updateControls()}).attr("tabindex","-1"),d.attr({role:"tree"}),h.append("<div class='"+b.finderClass+"-loader'>"+b.loadingText+"</div>"),d.addClass("ui-widget-content ui-widget"),b.width&&d.width(b.width),i.css({position:"relative",overflow:b.scroll?"auto":"hidden"}),b.prev&&a(b.prev).bind("click."+c.name,function(){return c.back(),!1}),b.next&&a(b.next).bind("click."+c.name,function(){return c.forward(),!1}),f?f.indexOf("#")!="-1"?b.sourceData=a(f).hide().clone():(a.get(f,function(d){b.sourceData=a(d),c.finishInit()}),e=!0):d.find(">ul").length&&(b.origContents=d.find(">ul"),b.sourceData=d.find(">ul").clone().end().remove()),d.bind("click."+c.name,function(){!d.data("bound")&&b.focusKeyboard&&c.bindKeyboard(),a("."+b.focusClass+" a",d).length||a("."+b.activeNowClass+" a",d).focus()}),e||c.finishInit()},finishInit:function(){var b=this.options,c=this,d=this.element,e=b.sourceData;d.find("."+b.finderClass+"-list a").live("click."+b.widgetName,function(f){var g=a(this).parent(),h=a(this).parents("."+b.finderClass+"-list"),i=g.hasClass(b.finderClass+"-folder"),j=h.index(),k=b.container.find(">div:gt("+j+")"),l;l=c.createColumn(),d.find("li."+b.activeNowClass+"").removeClass(b.activeNowClass),d.find("li."+b.focusClass).removeClass(b.focusClass),g.addClass(b.activeNowClass+" "+b.focusClass+" "+b.activeClass),g.siblings().removeClass(b.activeClass).find("a").attr({"aria-expanded":"false"}),g.find("a").attr({"aria-expanded":"true"}),i&&k.length?k.remove():k.length&&k.not("."+b.finderClass+"-page").remove();if(i){if(g.hasClass("ajax")||g.hasClass("folder"))g.find("a").append('<span class="'+b.finderClass+'-loader">'+b.loadingText+"</span>"),g.hasClass("ajax")&&a.get(this.href,function(a){c.loadStructure(g,a,f)}),g.removeClass("ajax folder"),e.find("#"+g.attr("id")).removeClass("ajax folder");else{var m=e.find("#"+g.attr("id")).find(">ul");m.length&&c.createLevel(m)}c._trigger("onFolderSelect",f,c)}else{var n=g.find("a"),o=n.attr("href");if(n.hasClass(b.gotoClass))return!0;b.target?l=a(b.target):(b.container.append(l),c.setContainerWidth());if(o.indexOf("#")!="-1"){var p=a(o);p.length&&l.html(p.clone().show())}else n.append('<span class="'+b.finderClass+'-loader">'+b.loadingText+"</span>"),a.get(n.attr("href"),function(a){l.html(a),g.find("span."+b.finderClass+"-loader").remove(),c._trigger("onPageLoad",0,g)});c._trigger("onPageSelect",f,g)}return c._trigger("onSelect",f,g),!1}).live("focus."+b.widgetName,function(c){d.find("a[tabindex=0]").attr("tabindex","-1"),d.find("."+b.focusClass).removeClass(b.focusClass),a(this).attr("tabindex","0").parent().addClass(b.focusClass)}).live("blur."+b.widgetName,function(a){c.unbindKeyboard()}),d.find("."+b.finderClass+"-list li").live("mouseover."+b.widgetName+" mouseout."+b.widgetName,function(c){c.type=="mouseover"?a(this).addClass(b.hoverClass):a(this).removeClass(b.hoverClass)}),d.find("a").live("focus."+b.widgetName,function(){!d.data("bound")&&b.focusKeyboard&&c.bindKeyboard()}),b.uid=0,c.tagSource(),c.createLevel(e),d.find("."+b.finderClass+"-loader").remove(),d.find("a:first").attr({tabindex:"0"}),b.sourceData.find("."+b.activeNowClass+":last").each(function(){a(a(this).parents("li").toArray().reverse()).each(function(){a("#"+a(this).attr("id")+" a").click()}),a(this).removeClass(b.activeNowClass),a("#"+a(this).attr("id")).find("a").click()}),b.setupComplete=!0,b.focusKeyboard=!0,c._trigger("onInit",0,c);return},loadStructure:function(a,b,c){var d=this.options,e=this,f=d.sourceData;d.parseData&&(b=d.parseData.call("",b));var g=f.find("#"+a.attr("id"));g.append(b),e.tagSource(),a.hasClass(d.activeClass)&&e.createLevel(g.find(">ul")),a.find("span."+d.finderClass+"-loader").remove(),e._trigger("onFolderLoad",c,a)},tagSource:function(){var b=this.options;b.sourceData.find("li,ul").each(function(){this.id||(a(this).attr("id","finder-"+b.uid),b.uid++)}),b.sourceData.find("a").each(function(){var b=a(this);b.attr({tabindex:"-1","aria-level":b.parents("ul").length,role:"treeitem","aria-expanded":"false"})})},createLevel:function(b){var c=this.options,d=this,e=b.find(">li"),f=a("<div class='"+c.finderClass+"-list'><ul></ul></div>").css({"float":"left"}),g,h=c.wrapper.scrollLeft();f=d.createColumn(),f.prepend("<ul></ul>"),e.each(function(){g=a(this).clone(),a(this).hasClass("ajax")||a(this).hasClass("folder")||g.find(">ul").length?g.addClass(c.finderClass+"-folder"):g.addClass(c.finderClass+"-page"),g.find(">ul").remove(),f.find("ul").append(g)}),f.attr("tabindex","-1"),c.container.append(f),d.setContainerWidth(),d.setWidth(),c.wrapper.scrollLeft(h),d.scrollTo(f,function(){}),d._trigger("onFolderDisplay",0,f)},createColumn:function(){var b=this.options,c=a("<div class='"+b.finderClass+"-list'></div>").css({"float":"left"}),d=b.columnHeight,e=b.columnWidth,f=b.columnScroll;return d&&c.height(d),f&&c.css({overflowY:f}),e&&c.width(e),c},setContainerWidth:function(b){var c=this.options,d=this,e=this.element,f=e.find("."+c.finderClass+"-list"),g=0;f.each(function(){g+=a(this).outerWidth()}),c.container.width(g),b&&d.scrollTo(d.findFirstCol(),function(){},1)},move:function(a){var b=this.options,c=this,d,e=c.findFirstCol();d=e.parent().children(":eq("+(a+e.index())+")"),d.length&&c.gotoCol(d,function(){d.find("."+b.activeClass+" a").focus()}),c._trigger("onMove",0,d)},forward:function(){this.move(1)},back:function(){this.move(-1)},findFirstCol:function(){var b=this.options,c=this.element,d=b.wrapper,e=c.find("."+b.finderClass+"-list"),f,g,h=d.offset().left,i=b.columnWidth/2;return e.each(function(b){f=a(this).offset().left,f>=h-i&&f<=h+i&&(g=a(this))}),g},gotoCol:function(b,c){var d=this.options,e;b=="last"&&(b=a("."+d.finderClass+"-list").length-1),typeof b=="number"?e=d.container.children(":eq("+b+")"):e=b,e.length&&this.scrollTo(e,c)},scrollTo:function(b,c,d){var e=this.options,f=this,g=e.wrapper,h;if(a.scrollTo){if(e.scrolling)return;d||(d=e.duration),h=function(){c&&c(),f.updateControls(),e.scrolling=!1},e.scrolling=!0,g.scrollTo(b,d,{axis:"x",easing:e.easing,onAfter:h}),g.trigger("scroll."+e.widgetName)}else alert("Finder: scrollTo plugin is required")},getActive:function(){var a=this.options;return this.element.find("."+a.activeClass+" a")},getVisible:function(){var b=this.options,c=this.element,d=b.wrapper,e=c.find("."+b.finderClass+"-list"),f,g,h=d.position().left,i=d.position().left+c.width();e.each(function(c){f=a(this).position().left,g=f+a(this).width(),h>=f&&h<=g&&(b.firstCol=c),i>f&&g<=i&&(b.lastCol=c)}),b.totalVisible=b.lastCol-b.firstCol+1},setWidth:function(a){var b=this.element,c=this.options,d=b.width(),e=this,f=b.find("."+c.finderClass+"-list");c.numColumns&&(d=parseInt(d,10)/parseInt(f.length>c.numColumns?c.numColumns:f.length,10)),f.width(d),c.columnWidth=d,e.setContainerWidth(a)},updateWidth:function(){this.setWidth(!0)},updateHeight:function(){var a=this.element,b=a.height(),c=this.options,d=a.find("."+c.finderClass+"-list:first").outerHeight()-a.find("."+c.finderClass+"-list:first").height();a.find("."+c.finderClass+"-list").height(a.height()-d),this.options.columnHeight=b},updateControls:function(){var b=this.options,c=this.element,d;this.getVisible(),d=c.find("."+b.finderClass+"-list").length,a(b.prev).add(b.next).removeClass("disabled"),b.firstCol===0&&a(b.prev).addClass("disabled"),(b.lastCol==d-1||d<=1)&&a(b.next).addClass("disabled")},bindKeyboard:function(){var b=this.options,c=this,d=this.element;d.data("bound")||(a(".ui-"+c.widgetName).finder("unbindKeyboard"),d.data("bound",!0),a(document).bind("keydown."+c.widgetName,function(e){var f=a("."+b.focusClass,d),g=a.ui.keyCode,h;f.length||(f=b.wrapper.find("a:first").focus().end());switch(e.keyCode){case g.UP:f.prevAll(":has(a):first").find("a").focus(),e.preventDefault();break;case g.DOWN:f.nextAll(":has(a):first").find("a").focus(),e.preventDefault();break;case g.LEFT:h=f.parents("."+b.finderClass+"-list").prev(),h.find("."+b.activeClass+" a").focus(),h.length&&c.gotoCol(h),e.preventDefault();break;case g.RIGHT:f.hasClass(b.activeClass)?(h=f.parents("."+b.finderClass+"-list").next(),h.find("."+b.activeClass+" a").focus(),h.find("."+b.activeClass+" a").length||h.find("a:first").focus(),h.length&&c.gotoCol(h)):f.find("a").click(),e.preventDefault()}}),a(document).bind("click."+c.widgetName,function(e){var f=e.originalEvent.originalTarget,g=!1;a(f).parents(b.wrapper).each(function(){this==a(b.filter)[0]?g=!0:this==d[0]&&(g=!0)}),!g&&f&&c.unbindKeyboard()}),c._trigger("onbind",0,c))},unbindKeyboard:function(){var b=this,c=this.element;c.data("bound",!1),a(document).unbind("keydown."+b.widgetName),a(document).unbind("click."+b.widgetName),b._trigger("onunbind",0,b)},destroy:function(){var b=this.options,c=this.element;a.Widget.prototype.destroy.apply(this,arguments),c.find("."+b.finderClass+"-list a").die("click.finder"),c.html(b.origContents).removeClass("ui-widget-content ui-widget"),c.find("."+b.finderClass+"-list li").die("mouseover.finder mouseout.finder")}}),a.extend(a.ixf.finder,{version:"1.2.3"})})(jQuery);
/*!
 * masterDetail
 * @description	Facilitates the loading of content from a list/table into a target area. Provides keyboard navigation of the list and caching.
 * @version		  1.2.4  - 2011/04/26
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	  ui.core.js (1.8+), makeVisible
 */
(function(a){a.widget("ixf.masterDetail",{options:{detailLink:"a",focusKeyboard:!0,filter:"",loaderID:"md-loading",loaderText:"Loading",hashLabel:"detail",cacheResults:!1,hashLabel2:"",masterParent:"",masterChild:"",loadFirst:!0,selectedClass:"selected",mergeMode:2,onloaddetail:function(a,b){},nomatch:function(a,b){alert("MasterDetail: Provided ID ("+b+") in the URL is not valid for "+a)},error:function(a,b){b.element.html("<div class='padding-sm'>There was an error with your request. Please try again or let the website administrator know.</div>")}},_create:function(){var b=this.options,c=this,d=this.element,e=b.hashLabel,f,g,h,i,j;b.hasRows=!0,b.hasBBQ=a.bbq,b.clicked=!1;if(!a.fn.makeVisible){alert("MasterDetail Plugin: MakeVisible plugin required for scrolling rows into view");return}if(!a("#"+e).length){alert("MasterDetail Plugin: Detail element doesn't exist. #"+e);return}b.detailTarget=a("#"+e),b.targetDefault=b.detailTarget.html(),b.cacheResults&&(b.cache={});if(d.is(":visible")){d.addClass("ixf-"+c.widgetName);if(d.is("table")){f=d.find("tbody tr"),b.wrapper=d.find("tbody"),b.rowType="tr",d.dataTable&&(b.hasDataTable=!0);if(!b.wrapper.length)return}else d.is("a")?b.hasRows=!1:(f=d.find("li"),b.wrapper=d,b.rowType="li");if(b.hasRows)a(b.rowType,b.wrapper).live("click."+c.widgetName,function(d){var e=a(this);b.clicked=!0,c.triggerRow(e,d,e.attr("ID"))}),a(b.detailLink,b.wrapper).live("click."+c.widgetName,function(c){return c.stopPropagation(),a(this).parents(b.rowType+":first").click(),!1}),d.click(function(){!d.data("bound")&&b.focusKeyboard&&c.bindKeyboard()});else{g=d.attr("id");if(!g){alert("MasterDetail: All items must have a unique ID. Anchor with issue is: "+d.text());return}d.bind("click."+c.widgetName,function(e){return e.stopPropagation(),c.loaderCreate(),b.lastLoad=a.ajax({url:d.attr("href"),success:function(a){c.loadData(a,g,e)},error:function(a,b,d){b!=="abort"&&(c.jqXHR=a,c._trigger("error",e,c),c._loaderDestroy())}}),!1})}h=a.bbq.getState(e),b.hasBBQ&&h&&!a("#"+e).data("clearSelected")?a("#"+h).length?(j=a("#"+h),c.triggerRow(j,!1,j.attr("ID"))):b.nomatch(e,a.bbq.getState(e)):d.find("."+b.selectedClass).length?d.find("."+b.selectedClass).click():b.hasRows&&b.loadFirst&&b.wrapper.find(b.rowType+":first").click(),b.hasBBQ&&a(window).unbind("hashchange."+e).bind("hashchange."+e,function(f){h=f.getState(e),b.lastHashVal!==h&&b.setupComplete&&(h&&b.hasRows?c.triggerRow(a("#"+h),f,h):(c.loadData(b.targetDefault,!1,!1),d.find("."+b.selectedClass).removeClass(b.selectedClass).attr("aria-selected","false"))),b.lastHashVal=f.getState(e)}).trigger("hashchange."+e),b.setupComplete=!0,b.focusKeyboard=!0}c._trigger("oncreate",0,c)},triggerRow:function(b,c,d){var e=this.options,f=this,g=b.attr("id"),h;if(!g){e.nomatch(e.hashLabel,d);return}if(!b.hasClass(e.selectedClass)||!e.setupComplete)b.addClass(e.selectedClass).attr("aria-selected","true").siblings("."+e.selectedClass).removeClass(e.selectedClass).attr("aria-selected","false"),e.lastLoad&&e.lastLoad.abort(),f._move(),f._trigger("onclick",0,f),e.cacheResults&&e.cache["row"+g]?f.loadData(e.cache["row"+g],g,c):(h=b.find(e.detailLink).attr("href"),h.indexOf("#")!==-1?f.loadData(a(h),g,c):(f.loaderCreate(),e.lastLoad=a.ajax({url:b.find(e.detailLink).attr("href"),success:function(a){f.loadData(a,g,c)},error:function(a,b,d){b!=="abort"&&(f.jqXHR=a,f._trigger("error",c,f),f._loaderDestroy())}}))),e.curSelected=b},loadData:function(b,c,d){if(b){var e=this.options,f=this,g=e.detailTarget,h;e.masterChild&&a("#"+e.masterChild).data("clearSelected",!0),f._trigger("onbeforeloaddetail",d,f),e.load?f._trigger("load",d,b):(g.html(b),g.scrollTop(0)),e.cacheResults&&c&&!e.cache["row"+c]&&(e.cache["row"+c]=b),f._trigger("onloaddetail",d,f),e.firstLoad=!0,f.loaderDestroy(),e.hasBBQ&&!e.masterChild&&(h={},e.masterParent&&(g.data("clearSelected")&&g.data("clearSelected",""),h[e.masterParent]=a("#"+e.masterParent).data("loadedID")),h[e.hashLabel]=c,e.clicked&&a.bbq.pushState(h,e.mergeMode),e.clicked=!1),e.hasRows||a("#"+g.data("loadedID")).removeClass(e.selectedClass),g.data("loadedID",c)}},bindKeyboard:function(){var b=this.options,c=this,d=this.element;d.data("bound")||(a(".ixf-"+c.widgetName).masterDetail("unbindKeyboard"),d.data("bound",!0),a(document).bind("keydown."+c.widgetName,function(b){var d=a.ui.keyCode;switch(b.keyCode){case d.UP:c._move("prev",b),b.preventDefault();break;case d.DOWN:c._move("next",b),b.preventDefault()}}),a(document).bind("click."+c.widgetName,function(e){var f=e.target,g=!1;a(f).parents(b.wrapper).each(function(){this===a(b.filter)[0]?g=!0:this===d[0]&&(g=!0)}),!g&&f&&c.unbindKeyboard()}),c._trigger("onbind",0,c))},unbindKeyboard:function(){var b=this,c=this.element;c.data("bound",!1),a(document).unbind("keydown."+b.widgetName),a(document).unbind("click."+b.widgetName),b._trigger("onunbind",0,b)},_move:function(b,c){var d=this.options,e=this,f=this.element,g=this.getSelectedRow(),h;g.length&&b?b==="prev"?g.prev().click():b==="next"&&(g.next().length?g.next().click():a(d.more).length&&(a(d.more).click(),g.next().click())):g.length||d.wrapper.find(d.rowType+":first").click(),h=f.find("thead").height()?f.find("thead").height():0,f.find(d.rowType+"."+d.selectedClass).makeVisible({speed:100,padTop:h,includePad:!0}),c&&c.preventDefault(),e._trigger("onmove",c,e)},getSelectedRow:function(){var b=this.options;return a(b.rowType+"."+b.selectedClass+":visible",b.wrapper)},getSelectedRowID:function(){var b=this.options;return a(b.rowType,b.wrapper).index(this.getSelectedRow())},clearCache:function(a){a?delete this.options.cache["row"+a]:this.options.cache={}},loaderCreate:function(){var b=this.options,c=b.detailTarget;this.loaderDestroy(),b.loader=a('<div id="'+b.loaderID+'" class="panel-loading"><p>'+b.loaderText+"</p><span></span></div>"),a("body").append(b.loader);var d=c.offset(),e=d.left+c.width()/2;b.loader.css({left:e}).show()},loaderDestroy:function(){var b=this.options;b.loader&&b.loader.fadeOut(function(){a(this).remove()})},destroy:function(){a.Widget.prototype.destroy.apply(this,arguments)},rowCreate:function(b,c,d){var e=this.options,f=this.element.dataTable(),g,h;e.rowType==="tr"&&(g=f.fnAddData(c),h=a(f.fnGetNodes(g)),h.attr("id",b)),d||h.click()},rowDestroy:function(b,c){var d=this.options,e=this.element.dataTable(),f;d.rowType==="tr"&&a("#"+b).length&&(f=e.fnDeleteRow(a("#"+b)[0])),c&&a("#"+c).click()}}),a.extend(a.ixf.masterDetail,{version:"1.2.4"})})(jQuery);
/*!
 * timePicker
 * @description	A time picker for jQuery UI. Parts taken from timePicker by Sam Collet (http://www.texotela.co.uk/code/jquery/timepicker/)
 * @version		  1.5  - 2010/10/25
 * @copyright   Intellectual Reserve, Inc.
 * @URL         http://irinc.github.com/ixf
 * @requires	  ui.core.js (1.8+)
 * @optional	  scrollTo plugin
 */
(function(a){a.widget("ixf.timePicker",{options:{step:30,height:200,widthPadding:15,separator:":",parseSeparators:"[:;.,]",am:"AM",pm:"PM",parseAm:"(a|A)",duration:60,autoSelect:!0,enforceRange:!0,useMakeVisible:!0,showDuration:!0,makeVisibleOptions:{pad:10,speed:100},uiCorners:"ui-corner-bottom",listId:"timepicker-list"},_create:function(){var b=this.options,c=this,d=this.element;d.data("manualTime",!1).data("canClose",!0).bind("focus.timepicker",function(){c.showList()}).bind("blur.timepicker",function(){d.data("manualTime")&&(d.data("manualTime",!1).data("canClose",!0),c.fixTime(),c.setTimeVal(this.value),b.onPick&&!b.isSecondField&&b.onPick.apply(c),b.onPickSecond&&b.isSecondField&&b.onPickSecond.apply(c)),c.hideList()}).attr("autocomplete","OFF").bind("keypress.timepicker",function(d){var e=a("#"+b.listId),f,g,h=e.find("li.ui-state-hover");switch(d.keyCode){case 38:case 63232:return f=h.prev().addClass("ui-state-hover")[0],h.length||(f=e.find("li:last").addClass("ui-state-hover")[0]),f&&(h.removeClass("ui-state-hover"),e[0].scrollTop=f.offsetTop),c.element.data("manualTime",!1),!1;case 40:case 63233:return g=h.next().addClass("ui-state-hover")[0],h.length||(g=e.find("li:first").addClass("ui-state-hover")[0]),g&&(h.removeClass("selected ui-state-hover"),e[0].scrollTop=g.offsetTop),c.element.data("manualTime",!1),!1;case 13:if(!e.is(":hidden")&&!c.element.data("manualTime"))return a("li.ui-state-hover",e).trigger("selectIt"),!1;c.element.data("manualTime",!1).data("canClose",!0),c.fixTime(),c.hideList(e);break;case 9:!e.is(":hidden")&&!c.element.data("manualTime")&&c.hideList(e);break;default:c.element.data("manualTime",!0)}}),b.isSecondField||(b.origStartTime=b.startTime,b.origEndTime=b.endTime),typeof b.startTime!="object"&&(b.startTime=this.normaliseTime(this.timeStringToDate(b.startTime))),typeof b.endTime!="object"&&(b.endTime=this.normaliseTime(this.timeStringToDate(b.endTime))),b.startTime||(b.startTime=new Date,b.startTime.setHours(0),b.startTime.setMinutes(0),b.startTime.setSeconds(0)),b.endTime||(b.endTime=new Date,b.endTime.setHours(23),b.endTime.setMinutes(59),b.endTime.setSeconds(59)),b.timeSpan=b.endTime-b.startTime;if(b.secondField){var e=a.extend({},a.ixf.timePicker.defaults,b);e.secondField=!1,e.isSecondField=!0,e.firstField=d,a(b.secondField).timePicker(e),this.setDuration()}},destroy:function(){var b=this.options;this.element.removeClass("ui-accordion ui-widget ui-helper-reset").removeAttr("role").unbind(".timepicker"),a("#"+b.listId).remove(),b.secondField&&a(b.secondField).timePicker("destroy"),a.Widget.prototype.destroy.apply(this,arguments)},hideList:function(){this.element.data("canClose")&&(a("#"+this.options.listId).remove(),a("body").unbind("keydown.timepicker"),this.theList.unbind(".timepicker"))},setTimeVal:function(b){var c=this.options,d=this.element,e,f,g,h;d.val(b).change();if(c.secondField&&b){e=c.duration,a(c.secondField).data("duration")&&(e=a(c.secondField).data("duration"));if(c.show24Hours){f=new RegExp(c.parseSeparators);var i=b.split(f);i[0]<12&&(b+=c.am)}g=this.timeStringToDate(b).getTime()+e*60*1e3,h=new Date(g),g=this.formatTime(h),(h.getTime()>c.endTime.getTime()||h.getTime()<this.timeStringToDate(b,c).getTime())&&c.origEndTime&&(g=this.theList.find("li:last").find("span").text()),!c.firstField&&a(c.secondField).data("duration")!="unknown"?a(c.secondField).val(g):this.setDuration(),c.onAutoAdjust&&c.secondField&&c.onAutoAdjust(c.secondField)}c.isSecondField&&c.firstField.val()?this.setDuration():c.isSecondField&&!c.firstField.val()&&d.data("duration","unknown")},showList:function(){var b=this.options,c=this,d=this.element,e,f,g,h;a("#"+b.listId).length&&c.hideList();var i=a("#"+b.listId);i=a('<ul role="listbox" aria-activedescendant="ui-active-menuitem" id="'+b.listId+'" class="ui-timePicker ui-menu ui-widget ui-widget-content '+b.uiCorners+'"></ul>').css({position:"absolute",top:"0px",left:"0px"}).hide().appendTo("body"),this.theList=i,e=b.startTime,f=b.endTime,b.isSecondField&&b.firstField.val()&&(e=this.normaliseTime(this.timeStringToDate(b.firstField.val()))),b.isSecondField&&!b.origEndTime&&(f=new Date(e),f.setMilliseconds(b.timeSpan)),f.setSeconds(1);var j=new Date(e);b.times=[];while(j<=f)b.times.push(this.formatTime(j)),j=new Date(j.setMinutes(j.getMinutes()+b.step));var k=this.theList.find("li").remove().end();b.isSecondField||(b.numSteps=b.times.length);for(var l=0;l<b.times.length;l++){var m="";b.isSecondField&&b.firstField.val()&&b.showDuration&&(g=Math.round(l*b.step/60*100)/100,m=" ("+g+" hrs)"),h=a("<li class='ui-menu-item' role='menuitem'><a><span>"+b.times[l]+"</span>"+m+"</a>"+"</li>").bind("selectIt.timePicker",function(){c.element.data("canClose",!0),c.setTimeVal(a(this).find("span").text()),b.onPick&&!b.isSecondField&&b.onPick.apply(c),b.onPickSecond&&b.isSecondField&&b.onPickSecond.apply(c),c.hideList()}).bind("click.timepicker",function(){a(this).trigger("selectIt")}).bind("mouseover.timepicker",function(){a(this).addClass("ui-state-hover").siblings().removeClass("ui-state-hover")}),a(k).append(h)}var n=this.element.offset();this.theList.css({top:n.top+this.element[0].offsetHeight,left:n.left}).show();var o=this.theList.width()+b.widthPadding;d.width()>o&&(o=d.width()),this.theList.css({height:b.height,overflow:"auto",width:o}),a.fn.makeVisible&&b.useMakeVisible&&this.theList.makeVisible(b.makeVisibleOptions),this.matchTime(),a("body").bind("keydown.timepicker",function(a){a.keyCode==27&&c.hideList()}),this.theList.bind("mouseover.timepicker",function(){c.element.data("canClose",!1).data("manualTime",!1)}).bind("mouseout.timepicker",function(){c.element.data("canClose",!0)})},fixTime:function(){var a=this.options,b=this,c=this.element,d,e,f;c.val()&&(d=this.timeStringToDate(c.val()),d&&(d<a.startTime||d>a.endTime)&&a.enforceRange?(e=this.formatTime(a.startTime),f=this.formatTime(a.endTime),a.onOutOfRange&&a.onOutOfRange(c.val(),e,f,a),setTimeout(function(){b.element.val("").focus()},50)):b.element.val(this.formatTime(d)))},formatNumber:function(a){return(a<10?"0":"")+a},formatTime:function(a){a=this.normaliseTime(a);var b=this.options,c=a.getHours(),d=b.show24Hours?c:(c+11)%12+1,e=a.getMinutes();return this.formatNumber(d)+b.separator+this.formatNumber(e)+(b.show24Hours?"":c<12?" "+b.am:" "+b.pm)},matchTime:function(){var b=this.options,c=this.theList,d=this.element,e;d.val()&&(e=a(c).find("span:contains("+d.val()+")"),e.length&&(e.parentsUntil("li").addClass("ui-state-hover ui-state-active"),a(c)[0].scrollTop=e.parentsUntil("li")[0].offsetTop),!b.autoSelect&&!d.val()&&a(c).find("li").removeClass("ui-state-hover ui-state-active"))},normaliseTime:function(a){return a},setDuration:function(){var b=this.options,c=b.isSecondField?b.firstField:this.element,d=b.isSecondField?this.element:a(b.secondField),e,f,g;d.val()&&(e=this.timeStringToDate(c.val()).getTime(),f=this.timeStringToDate(d.val()).getTime(),g=(f-e)/6e4,a(d).data("duration",g))},timeStringToDate:function(a){var b=this.options,c,d,e,f,g;return a?(c=new RegExp(b.parseSeparators),d=a.split(c),d.length===1&&(d=a.match(/\d+/),d[1]="00"),e=parseFloat(d[0]),e==12&&(e=0),f=new RegExp(b.parseAm),!a.match(f)&&e<13&&!b.show24Hours&&(e+=12),g=parseFloat(d[1]),a=new Date,a.setHours(e),a.setMinutes(g),a.setSeconds(0),this.normaliseTime(a)):null}}),a.extend(a.ixf.timePicker,{version:"1.5"})})(jQuery),function(a){function c(a){return typeof a=="object"?a:{top:a,left:a}}var b=a.scrollTo=function(b,c,d){a(window).scrollTo(b,c,d)};b.defaults={axis:"xy",duration:parseFloat(a.fn.jquery)>=1.3?0:1},b.window=function(b){return a(window)._scrollable()},a.fn._scrollable=function(){return this.map(function(){var b=this,c=!b.nodeName||a.inArray(b.nodeName.toLowerCase(),["iframe","#document","html","body"])!=-1;if(!c)return b;var d=(b.contentWindow||b).document||b.ownerDocument||b;return a.browser.safari||d.compatMode=="BackCompat"?d.body:d.documentElement})},a.fn.scrollTo=function(d,e,f){return typeof e=="object"&&(f=e,e=0),typeof f=="function"&&(f={onAfter:f}),d=="max"&&(d=9e9),f=a.extend({},b.defaults,f),e=e||f.speed||f.duration,f.queue=f.queue&&f.axis.length>1,f.queue&&(e/=2),f.offset=c(f.offset),f.over=c(f.over),this._scrollable().each(function(){function m(a){h.animate(k,e,f.easing,a&&function(){a.call(this,d,f)})}var g=this,h=a(g),i=d,j,k={},l=h.is("html,body");switch(typeof i){case"number":case"string":if(/^([+-]=)?\d+(\.\d+)?(px|%)?$/.test(i)){i=c(i);break}i=a(i,this);case"object":if(i.is||i.style)j=(i=a(i)).offset()}a.each(f.axis.split(""),function(a,c){var d=c=="x"?"Left":"Top",e=d.toLowerCase(),n="scroll"+d,o=g[n],p=b.max(g,c);if(j)k[n]=j[e]+(l?0:o-h.offset()[e]),f.margin&&(k[n]-=parseInt(i.css("margin"+d))||0,k[n]-=parseInt(i.css("border"+d+"Width"))||0),k[n]+=f.offset[e]||0,f.over[e]&&(k[n]+=i[c=="x"?"width":"height"]()*f.over[e]);else{var q=i[e];k[n]=q.slice&&q.slice(-1)=="%"?parseFloat(q)/100*p:q}/^\d+$/.test(k[n])&&(k[n]=k[n]<=0?0:Math.min(k[n],p)),!a&&f.queue&&(o!=k[n]&&m(f.onAfterFirst),delete k[n])}),m(f.onAfter)}).end()},b.max=function(b,c){var d=c=="x"?"Width":"Height",e="scroll"+d;if(!a(b).is("html,body"))return b[e]-a(b)[d.toLowerCase()]();var f="client"+d,g=b.ownerDocument.documentElement,h=b.ownerDocument.body;return Math.max(g[e],h[e])-Math.min(g[f],h[f])}}(jQuery);
/*!
 * jScrollTouch plugin 1.0 - http://www.dealinium.com/common/jScrollTouch
 *
 * Copyright (c) 2010 Damien Rottemberg
 *
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 *
 * Updated by Aaron Barker to newer jQuery stuff
 */
(function(a){a.fn.jTouchScroll=function(){var b;if(navigator.userAgent.match(/iPhone/i)||navigator.userAgent.match(/iPod/i)||navigator.userAgent.match(/iPad/i))b=1;else{b=0;return}return a(this).css({overflow:"auto"}),this.each(function(){var c=a(this),d=0,e=c.scrollTop();c.scrollTop(1e5),d=c.scrollTop(),c.scrollTop(e),c.bind("mousedown touchstart",function(a){e=c.scrollTop(),b&&(a=a.originalEvent.touches[0]);var d=a.pageY;c.bind("mousemove touchmove",function(a){b&&(a.preventDefault(),a=a.originalEvent.touches[0]);var f=e-(a.pageY-d);c.scrollTop(f),e=c.scrollTop(),d=a.pageY}),c.bind("mouseup touchend",function(a){c.unbind("mousemove touchmove mouseup touchend")})})})}})(jQuery);
/*!
 * jQuery.ScrollTo - Easy element scrolling using jQuery.
 * Copyright (c) 2007-2009 Ariel Flesler - aflesler(at)gmail(dot)com | http://flesler.blogspot.com
 * Dual licensed under MIT and GPL.
 * Date: 5/25/2009
 * @author Ariel Flesler
 * @version 1.4.2
 *
 * http://flesler.blogspot.com/2007/10/jqueryscrollto.html
 */
(function(a){function c(a){return typeof a=="object"?a:{top:a,left:a}}var b=a.scrollTo=function(b,c,d){a(window).scrollTo(b,c,d)};b.defaults={axis:"xy",duration:parseFloat(a.fn.jquery)>=1.3?0:1},b.window=function(b){return a(window)._scrollable()},a.fn._scrollable=function(){return this.map(function(){var b=this,c=!b.nodeName||a.inArray(b.nodeName.toLowerCase(),["iframe","#document","html","body"])!=-1;if(!c)return b;var d=(b.contentWindow||b).document||b.ownerDocument||b;return a.browser.safari||d.compatMode=="BackCompat"?d.body:d.documentElement})},a.fn.scrollTo=function(d,e,f){return typeof e=="object"&&(f=e,e=0),typeof f=="function"&&(f={onAfter:f}),d=="max"&&(d=9e9),f=a.extend({},b.defaults,f),e=e||f.speed||f.duration,f.queue=f.queue&&f.axis.length>1,f.queue&&(e/=2),f.offset=c(f.offset),f.over=c(f.over),this._scrollable().each(function(){function m(a){h.animate(k,e,f.easing,a&&function(){a.call(this,d,f)})}var g=this,h=a(g),i=d,j,k={},l=h.is("html,body");switch(typeof i){case"number":case"string":if(/^([+-]=)?\d+(\.\d+)?(px|%)?$/.test(i)){i=c(i);break}i=a(i,this);case"object":if(i.is||i.style)j=(i=a(i)).offset()}a.each(f.axis.split(""),function(a,c){var d=c=="x"?"Left":"Top",e=d.toLowerCase(),n="scroll"+d,o=g[n],p=b.max(g,c);if(j)k[n]=j[e]+(l?0:o-h.offset()[e]),f.margin&&(k[n]-=parseInt(i.css("margin"+d))||0,k[n]-=parseInt(i.css("border"+d+"Width"))||0),k[n]+=f.offset[e]||0,f.over[e]&&(k[n]+=i[c=="x"?"width":"height"]()*f.over[e]);else{var q=i[e];k[n]=q.slice&&q.slice(-1)=="%"?parseFloat(q)/100*p:q}/^\d+$/.test(k[n])&&(k[n]=k[n]<=0?0:Math.min(k[n],p)),!a&&f.queue&&(o!=k[n]&&m(f.onAfterFirst),delete k[n])}),m(f.onAfter)}).end()},b.max=function(b,c){var d=c=="x"?"Width":"Height",e="scroll"+d;if(!a(b).is("html,body"))return b[e]-a(b)[d.toLowerCase()]();var f="client"+d,g=b.ownerDocument.documentElement,h=b.ownerDocument.body;return Math.max(g[e],h[e])-Math.min(g[f],h[f])}})(jQuery);
/*!
 * jQuery BBQ: Back Button & Query Library - v1.2.1 - 2/17/2010
 * http://benalman.com/projects/jquery-bbq-plugin/
 * 
 * Copyright (c) 2010 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
(function(a,b){function z(a){return typeof a=="string"}function A(a){var b=d.call(arguments,1);return function(){return a.apply(this,b.concat(d.call(arguments)))}}function B(a){return a.replace(/^[^#]*#?(.*)$/,"$1")}function C(a){return a.replace(/(?:^[^?#]*\?([^#]*).*$)?.*/,"$1")}function D(d,g,i,j,k){var l,m,n,o,r;return j!==c?(n=i.match(d?/^([^#]*)\#?(.*)$/:/^([^#?]*)\??([^#]*)(#?.*)/),r=n[3]||"",k===2&&z(j)?m=j.replace(d?w:v,""):(o=h(n[2]),j=z(j)?h[d?q:p](j):j,m=k===2?j:k===1?a.extend({},j,o):a.extend({},o,j),m=f(m),d&&(m=m.replace(x,e))),l=n[1]+(d?"#":m||!n[1]?"?":"")+m+r):l=g(i!==c?i:b[s][t]),l}function E(a,b,d){return b===c||typeof b=="boolean"?(d=b,b=f[a?q:p]()):b=z(b)?b.replace(a?w:v,""):b,h(b,d)}function F(b,d,e,g){return!z(e)&&typeof e!="object"&&(g=e,e=d,d=c),this.each(function(){var c=a(this),h=d||m()[(this.nodeName||"").toLowerCase()]||"",i=h&&c.attr(h)||"";c.attr(h,f[b](i,e,g))})}"$:nomunge";var c,d=Array.prototype.slice,e=decodeURIComponent,f=a.param,g,h,i,j=a.bbq=a.bbq||{},k,l,m,n=a.event.special,o="hashchange",p="querystring",q="fragment",r="elemUrlAttr",s="location",t="href",u="src",v=/^.*\?|#.*$/g,w=/^.*\#/,x,y={};f[p]=A(D,0,C),f[q]=g=A(D,1,B),g.noEscape=function(b){b=b||"";var c=a.map(b.split(""),encodeURIComponent);x=new RegExp(c.join("|"),"g")},g.noEscape(",/"),a.deparam=h=function(b,d){var f={},g={"true":!0,"false":!1,"null":null};return a.each(b.replace(/\+/g," ").split("&"),function(b,h){var i=h.split("="),j=e(i[0]),k,l=f,m=0,n=j.split("]["),o=n.length-1;/\[/.test(n[0])&&/\]$/.test(n[o])?(n[o]=n[o].replace(/\]$/,""),n=n.shift().split("[").concat(n),o=n.length-1):o=0;if(i.length===2){k=e(i[1]),d&&(k=k&&!isNaN(k)?+k:k==="undefined"?c:g[k]!==c?g[k]:k);if(o)for(;m<=o;m++)j=n[m]===""?l.length:n[m],l=l[j]=m<o?l[j]||(n[m+1]&&isNaN(n[m+1])?{}:[]):k;else a.isArray(f[j])?f[j].push(k):f[j]!==c?f[j]=[f[j],k]:f[j]=k}else j&&(f[j]=d?c:"")}),f},h[p]=A(E,0),h[q]=i=A(E,1),a[r]||(a[r]=function(b){return a.extend(y,b)})({a:t,base:t,iframe:u,img:u,input:u,form:"action",link:t,script:u}),m=a[r],a.fn[p]=A(F,p),a.fn[q]=A(F,q),j.pushState=k=function(a,d){z(a)&&/^#/.test(a)&&d===c&&(d=2);var e=a!==c,f=g(b[s][t],e?a:{},e?d:2);b[s][t]=f+(/#/.test(f)?"":"#")},j.getState=l=function(a,b){return a===c||typeof a=="boolean"?i(a):i(b)[a]},j.removeState=function(b){var d={};b!==c&&(d=l(),a.each(a.isArray(b)?b:arguments,function(a,b){delete d[b]})),k(d,2)},n[o]=a.extend(n[o],{add:function(b){function e(a){var b=a[q]=g();a.getState=function(a,d){return a===c||typeof a=="boolean"?h(b,a):h(b,d)[a]},d.apply(this,arguments)}var d;if(a.isFunction(b))return d=b,e;d=b.handler,b.handler=e}})})(jQuery,this);
/*!
	 * jQuery hashchange event - v1.2 - 2/11/2010
	 * http://benalman.com/projects/jquery-hashchange-plugin/
	 * 
	 * Copyright (c) 2010 "Cowboy" Ben Alman
	 * Dual licensed under the MIT and GPL licenses.
	 * http://benalman.com/about/license/
	 */
(function(a,b,c){function m(a){return a=a||b[f][h],a.replace(/^[^#]*#?(.*)$/,"$1")}"$:nomunge";var d,e=a.event.special,f="location",g="hashchange",h="href",i=a.browser,j=document.documentMode,k=i.msie&&(j===c||j<8),l="on"+g in b&&!k;a[g+"Delay"]=100,e[g]=a.extend(e[g],{setup:function(){if(l)return!1;a(d.start)},teardown:function(){if(l)return!1;a(d.stop)}}),d=function(){function l(){i=j=function(a){return a},k&&(e=a('<iframe src="javascript:0"/>').hide().insertAfter("body")[0].contentWindow,j=function(){return m(e.document[f][h])},i=function(a,b){if(a!==b){var c=e.document;c.open().close(),c[f].hash="#"+a}},i(m()))}var c={},d,e,i,j;return c.start=function(){if(d)return;var c=m();i||l(),function e(){var k=m(),l=j(c);k!==c?(i(c=k,l),a(b).trigger(g)):l!==c&&(b[f][h]=b[f][h].replace(/#.*/,"")+"#"+l),d=setTimeout(e,a[g+"Delay"])}()},c.stop=function(){e||(d&&clearTimeout(d),d=0)},c}()})(jQuery,this),function(a,b,c){function j(a){return a=a||location.href,"#"+a.replace(/^[^#]*#?(.*)$/,"$1")}"$:nomunge";var d="hashchange",e=document,f,g=a.event.special,h=e.documentMode,i="on"+d in b&&(h===c||h>7);a.fn[d]=function(a){return a?this.bind(d,a):this.trigger(d)},a.fn[d].delay=50,g[d]=a.extend(g[d],{setup:function(){if(i)return!1;a(f.start)},teardown:function(){if(i)return!1;a(f.stop)}}),f=function(){function n(){var c=j(),e=m(h);c!==h?(l(h=c,e),a(b).trigger(d)):e!==h&&(location.href=location.href.replace(/#.*/,"")+e),g=setTimeout(n,a.fn[d].delay)}var f={},g,h=j(),k=function(a){return a},l=k,m=k;return f.start=function(){g||n()},f.stop=function(){g&&clearTimeout(g),g=c},a.browser.msie&&!i&&function(){var b,c;f.start=function(){b||(c=a.fn[d].src,c=c&&c+j(),b=a('<iframe tabindex="-1" title="empty"/>').hide().one("load",function(){c||l(j()),n()}).attr("src",c||"javascript:0").insertAfter("body")[0].contentWindow,e.onpropertychange=function(){try{event.propertyName==="title"&&(b.document.title=e.title)}catch(a){}})},f.stop=k,m=function(){return j(b.location.href)},l=function(c,f){var g=b.document,h=a.fn[d].domain;c!==f&&(g.title=e.title,g.open(),h&&g.write('<script>document.domain="'+h+'"</script>'),g.close(),b.location.hash=c)}}(),f}()}(jQuery,this);
/*!
 *
 * Copyright (c) 2010 C. F., Wong (<a href="http://cloudgen.w0ng.hk">Cloudgen Examplet Store</a>)
 * Licensed under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 *
 * http://plugins.jquery.com/project/jCaret
 */
(function(a){a.fn.caret=function(a,b){var c=function(a,b,c){if(a.setSelectionRange)a.focus(),a.setSelectionRange(b,c);else if(a.createTextRange){var d=a.createTextRange();d.collapse(!0),d.moveEnd("character",c),d.moveStart("character",b),d.select()}};if(a!=null&&b!=null)return this.each(function(){c(this,a,b)});if(a!=null)return this.each(function(){c(this,a,a)});var d=this[0];if(d.createTextRange){var e=document.selection.createRange().duplicate(),f=d.value.lastIndexOf(e.text)+e.text.length;e.moveEnd("character",d.value.length);var g=e.text==""?d.value.length:d.value.lastIndexOf(e.text);return[g,f]}return[d.selectionStart,d.selectionEnd]}})(jQuery);
/**
 * @summary     DataTables
 * @description Paginate, search and sort HTML tables
 * @version     1.9.0
 * @file        jquery.dataTables.js
 * @author      Allan Jardine (www.sprymedia.co.uk)
 * @contact     www.sprymedia.co.uk/contact
 *
 * @copyright Copyright 2008-2012 Allan Jardine, all rights reserved.
 *
 * This source file is free software, under either the GPL v2 license or a
 * BSD style license, available at:
 *   http://datatables.net/license_gpl2
 *   http://datatables.net/license_bsd
 *
 * This source file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the license files for details.
 *
 * For details please refer to: http://www.datatables.net
 */
(function($,window,document,undefined){var DataTable=function(oInit){function _fnAddColumn(a,b){var c=DataTable.defaults.columns,d=a.aoColumns.length,e=$.extend({},DataTable.models.oColumn,c,{sSortingClass:a.oClasses.sSortable,sSortingClassJUI:a.oClasses.sSortJUI,nTh:b?b:document.createElement("th"),sTitle:c.sTitle?c.sTitle:b?b.innerHTML:"",aDataSort:c.aDataSort?c.aDataSort:[d],mDataProp:c.mDataProp?c.oDefaults:d});a.aoColumns.push(e);if(a.aoPreSearchCols[d]===undefined||a.aoPreSearchCols[d]===null)a.aoPreSearchCols[d]=$.extend({},DataTable.models.oSearch);else{var f=a.aoPreSearchCols[d];f.bRegex===undefined&&(f.bRegex=!0),f.bSmart===undefined&&(f.bSmart=!0),f.bCaseInsensitive===undefined&&(f.bCaseInsensitive=!0)}_fnColumnOptions(a,d,null)}function _fnColumnOptions(a,b,c){var d=a.aoColumns[b];c!==undefined&&c!==null&&(c.sType!==undefined&&(d.sType=c.sType,d._bAutoType=!1),$.extend(d,c),_fnMap(d,c,"sWidth","sWidthOrig"),c.iDataSort!==undefined&&(d.aDataSort=[c.iDataSort]),_fnMap(d,c,"aDataSort")),d.fnGetData=_fnGetObjectDataFn(d.mDataProp),d.fnSetData=_fnSetObjectDataFn(d.mDataProp),a.oFeatures.bSort||(d.bSortable=!1),!d.bSortable||$.inArray("asc",d.asSorting)==-1&&$.inArray("desc",d.asSorting)==-1?(d.sSortingClass=a.oClasses.sSortableNone,d.sSortingClassJUI=""):d.bSortable||$.inArray("asc",d.asSorting)==-1&&$.inArray("desc",d.asSorting)==-1?(d.sSortingClass=a.oClasses.sSortable,d.sSortingClassJUI=a.oClasses.sSortJUI):$.inArray("asc",d.asSorting)!=-1&&$.inArray("desc",d.asSorting)==-1?(d.sSortingClass=a.oClasses.sSortableAsc,d.sSortingClassJUI=a.oClasses.sSortJUIAscAllowed):$.inArray("asc",d.asSorting)==-1&&$.inArray("desc",d.asSorting)!=-1&&(d.sSortingClass=a.oClasses.sSortableDesc,d.sSortingClassJUI=a.oClasses.sSortJUIDescAllowed)}function _fnAdjustColumnSizing(a){if(a.oFeatures.bAutoWidth===!1)return!1;_fnCalculateColumnWidths(a);for(var b=0,c=a.aoColumns.length;b<c;b++)a.aoColumns[b].nTh.style.width=a.aoColumns[b].sWidth}function _fnVisibleToColumnIndex(a,b){var c=-1;for(var d=0;d<a.aoColumns.length;d++){a.aoColumns[d].bVisible===!0&&c++;if(c==b)return d}return null}function _fnColumnIndexToVisible(a,b){var c=-1;for(var d=0;d<a.aoColumns.length;d++){a.aoColumns[d].bVisible===!0&&c++;if(d==b)return a.aoColumns[d].bVisible===!0?c:null}return null}function _fnVisbleColumns(a){var b=0;for(var c=0;c<a.aoColumns.length;c++)a.aoColumns[c].bVisible===!0&&b++;return b}function _fnDetectType(a){var b=DataTable.ext.aTypes,c=b.length;for(var d=0;d<c;d++){var e=b[d](a);if(e!==null)return e}return"string"}function _fnReOrderIndex(a,b){var c=b.split(","),d=[];for(var e=0,f=a.aoColumns.length;e<f;e++)for(var g=0;g<f;g++)if(a.aoColumns[e].sName==c[g]){d.push(g);break}return d}function _fnColumnOrdering(a){var b="";for(var c=0,d=a.aoColumns.length;c<d;c++)b+=a.aoColumns[c].sName+",";return b.length==d?"":b.slice(0,-1)}function _fnApplyColumnDefs(a,b,c,d){var e,f,g,h,i,j;if(b)for(e=b.length-1;e>=0;e--){var k=b[e].aTargets;$.isArray(k)||_fnLog(a,1,"aTargets must be an array of targets, not a "+typeof k);for(g=0,h=k.length;g<h;g++)if(typeof k[g]=="number"&&k[g]>=0){while(a.aoColumns.length<=k[g])_fnAddColumn(a);d(k[g],b[e])}else if(typeof k[g]=="number"&&k[g]<0)d(a.aoColumns.length+k[g],b[e]);else if(typeof k[g]=="string")for(i=0,j=a.aoColumns.length;i<j;i++)(k[g]=="_all"||$(a.aoColumns[i].nTh).hasClass(k[g]))&&d(i,b[e])}if(c)for(e=0,f=c.length;e<f;e++)d(e,c[e])}function _fnAddData(a,b){var c,d=$.isArray(b)?b.slice():$.extend(!0,{},b),e=a.aoData.length,f=$.extend(!0,{},DataTable.models.oRow,{_aData:d});a.aoData.push(f);var g,h;for(var i=0,j=a.aoColumns.length;i<j;i++){c=a.aoColumns[i],typeof c.fnRender=="function"&&c.bUseRendered&&c.mDataProp!==null&&_fnSetCellData(a,e,i,_fnRender(a,e,i));if(c._bAutoType&&c.sType!="string"){var k=_fnGetCellData(a,e,i,"type");k!==null&&k!==""&&(h=_fnDetectType(k),c.sType===null?c.sType=h:c.sType!=h&&c.sType!="html"&&(c.sType="string"))}}return a.aiDisplayMaster.push(e),a.oFeatures.bDeferRender||_fnCreateTr(a,e),e}function _fnGatherData(a){var b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s;if(a.bDeferLoading||a.sAjaxSource===null){i=a.nTBody.childNodes;for(c=0,d=i.length;c<d;c++)if(i[c].nodeName.toUpperCase()=="TR"){l=a.aoData.length,i[c]._DT_RowIndex=l,a.aoData.push($.extend(!0,{},DataTable.models.oRow,{nTr:i[c]})),a.aiDisplayMaster.push(l),h=i[c].childNodes,g=0;for(e=0,f=h.length;e<f;e++){q=h[e].nodeName.toUpperCase();if(q=="TD"||q=="TH")_fnSetCellData(a,l,g,$.trim(h[e].innerHTML)),g++}}}i=_fnGetTrNodes(a),h=[];for(c=0,d=i.length;c<d;c++)for(e=0,f=i[c].childNodes.length;e<f;e++)j=i[c].childNodes[e],q=j.nodeName.toUpperCase(),(q=="TD"||q=="TH")&&h.push(j);for(o=0,p=a.aoColumns.length;o<p;o++){r=a.aoColumns[o],r.sTitle===null&&(r.sTitle=r.nTh.innerHTML);var t=r._bAutoType,u=typeof r.fnRender=="function",v=r.sClass!==null,w=r.bVisible,x,y,z,A;if(t||u||v||!w)for(m=0,n=a.aoData.length;m<n;m++)s=a.aoData[m],x=h[m*p+o],t&&r.sType!="string"&&(A=_fnGetCellData(a,m,o,"type"),A!==""&&(y=_fnDetectType(A),r.sType===null?r.sType=y:r.sType!=y&&r.sType!="html"&&(r.sType="string"))),typeof r.mDataProp=="function"&&(x.innerHTML=_fnGetCellData(a,m,o,"display")),u&&(z=_fnRender(a,m,o),x.innerHTML=z,r.bUseRendered&&_fnSetCellData(a,m,o,z)),v&&(x.className+=" "+r.sClass),w?s._anHidden[o]=null:(s._anHidden[o]=x,x.parentNode.removeChild(x)),r.fnCreatedCell&&r.fnCreatedCell.call(a.oInstance,x,_fnGetCellData(a,m,o,"display"),s._aData,m,o)}if(a.aoRowCreatedCallback.length!==0)for(c=0,d=a.aoData.length;c<d;c++)s=a.aoData[c],_fnCallbackFire(a,"aoRowCreatedCallback",null,[s.nTr,s._aData,c])}function _fnNodeToDataIndex(a,b){return b._DT_RowIndex!==undefined?b._DT_RowIndex:null}function _fnNodeToColumnIndex(a,b,c){var d=_fnGetTdNodes(a,b);for(var e=0,f=a.aoColumns.length;e<f;e++)if(d[e]===c)return e;return-1}function _fnGetRowData(a,b,c){var d=[];for(var e=0,f=a.aoColumns.length;e<f;e++)d.push(_fnGetCellData(a,b,e,c));return d}function _fnGetCellData(a,b,c,d){var e,f=a.aoColumns[c],g=a.aoData[b]._aData;if((e=f.fnGetData(g,d))===undefined)return a.iDrawError!=a.iDraw&&f.sDefaultContent===null&&(_fnLog(a,0,"Requested unknown parameter '"+f.mDataProp+"' from the data source for row "+b),a.iDrawError=a.iDraw),f.sDefaultContent;if(e===null&&f.sDefaultContent!==null)e=f.sDefaultContent;else if(typeof e=="function")return e();return d=="display"&&e===null?"":e}function _fnSetCellData(a,b,c,d){var e=a.aoColumns[c],f=a.aoData[b]._aData;e.fnSetData(f,d)}function _fnGetObjectDataFn(a){if(a===null)return function(a,b){return null};if(typeof a=="function")return function(b,c){return a(b,c)};if(typeof a=="string"&&a.indexOf(".")!=-1){var b=a.split(".");return function(a,c){for(var d=0,e=b.length;d<e;d++){a=a[b[d]];if(a===undefined)return undefined}return a}}return function(b,c){return b[a]}}function _fnSetObjectDataFn(a){if(a===null)return function(a,b){};if(typeof a=="function")return function(b,c){a(b,"set",c)};if(typeof a=="string"&&a.indexOf(".")!=-1){var b=a.split(".");return function(a,c){for(var d=0,e=b.length-1;d<e;d++)a=a[b[d]];a[b[b.length-1]]=c}}return function(b,c){b[a]=c}}function _fnGetDataMaster(a){var b=[],c=a.aoData.length;for(var d=0;d<c;d++)b.push(a.aoData[d]._aData);return b}function _fnClearTable(a){a.aoData.splice(0,a.aoData.length),a.aiDisplayMaster.splice(0,a.aiDisplayMaster.length),a.aiDisplay.splice(0,a.aiDisplay.length),_fnCalculateEnd(a)}function _fnDeleteIndex(a,b){var c=-1;for(var d=0,e=a.length;d<e;d++)a[d]==b?c=d:a[d]>b&&a[d]--;c!=-1&&a.splice(c,1)}function _fnRender(a,b,c){var d=a.aoColumns[c];return d.fnRender({iDataRow:b,iDataColumn:c,oSettings:a,aData:a.aoData[b]._aData,mDataProp:d.mDataProp},_fnGetCellData(a,b,c,"display"))}function _fnCreateTr(a,b){var c=a.aoData[b],d;if(c.nTr===null){c.nTr=document.createElement("tr"),c.nTr._DT_RowIndex=b,c._aData.DT_RowId&&(c.nTr.id=c._aData.DT_RowId),c._aData.DT_RowClass&&$(c.nTr).addClass(c._aData.DT_RowClass);for(var e=0,f=a.aoColumns.length;e<f;e++){var g=a.aoColumns[e];d=document.createElement("td"),d.innerHTML=typeof g.fnRender!="function"||!!g.bUseRendered&&g.mDataProp!==null?_fnGetCellData(a,b,e,"display"):_fnRender(a,b,e),g.sClass!==null&&(d.className=g.sClass),g.bVisible?(c.nTr.appendChild(d),c._anHidden[e]=null):c._anHidden[e]=d,g.fnCreatedCell&&g.fnCreatedCell.call(a.oInstance,d,_fnGetCellData(a,b,e,"display"),c._aData,b,e)}_fnCallbackFire(a,"aoRowCreatedCallback",null,[c.nTr,c._aData,b])}}function _fnBuildHead(a){var b,c,d,e,f,g=a.nTHead.getElementsByTagName("th").length,h=0,i;if(g!==0)for(b=0,d=a.aoColumns.length;b<d;b++)c=a.aoColumns[b].nTh,c.setAttribute("role","columnheader"),a.aoColumns[b].bSortable&&(c.setAttribute("tabindex",a.iTabIndex),c.setAttribute("aria-controls",a.sTableId)),a.aoColumns[b].sClass!==null&&$(c).addClass(a.aoColumns[b].sClass),a.aoColumns[b].sTitle!=c.innerHTML&&(c.innerHTML=a.aoColumns[b].sTitle);else{var j=document.createElement("tr");for(b=0,d=a.aoColumns.length;b<d;b++)c=a.aoColumns[b].nTh,c.innerHTML=a.aoColumns[b].sTitle,c.setAttribute("tabindex","0"),a.aoColumns[b].sClass!==null&&$(c).addClass(a.aoColumns[b].sClass),j.appendChild(c);$(a.nTHead).html("")[0].appendChild(j),_fnDetectHeader(a.aoHeader,a.nTHead)}$(a.nTHead).children("tr").attr("role","row");if(a.bJUI)for(b=0,d=a.aoColumns.length;b<d;b++){c=a.aoColumns[b].nTh;var k=document.createElement("div");k.className=a.oClasses.sSortJUIWrapper,$(c).contents().appendTo(k);var l=document.createElement("span");l.className=a.oClasses.sSortIcon,k.appendChild(l),c.appendChild(k)}if(a.oFeatures.bSort)for(b=0;b<a.aoColumns.length;b++)a.aoColumns[b].bSortable!==!1?_fnSortAttachListener(a,a.aoColumns[b].nTh,b):$(a.aoColumns[b].nTh).addClass(a.oClasses.sSortableNone);a.oClasses.sFooterTH!==""&&$(a.nTFoot).children("tr").children("th").addClass(a.oClasses.sFooterTH);if(a.nTFoot!==null){var m=_fnGetUniqueThs(a,null,a.aoFooter);for(b=0,d=a.aoColumns.length;b<d;b++)m[b]&&(a.aoColumns[b].nTf=m[b],a.aoColumns[b].sClass&&$(m[b]).addClass(a.aoColumns[b].sClass))}}function _fnDrawHead(a,b,c){var d,e,f,g,h,i,j,k,l=[],m=[],n=a.aoColumns.length,o,p;c===undefined&&(c=!1);for(d=0,e=b.length;d<e;d++){l[d]=b[d].slice(),l[d].nTr=b[d].nTr;for(f=n-1;f>=0;f--)!a.aoColumns[f].bVisible&&!c&&l[d].splice(f,1);m.push([])}for(d=0,e=l.length;d<e;d++){k=l[d].nTr;if(k)while(j=k.firstChild)k.removeChild(j);for(f=0,g=l[d].length;f<g;f++){o=1,p=1;if(m[d][f]===undefined){k.appendChild(l[d][f].cell),m[d][f]=1;while(l[d+o]!==undefined&&l[d][f].cell==l[d+o][f].cell)m[d+o][f]=1,o++;while(l[d][f+p]!==undefined&&l[d][f].cell==l[d][f+p].cell){for(h=0;h<o;h++)m[d+h][f+p]=1;p++}l[d][f].cell.rowSpan=o,l[d][f].cell.colSpan=p}}}}function _fnDraw(a){var b,c,d,e=[],f=0,g=a.asStripeClasses.length,h=a.aoOpenRows.length,i=_fnCallbackFire(a,"aoPreDrawCallback","preDraw",[a]);if($.inArray(!1,i)!==-1)return;a.bDrawing=!0,a.iInitDisplayStart!==undefined&&a.iInitDisplayStart!=-1&&(a.oFeatures.bServerSide?a._iDisplayStart=a.iInitDisplayStart:a._iDisplayStart=a.iInitDisplayStart>=a.fnRecordsDisplay()?0:a.iInitDisplayStart,a.iInitDisplayStart=-1,_fnCalculateEnd(a));if(a.bDeferLoading)a.bDeferLoading=!1,a.iDraw++;else if(!a.oFeatures.bServerSide)a.iDraw++;else if(!a.bDestroying&&!_fnAjaxUpdate(a))return;if(a.aiDisplay.length!==0){var j=a._iDisplayStart,k=a._iDisplayEnd;a.oFeatures.bServerSide&&(j=0,k=a.aoData.length);for(var l=j;l<k;l++){var m=a.aoData[a.aiDisplay[l]];m.nTr===null&&_fnCreateTr(a,a.aiDisplay[l]);var n=m.nTr;if(g!==0){var o=a.asStripeClasses[f%g];m._sRowStripe!=o&&($(n).removeClass(m._sRowStripe).addClass(o),m._sRowStripe=o)}_fnCallbackFire(a,"aoRowCallback",null,[n,a.aoData[a.aiDisplay[l]]._aData,f,l]),e.push(n),f++;if(h!==0)for(var p=0;p<h;p++)if(n==a.aoOpenRows[p].nParent){e.push(a.aoOpenRows[p].nTr);break}}}else{e[0]=document.createElement("tr"),a.asStripeClasses[0]&&(e[0].className=a.asStripeClasses[0]);var q=a.oLanguage.sZeroRecords.replace("_MAX_",a.fnFormatNumber(a.fnRecordsTotal()));a.iDraw==1&&a.sAjaxSource!==null&&!a.oFeatures.bServerSide?q=a.oLanguage.sLoadingRecords:a.oLanguage.sEmptyTable&&a.fnRecordsTotal()===0&&(q=a.oLanguage.sEmptyTable);var r=document.createElement("td");r.setAttribute("valign","top"),r.colSpan=_fnVisbleColumns(a),r.className=a.oClasses.sRowEmpty,r.innerHTML=q,e[f].appendChild(r)}_fnCallbackFire(a,"aoHeaderCallback","header",[$(a.nTHead).children("tr")[0],_fnGetDataMaster(a),a._iDisplayStart,a.fnDisplayEnd(),a.aiDisplay]),_fnCallbackFire(a,"aoFooterCallback","footer",[$(a.nTFoot).children("tr")[0],_fnGetDataMaster(a),a._iDisplayStart,a.fnDisplayEnd(),a.aiDisplay]);var s=document.createDocumentFragment(),t=document.createDocumentFragment(),u,v;if(a.nTBody){u=a.nTBody.parentNode,t.appendChild(a.nTBody);if(!a.oScroll.bInfinite||!a._bInitComplete||a.bSorted||a.bFiltered)while(d=a.nTBody.firstChild)a.nTBody.removeChild(d);for(b=0,c=e.length;b<c;b++)s.appendChild(e[b]);a.nTBody.appendChild(s),u!==null&&u.appendChild(a.nTBody)}_fnCallbackFire(a,"aoDrawCallback","draw",[a]),a.bSorted=!1,a.bFiltered=!1,a.bDrawing=!1,a.oFeatures.bServerSide&&(_fnProcessingDisplay(a,!1),a._bInitComplete||_fnInitComplete(a))}function _fnReDraw(a){a.oFeatures.bSort?_fnSort(a,a.oPreviousSearch):a.oFeatures.bFilter?_fnFilterComplete(a,a.oPreviousSearch):(_fnCalculateEnd(a),_fnDraw(a))}function _fnAddOptionsHtml(a){var b=$("<div></div>")[0];a.nTable.parentNode.insertBefore(b,a.nTable),a.nTableWrapper=$('<div id="'+a.sTableId+'_wrapper" class="'+a.oClasses.sWrapper+'" role="grid"></div>')[0],a.nTableReinsertBefore=a.nTable.nextSibling;var c=a.nTableWrapper,d=a.sDom.split(""),e,f,g,h,i,j,k;for(var l=0;l<d.length;l++){f=0,g=d[l];if(g=="<"){h=$("<div></div>")[0],i=d[l+1];if(i=="'"||i=='"'){j="",k=2;while(d[l+k]!=i)j+=d[l+k],k++;j=="H"?j="fg-toolbar ui-toolbar ui-widget-header ui-corner-tl ui-corner-tr ui-helper-clearfix":j=="F"&&(j="fg-toolbar ui-toolbar ui-widget-header ui-corner-bl ui-corner-br ui-helper-clearfix");if(j.indexOf(".")!=-1){var m=j.split(".");h.id=m[0].substr(1,m[0].length-1),h.className=m[1]}else j.charAt(0)=="#"?h.id=j.substr(1,j.length-1):h.className=j;l+=k}c.appendChild(h),c=h}else if(g==">")c=c.parentNode;else if(g=="l"&&a.oFeatures.bPaginate&&a.oFeatures.bLengthChange)e=_fnFeatureHtmlLength(a),f=1;else if(g=="f"&&a.oFeatures.bFilter)e=_fnFeatureHtmlFilter(a),f=1;else if(g=="r"&&a.oFeatures.bProcessing)e=_fnFeatureHtmlProcessing(a),f=1;else if(g=="t")e=_fnFeatureHtmlTable(a),f=1;else if(g=="i"&&a.oFeatures.bInfo)e=_fnFeatureHtmlInfo(a),f=1;else if(g=="p"&&a.oFeatures.bPaginate)e=_fnFeatureHtmlPaginate(a),f=1;else if(DataTable.ext.aoFeatures.length!==0){var n=DataTable.ext.aoFeatures;for(var o=0,p=n.length;o<p;o++)if(g==n[o].cFeature){e=n[o].fnInit(a),e&&(f=1);break}}f==1&&e!==null&&(typeof a.aanFeatures[g]!="object"&&(a.aanFeatures[g]=[]),a.aanFeatures[g].push(e),c.appendChild(e))}b.parentNode.replaceChild(a.nTableWrapper,b)}function _fnDetectHeader(a,b){var c=$(b).children("tr"),d,e,f,g,h,i,j,k,l=function(a,b,c){while(a[b][c])c++;return c};a.splice(0,a.length);for(e=0,i=c.length;e<i;e++)a.push([]);for(e=0,i=c.length;e<i;e++){var m=0;for(f=0,j=c[e].childNodes.length;f<j;f++){d=c[e].childNodes[f];if(d.nodeName.toUpperCase()=="TD"||d.nodeName.toUpperCase()=="TH"){var n=d.getAttribute("colspan")*1,o=d.getAttribute("rowspan")*1;n=!n||n===0||n===1?1:n,o=!o||o===0||o===1?1:o,k=l(a,e,m);for(h=0;h<n;h++)for(g=0;g<o;g++)a[e+g][k+h]={cell:d,unique:n==1?!0:!1},a[e+g].nTr=c[e]}}}}function _fnGetUniqueThs(a,b,c){var d=[];c||(c=a.aoHeader,b&&(c=[],_fnDetectHeader(c,b)));for(var e=0,f=c.length;e<f;e++)for(var g=0,h=c[e].length;g<h;g++)c[e][g].unique&&(!d[g]||!a.bSortCellsTop)&&(d[g]=c[e][g].cell);return d}function _fnAjaxUpdate(a){if(a.bAjaxDataGet){a.iDraw++,_fnProcessingDisplay(a,!0);var b=a.aoColumns.length,c=_fnAjaxParameters(a);return _fnServerParams(a,c),a.fnServerData.call(a.oInstance,a.sAjaxSource,c,function(b){_fnAjaxUpdateDraw(a,b)},a),!1}return!0}function _fnAjaxParameters(a){var b=a.aoColumns.length,c=[],d,e;c.push({name:"sEcho",value:a.iDraw}),c.push({name:"iColumns",value:b}),c.push({name:"sColumns",value:_fnColumnOrdering(a)}),c.push({name:"iDisplayStart",value:a._iDisplayStart}),c.push({name:"iDisplayLength",value:a.oFeatures.bPaginate!==!1?a._iDisplayLength:-1});for(e=0;e<b;e++)d=a.aoColumns[e].mDataProp,c.push({name:"mDataProp_"+e,value:typeof d=="function"?"function":d});if(a.oFeatures.bFilter!==!1){c.push({name:"sSearch",value:a.oPreviousSearch.sSearch}),c.push({name:"bRegex",value:a.oPreviousSearch.bRegex});for(e=0;e<b;e++)c.push({name:"sSearch_"+e,value:a.aoPreSearchCols[e].sSearch}),c.push({name:"bRegex_"+e,value:a.aoPreSearchCols[e].bRegex}),c.push({name:"bSearchable_"+e,value:a.aoColumns[e].bSearchable})}if(a.oFeatures.bSort!==!1){var f=a.aaSortingFixed!==null?a.aaSortingFixed.length:0,g=a.aaSorting.length;c.push({name:"iSortingCols",value:f+g});for(e=0;e<f;e++)c.push({name:"iSortCol_"+e,value:a.aaSortingFixed[e][0]}),c.push({name:"sSortDir_"+e,value:a.aaSortingFixed[e][1]});for(e=0;e<g;e++)c.push({name:"iSortCol_"+(e+f),value:a.aaSorting[e][0]}),c.push({name:"sSortDir_"+(e+f),value:a.aaSorting[e][1]});for(e=0;e<b;e++)c.push({name:"bSortable_"+e,value:a.aoColumns[e].bSortable})}return c}function _fnServerParams(a,b){_fnCallbackFire(a,"aoServerParams","serverParams",[b])}function _fnAjaxUpdateDraw(a,b){if(b.sEcho!==undefined){if(b.sEcho*1<a.iDraw)return;a.iDraw=b.sEcho*1}(!a.oScroll.bInfinite||a.oScroll.bInfinite&&(a.bSorted||a.bFiltered))&&_fnClearTable(a),a._iRecordsTotal=parseInt(b.iTotalRecords,10),a._iRecordsDisplay=parseInt(b.iTotalDisplayRecords,10);var c=_fnColumnOrdering(a),d=b.sColumns!==undefined&&c!==""&&b.sColumns!=c,e;d&&(e=_fnReOrderIndex(a,b.sColumns));var f=_fnGetObjectDataFn(a.sAjaxDataProp)(b);for(var g=0,h=f.length;g<h;g++)if(d){var i=[];for(var j=0,k=a.aoColumns.length;j<k;j++)i.push(f[g][e[j]]);_fnAddData(a,i)}else _fnAddData(a,f[g]);a.aiDisplay=a.aiDisplayMaster.slice(),a.bAjaxDataGet=!1,_fnDraw(a),a.bAjaxDataGet=!0,_fnProcessingDisplay(a,!1)}function _fnFeatureHtmlFilter(a){var b=a.oPreviousSearch,c=a.oLanguage.sSearch;c=c.indexOf("_INPUT_")!==-1?c.replace("_INPUT_",'<input type="text" />'):c===""?'<input type="text" />':c+' <input type="text" />';var d=document.createElement("div");d.className=a.oClasses.sFilter,d.innerHTML="<label>"+c+"</label>",a.aanFeatures.f||(d.id=a.sTableId+"_filter");var e=$("input",d);return e.val(b.sSearch.replace('"',"&quot;")),e.bind("keyup.DT",function(c){var d=a.aanFeatures.f;for(var e=0,f=d.length;e<f;e++)d[e]!=$(this).parents("div.dataTables_filter")[0]&&$("input",d[e]).val(this.value);this.value!=b.sSearch&&_fnFilterComplete(a,{sSearch:this.value,bRegex:b.bRegex,bSmart:b.bSmart,bCaseInsensitive:b.bCaseInsensitive})}),e.attr("aria-controls",a.sTableId).bind("keypress.DT",function(a){if(a.keyCode==13)return!1}),d}function _fnFilterComplete(a,b,c){var d=a.oPreviousSearch,e=a.aoPreSearchCols,f=function(a){d.sSearch=a.sSearch,d.bRegex=a.bRegex,d.bSmart=a.bSmart,d.bCaseInsensitive=a.bCaseInsensitive};if(!a.oFeatures.bServerSide){_fnFilter(a,b.sSearch,c,b.bRegex,b.bSmart,b.bCaseInsensitive),f(b);for(var g=0;g<a.aoPreSearchCols.length;g++)_fnFilterColumn(a,e[g].sSearch,g,e[g].bRegex,e[g].bSmart,e[g].bCaseInsensitive);_fnFilterCustom(a)}else f(b);a.bFiltered=!0,$(a.oInstance).trigger("filter",a),a._iDisplayStart=0,_fnCalculateEnd(a),_fnDraw(a),_fnBuildSearchArray(a,0)}function _fnFilterCustom(a){var b=DataTable.ext.afnFiltering;for(var c=0,d=b.length;c<d;c++){var e=0;for(var f=0,g=a.aiDisplay.length;f<g;f++){var h=a.aiDisplay[f-e];b[c](a,_fnGetRowData(a,h,"filter"),h)||(a.aiDisplay.splice(f-e,1),e++)}}}function _fnFilterColumn(a,b,c,d,e,f){if(b==="")return;var g=0,h=_fnFilterCreateSearch(b,d,e,f);for(var i=a.aiDisplay.length-1;i>=0;i--){var j=_fnDataToSearch(_fnGetCellData(a,a.aiDisplay[i],c,"filter"),a.aoColumns[c].sType);h.test(j)||(a.aiDisplay.splice(i,1),g++)}}function _fnFilter(a,b,c,d,e,f){var g,h=_fnFilterCreateSearch(b,d,e,f),i=a.oPreviousSearch;c||(c=0),DataTable.ext.afnFiltering.length!==0&&(c=1);if(b.length<=0)a.aiDisplay.splice(0,a.aiDisplay.length),a.aiDisplay=a.aiDisplayMaster.slice();else if(a.aiDisplay.length==a.aiDisplayMaster.length||i.sSearch.length>b.length||c==1||b.indexOf(i.sSearch)!==0){a.aiDisplay.splice(0,a.aiDisplay.length),_fnBuildSearchArray(a,1);for(g=0;g<a.aiDisplayMaster.length;g++)h.test(a.asDataSearch[g])&&a.aiDisplay.push(a.aiDisplayMaster[g])}else{var j=0;for(g=0;g<a.asDataSearch.length;g++)h.test(a.asDataSearch[g])||(a.aiDisplay.splice(g-j,1),j++)}}function _fnBuildSearchArray(a,b){if(!a.oFeatures.bServerSide){a.asDataSearch.splice(0,a.asDataSearch.length);var c=b&&b===1?a.aiDisplayMaster:a.aiDisplay;for(var d=0,e=c.length;d<e;d++)a.asDataSearch[d]=_fnBuildSearchRow(a,_fnGetRowData(a,c[d],"filter"))}}function _fnBuildSearchRow(a,b){var c="";a.__nTmpFilter===undefined&&(a.__nTmpFilter=document.createElement("div"));var d=a.__nTmpFilter;for(var e=0,f=a.aoColumns.length;e<f;e++)if(a.aoColumns[e].bSearchable){var g=b[e];c+=_fnDataToSearch(g,a.aoColumns[e].sType)+"  "}return c.indexOf("&")!==-1&&(d.innerHTML=c,c=d.textContent?d.textContent:d.innerText,c=c.replace(/\n/g," ").replace(/\r/g,"")),c}function _fnFilterCreateSearch(a,b,c,d){var e,f;return c?(e=b?a.split(" "):_fnEscapeRegex(a).split(" "),f="^(?=.*?"+e.join(")(?=.*?")+").*$",new RegExp(f,d?"i":"")):(a=b?a:_fnEscapeRegex(a),new RegExp(a,d?"i":""))}function _fnDataToSearch(a,b){return typeof DataTable.ext.ofnSearch[b]=="function"?DataTable.ext.ofnSearch[b](a):b=="html"?a.replace(/[\r\n]/g," ").replace(/<.*?>/g,""):typeof a=="string"?a.replace(/[\r\n]/g," "):a===null?"":a}function _fnEscapeRegex(a){var b=["/",".","*","+","?","|","(",")","[","]","{","}","\\","$","^"],c=new RegExp("(\\"+b.join("|\\")+")","g");return a.replace(c,"\\$1")}function _fnFeatureHtmlInfo(a){var b=document.createElement("div");return b.className=a.oClasses.sInfo,a.aanFeatures.i||(a.aoDrawCallback.push({fn:_fnUpdateInfo,sName:"information"}),b.id=a.sTableId+"_info"),a.nTable.setAttribute("aria-describedby",a.sTableId+"_info"),b}function _fnUpdateInfo(a){if(!a.oFeatures.bInfo||a.aanFeatures.i.length===0)return;var b=a._iDisplayStart+1,c=a.fnDisplayEnd(),d=a.fnRecordsTotal(),e=a.fnRecordsDisplay(),f=a.fnFormatNumber(b),g=a.fnFormatNumber(c),h=a.fnFormatNumber(d),i=a.fnFormatNumber(e),j;a.oScroll.bInfinite&&(f=a.fnFormatNumber(1)),a.fnRecordsDisplay()===0&&a.fnRecordsDisplay()==a.fnRecordsTotal()?j=a.oLanguage.sInfoEmpty+a.oLanguage.sInfoPostFix:a.fnRecordsDisplay()===0?j=a.oLanguage.sInfoEmpty+" "+a.oLanguage.sInfoFiltered.replace("_MAX_",h)+a.oLanguage.sInfoPostFix:a.fnRecordsDisplay()==a.fnRecordsTotal()?j=a.oLanguage.sInfo.replace("_START_",f).replace("_END_",g).replace("_TOTAL_",i)+a.oLanguage.sInfoPostFix:j=a.oLanguage.sInfo.replace("_START_",f).replace("_END_",g).replace("_TOTAL_",i)+" "+a.oLanguage.sInfoFiltered.replace("_MAX_",a.fnFormatNumber(a.fnRecordsTotal()))+a.oLanguage.sInfoPostFix,a.oLanguage.fnInfoCallback!==null&&(j=a.oLanguage.fnInfoCallback.call(a.oInstance,a,b,c,d,e,j));var k=a.aanFeatures.i;for(var l=0,m=k.length;l<m;l++)$(k[l]).html(j)}function _fnInitialise(a){var b,c,d=a.iInitDisplayStart;if(a.bInitialised===!1){setTimeout(function(){_fnInitialise(a)},200);return}_fnAddOptionsHtml(a),_fnBuildHead(a),_fnDrawHead(a,a.aoHeader),a.nTFoot&&_fnDrawHead(a,a.aoFooter),_fnProcessingDisplay(a,!0),a.oFeatures.bAutoWidth&&_fnCalculateColumnWidths(a);for(b=0,c=a.aoColumns.length;b<c;b++)a.aoColumns[b].sWidth!==null&&(a.aoColumns[b].nTh.style.width=_fnStringToCss(a.aoColumns[b].sWidth));a.oFeatures.bSort?_fnSort(a):a.oFeatures.bFilter?_fnFilterComplete(a,a.oPreviousSearch):(a.aiDisplay=a.aiDisplayMaster.slice(),_fnCalculateEnd(a),_fnDraw(a));if(a.sAjaxSource!==null&&!a.oFeatures.bServerSide){var e=[];_fnServerParams(a,e),a.fnServerData.call(a.oInstance,a.sAjaxSource,e,function(c){var e=a.sAjaxDataProp!==""?_fnGetObjectDataFn(a.sAjaxDataProp)(c):c;for(b=0;b<e.length;b++)_fnAddData(a,e[b]);a.iInitDisplayStart=d,a.oFeatures.bSort?_fnSort(a):(a.aiDisplay=a.aiDisplayMaster.slice(),_fnCalculateEnd(a),_fnDraw(a)),_fnProcessingDisplay(a,!1),_fnInitComplete(a,c)},a);return}a.oFeatures.bServerSide||(_fnProcessingDisplay(a,!1),_fnInitComplete(a))}function _fnInitComplete(a,b){a._bInitComplete=!0,_fnCallbackFire(a,"aoInitComplete","init",[a,b])}function _fnLanguageCompat(a){!a.sEmptyTable&&a.sZeroRecords&&_fnMap(a,a,"sZeroRecords","sEmptyTable"),!a.sLoadingRecords&&a.sZeroRecords&&_fnMap(a,a,"sZeroRecords","sLoadingRecords")}function _fnFeatureHtmlLength(a){if(a.oScroll.bInfinite)return null;var b='name="'+a.sTableId+'_length"',c='<select size="1" '+b+">",d,e,f=a.aLengthMenu;if(f.length==2&&typeof f[0]=="object"&&typeof f[1]=="object")for(d=0,e=f[0].length;d<e;d++)c+='<option value="'+f[0][d]+'">'+f[1][d]+"</option>";else for(d=0,e=f.length;d<e;d++)c+='<option value="'+f[d]+'">'+f[d]+"</option>";c+="</select>";var g=document.createElement("div");return a.aanFeatures.l||(g.id=a.sTableId+"_length"),g.className=a.oClasses.sLength,g.innerHTML="<label>"+a.oLanguage.sLengthMenu.replace("_MENU_",c)+"</label>",$('select option[value="'+a._iDisplayLength+'"]',g).attr("selected",!0),$("select",g).bind("change.DT",function(b){var c=$(this).val(),f=a.aanFeatures.l;for(d=0,e=f.length;d<e;d++)f[d]!=this.parentNode&&$("select",f[d]).val(c);a._iDisplayLength=parseInt(c,10),_fnCalculateEnd(a),a.fnDisplayEnd()==a.fnRecordsDisplay()&&(a._iDisplayStart=a.fnDisplayEnd()-a._iDisplayLength,a._iDisplayStart<0&&(a._iDisplayStart=0)),a._iDisplayLength==-1&&(a._iDisplayStart=0),_fnDraw(a)}),$("select",g).attr("aria-controls",a.sTableId),g}function _fnCalculateEnd(a){a.oFeatures.bPaginate===!1?a._iDisplayEnd=a.aiDisplay.length:a._iDisplayStart+a._iDisplayLength>a.aiDisplay.length||a._iDisplayLength==-1?a._iDisplayEnd=a.aiDisplay.length:a._iDisplayEnd=a._iDisplayStart+a._iDisplayLength}function _fnFeatureHtmlPaginate(a){if(a.oScroll.bInfinite)return null;var b=document.createElement("div");return b.className=a.oClasses.sPaging+a.sPaginationType,DataTable.ext.oPagination[a.sPaginationType].fnInit(a,b,function(a){_fnCalculateEnd(a),_fnDraw(a)}),a.aanFeatures.p||a.aoDrawCallback.push({fn:function(a){DataTable.ext.oPagination[a.sPaginationType].fnUpdate(a,function(a){_fnCalculateEnd(a),_fnDraw(a)})},sName:"pagination"}),b}function _fnPageChange(a,b){var c=a._iDisplayStart;if(typeof b=="number")a._iDisplayStart=b*a._iDisplayLength,a._iDisplayStart>a.fnRecordsDisplay()&&(a._iDisplayStart=0);else if(b=="first")a._iDisplayStart=0;else if(b=="previous")a._iDisplayStart=a._iDisplayLength>=0?a._iDisplayStart-a._iDisplayLength:0,a._iDisplayStart<0&&(a._iDisplayStart=0);else if(b=="next")a._iDisplayLength>=0?a._iDisplayStart+a._iDisplayLength<a.fnRecordsDisplay()&&(a._iDisplayStart+=a._iDisplayLength):a._iDisplayStart=0;else if(b=="last")if(a._iDisplayLength>=0){var d=parseInt((a.fnRecordsDisplay()-1)/a._iDisplayLength,10)+1;a._iDisplayStart=(d-1)*a._iDisplayLength}else a._iDisplayStart=0;else _fnLog(a,0,"Unknown paging action: "+b);return $(a.oInstance).trigger("page",a),c!=a._iDisplayStart}function _fnFeatureHtmlProcessing(a){var b=document.createElement("div");return a.aanFeatures.r||(b.id=a.sTableId+"_processing"),b.innerHTML=a.oLanguage.sProcessing,b.className=a.oClasses.sProcessing,a.nTable.parentNode.insertBefore(b,a.nTable),b}function _fnProcessingDisplay(a,b){if(a.oFeatures.bProcessing){var c=a.aanFeatures.r;for(var d=0,e=c.length;d<e;d++)c[d].style.visibility=b?"visible":"hidden"}$(a.oInstance).trigger("processing",[a,b])}function _fnFeatureHtmlTable(a){if(a.oScroll.sX===""&&a.oScroll.sY==="")return a.nTable;var b=document.createElement("div"),c=document.createElement("div"),d=document.createElement("div"),e=document.createElement("div"),f=document.createElement("div"),g=document.createElement("div"),h=a.nTable.cloneNode(!1),i=a.nTable.cloneNode(!1),j=a.nTable.getElementsByTagName("thead")[0],k=a.nTable.getElementsByTagName("tfoot").length===0?null:a.nTable.getElementsByTagName("tfoot")[0],l=a.oClasses;c.appendChild(d),f.appendChild(g),e.appendChild(a.nTable),b.appendChild(c),b.appendChild(e),d.appendChild(h),h.appendChild(j),k!==null&&(b.appendChild(f),g.appendChild(i),i.appendChild(k)),b.className=l.sScrollWrapper,c.className=l.sScrollHead,d.className=l.sScrollHeadInner,e.className=l.sScrollBody,f.className=l.sScrollFoot,g.className=l.sScrollFootInner,a.oScroll.bAutoCss&&(c.style.overflow="hidden",c.style.position="relative",f.style.overflow="hidden",e.style.overflow="auto"),c.style.border="0",c.style.width="100%",f.style.border="0",d.style.width="150%",h.removeAttribute("id"),h.style.marginLeft="0",a.nTable.style.marginLeft="0",k!==null&&(i.removeAttribute("id"),i.style.marginLeft="0");var m=$(a.nTable).children("caption");for(var n=0,o=m.length;n<o;n++)h.appendChild(m[n]);return a.oScroll.sX!==""&&(c.style.width=_fnStringToCss(a.oScroll.sX),e.style.width=_fnStringToCss(a.oScroll.sX),k!==null&&(f.style.width=_fnStringToCss(a.oScroll.sX)),$(e).scroll(function(a){c.scrollLeft=this.scrollLeft,k!==null&&(f.scrollLeft=this.scrollLeft)})),a.oScroll.sY!==""&&(e.style.height=_fnStringToCss(a.oScroll.sY)),a.aoDrawCallback.push({fn:_fnScrollDraw,sName:"scrolling"}),a.oScroll.bInfinite&&$(e).scroll(function(){!a.bDrawing&&$(this).scrollTop()!==0&&$(this).scrollTop()+$(this).height()>$(a.nTable).height()-a.oScroll.iLoadGap&&a.fnDisplayEnd()<a.fnRecordsDisplay()&&(_fnPageChange(a,"next"),_fnCalculateEnd(a),_fnDraw(a))}),a.nScrollHead=c,a.nScrollFoot=f,b}function _fnScrollDraw(a){var b=a.nScrollHead.getElementsByTagName("div")[0],c=b.getElementsByTagName("table")[0],d=a.nTable.parentNode,e,f,g,h,i,j,k,l,m,n,o,p=[],q,r=a.nTFoot!==null?a.nScrollFoot.getElementsByTagName("div")[0]:null,s=a.nTFoot!==null?r.getElementsByTagName("table")[0]:null,t=$.browser.msie&&$.browser.version<=7,u=a.nTable.getElementsByTagName("thead");u.length>0&&a.nTable.removeChild(u[0]);var v;a.nTFoot!==null&&(v=a.nTable.getElementsByTagName("tfoot"),v.length>0&&a.nTable.removeChild(v[0])),u=a.nTHead.cloneNode(!0),a.nTable.insertBefore(u,a.nTable.childNodes[0]),a.nTFoot!==null&&(v=a.nTFoot.cloneNode(!0),a.nTable.insertBefore(v,a.nTable.childNodes[1])),a.oScroll.sX===""&&(d.style.width="100%",b.parentNode.style.width="100%");var w=_fnGetUniqueThs(a,u);for(e=0,f=w.length;e<f;e++)n=_fnVisibleToColumnIndex(a,e),w[e].style.width=a.aoColumns[n].sWidth;a.nTFoot!==null&&_fnApplyToChildren(function(a){a.style.width=""},v.getElementsByTagName("tr")),q=$(a.nTable).outerWidth(),a.oScroll.sX===""?(a.nTable.style.width="100%",t&&($("tbody",d).height()>d.offsetHeight||$(d).css("overflow-y")=="scroll")&&(a.nTable.style.width=_fnStringToCss($(a.nTable).outerWidth()-a.oScroll.iBarWidth))):a.oScroll.sXInner!==""?a.nTable.style.width=_fnStringToCss(a.oScroll.sXInner):q==$(d).width()&&$(d).height()<$(a.nTable).height()?(a.nTable.style.width=_fnStringToCss(q-a.oScroll.iBarWidth),$(a.nTable).outerWidth()>q-a.oScroll.iBarWidth&&(a.nTable.style.width=_fnStringToCss(q))):a.nTable.style.width=_fnStringToCss(q),q=$(a.nTable).outerWidth(),i=a.nTHead.getElementsByTagName("tr"),j=u.getElementsByTagName("tr"),_fnApplyToChildren(function(a,b){m=a.style,m.paddingTop="0",m.paddingBottom="0",m.borderTopWidth="0",m.borderBottomWidth="0",m.height=0,o=$(a).width(),b.style.width=_fnStringToCss(o),p.push(o)},j,i),$(j).height(0),a.nTFoot!==null&&(k=v.getElementsByTagName("tr"),l=a.nTFoot.getElementsByTagName("tr"),_fnApplyToChildren(function(a,b){m=a.style,m.paddingTop="0",m.paddingBottom="0",m.borderTopWidth="0",m.borderBottomWidth="0",m.height=0,o=$(a).width(),b.style.width=_fnStringToCss(o),p.push(o)},k,l),$(k).height(0)),_fnApplyToChildren(function(a){a.innerHTML="",a.style.width=_fnStringToCss(p.shift())},j),a.nTFoot!==null&&_fnApplyToChildren(function(a){a.innerHTML="",a.style.width=_fnStringToCss(p.shift())},k);if($(a.nTable).outerWidth()<q){var x=d.scrollHeight>d.offsetHeight||$(d).css("overflow-y")=="scroll"?q+a.oScroll.iBarWidth:q;t&&(d.scrollHeight>d.offsetHeight||$(d).css("overflow-y")=="scroll")&&(a.nTable.style.width=_fnStringToCss(x-a.oScroll.iBarWidth)),d.style.width=_fnStringToCss(x),b.parentNode.style.width=_fnStringToCss(x),a.nTFoot!==null&&(r.parentNode.style.width=_fnStringToCss(x)),a.oScroll.sX===""?_fnLog(a,1,"The table cannot fit into the current element which will cause column misalignment. The table has been drawn at its minimum possible width."):a.oScroll.sXInner!==""&&_fnLog(a,1,"The table cannot fit into the current element which will cause column misalignment. Increase the sScrollXInner value or remove it to allow automatic calculation")}else d.style.width=_fnStringToCss("100%"),b.parentNode.style.width=_fnStringToCss("100%"),a.nTFoot!==null&&(r.parentNode.style.width=_fnStringToCss("100%"));a.oScroll.sY===""&&t&&(d.style.height=_fnStringToCss(a.nTable.offsetHeight+a.oScroll.iBarWidth));if(a.oScroll.sY!==""&&a.oScroll.bCollapse){d.style.height=_fnStringToCss(a.oScroll.sY);var y=a.oScroll.sX!==""&&a.nTable.offsetWidth>d.offsetWidth?a.oScroll.iBarWidth:0;a.nTable.offsetHeight<d.offsetHeight&&(d.style.height=_fnStringToCss($(a.nTable).height()+y))}var z=$(a.nTable).outerWidth();c.style.width=_fnStringToCss(z),b.style.width=_fnStringToCss(z),a.nTFoot!==null&&(r.style.width=_fnStringToCss(a.nTable.offsetWidth),s.style.width=_fnStringToCss(a.nTable.offsetWidth));if(a.bSorted||a.bFiltered)d.scrollTop=0}function _fnApplyToChildren(a,b,c){for(var d=0,e=b.length;d<e;d++)for(var f=0,g=b[d].childNodes.length;f<g;f++)b[d].childNodes[f].nodeType==1&&(c?a(b[d].childNodes[f],c[d].childNodes[f]):a(b[d].childNodes[f]))}function _fnConvertToWidth(a,b){if(!a||a===null||a==="")return 0;b||(b=document.getElementsByTagName("body")[0]);var c,d=document.createElement("div");return d.style.width=_fnStringToCss(a),b.appendChild(d),c=d.offsetWidth,b.removeChild(d),c}function _fnCalculateColumnWidths(a){var b=a.nTable.offsetWidth,c=0,d,e=0,f=a.aoColumns.length,g,h,i,j,k=$("th",a.nTHead),l=a.nTable.getAttribute("width");for(g=0;g<f;g++)a.aoColumns[g].bVisible&&(e++,a.aoColumns[g].sWidth!==null&&(d=_fnConvertToWidth(a.aoColumns[g].sWidthOrig,a.nTable.parentNode),d!==null&&(a.aoColumns[g].sWidth=_fnStringToCss(d)),c++));if(f==k.length&&c===0&&e==f&&a.oScroll.sX===""&&a.oScroll.sY==="")for(g=0;g<a.aoColumns.length;g++)d=$(k[g]).width(),d!==null&&(a.aoColumns[g].sWidth=_fnStringToCss(d));else{var m=a.nTable.cloneNode(!1),n=a.nTHead.cloneNode(!0),o=document.createElement("tbody"),p=document.createElement("tr"),q;m.removeAttribute("id"),m.appendChild(n),a.nTFoot!==null&&(m.appendChild(a.nTFoot.cloneNode(!0)),_fnApplyToChildren(function(a){a.style.width=""},m.getElementsByTagName("tr"))),m.appendChild(o),o.appendChild(p);var r=$("thead th",m);r.length===0&&(r=$("tbody tr:eq(0)>td",m));var s=_fnGetUniqueThs(a,n);i=0;for(g=0;g<f;g++){var t=a.aoColumns[g];t.bVisible&&t.sWidthOrig!==null&&t.sWidthOrig!==""?s[g-i].style.width=_fnStringToCss(t.sWidthOrig):t.bVisible?s[g-i].style.width="":i++}for(g=0;g<f;g++)if(a.aoColumns[g].bVisible){var u=_fnGetWidestNode(a,g);u!==null&&(u=u.cloneNode(!0),a.aoColumns[g].sContentPadding!==""&&(u.innerHTML+=a.aoColumns[g].sContentPadding),p.appendChild(u))}var v=a.nTable.parentNode;v.appendChild(m),a.oScroll.sX!==""&&a.oScroll.sXInner!==""?m.style.width=_fnStringToCss(a.oScroll.sXInner):a.oScroll.sX!==""?(m.style.width="",$(m).width()<v.offsetWidth&&(m.style.width=_fnStringToCss(v.offsetWidth))):a.oScroll.sY!==""?m.style.width=_fnStringToCss(v.offsetWidth):l&&(m.style.width=_fnStringToCss(l)),m.style.visibility="hidden",_fnScrollingWidthAdjust(a,m);var w=$("tbody tr:eq(0)",m).children();w.length===0&&(w=_fnGetUniqueThs(a,$("thead",m)[0]));if(a.oScroll.sX!==""){var x=0;i=0;for(g=0;g<a.aoColumns.length;g++)a.aoColumns[g].bVisible&&(a.aoColumns[g].sWidthOrig===null?x+=$(w[i]).outerWidth():x+=parseInt(a.aoColumns[g].sWidth.replace("px",""),10)+($(w[i]).outerWidth()-$(w[i]).width()),i++);m.style.width=_fnStringToCss(x),a.nTable.style.width=_fnStringToCss(x)}i=0;for(g=0;g<a.aoColumns.length;g++)a.aoColumns[g].bVisible&&(j=$(w[i]).width(),j!==null&&j>0&&(a.aoColumns[g].sWidth=_fnStringToCss(j)),i++);var y=$(m).css("width");a.nTable.style.width=y.indexOf("%")!==-1?y:_fnStringToCss($(m).outerWidth()),m.parentNode.removeChild(m)}l&&(a.nTable.style.width=_fnStringToCss(l))}function _fnScrollingWidthAdjust(a,b){if(a.oScroll.sX===""&&a.oScroll.sY!==""){var c=$(b).width();b.style.width=_fnStringToCss($(b).outerWidth()-a.oScroll.iBarWidth)}else a.oScroll.sX!==""&&(b.style.width=_fnStringToCss($(b).outerWidth()))}function _fnGetWidestNode(a,b){var c=_fnGetMaxLenString(a,b);if(c<0)return null;if(a.aoData[c].nTr===null){var d=document.createElement("td");return d.innerHTML=_fnGetCellData(a,c,b,""),d}return _fnGetTdNodes(a,c)[b]}function _fnGetMaxLenString(a,b){var c=-1,d=-1;for(var e=0;e<a.aoData.length;e++){var f=_fnGetCellData(a,e,b,"display")+"";f=f.replace(/<.*?>/g,""),f.length>c&&(c=f.length,d=e)}return d}function _fnStringToCss(a){if(a===null)return"0px";if(typeof a=="number")return a<0?"0px":a+"px";var b=a.charCodeAt(a.length-1);return b<48||b>57?a:a+"px"}function _fnScrollBarWidth(){var a=document.createElement("p"),b=a.style;b.width="100%",b.height="200px",b.padding="0px";var c=document.createElement("div");b=c.style,b.position="absolute",b.top="0px",b.left="0px",b.visibility="hidden",b.width="200px",b.height="150px",b.padding="0px",b.overflow="hidden",c.appendChild(a),document.body.appendChild(c);var d=a.offsetWidth;c.style.overflow="scroll";var e=a.offsetWidth;return d==e&&(e=c.clientWidth),document.body.removeChild(c),d-e}function _fnSort(a,b){var c,d,e,f,g,h,i,j,k=[],l=[],m=DataTable.ext.oSort,n=a.aoData,o=a.aoColumns,p=a.oLanguage.oAria;if(!a.oFeatures.bServerSide&&(a.aaSorting.length!==0||a.aaSortingFixed!==null)){a.aaSortingFixed!==null?k=a.aaSortingFixed.concat(a.aaSorting):k=a.aaSorting.slice();for(c=0;c<k.length;c++){var q=k[c][0],r=_fnColumnIndexToVisible(a,q);i=a.aoColumns[q].sSortDataType;if(DataTable.ext.afnSortData[i]){var s=DataTable.ext.afnSortData[i](a,q,r);for(e=0,f=n.length;e<f;e++)_fnSetCellData(a,e,q,s[e])}}for(c=0,d=a.aiDisplayMaster.length;c<d;c++)l[a.aiDisplayMaster[c]]=c;var t=k.length,u,v;for(c=0,d=n.length;c<d;c++)for(e=0;e<t;e++){v=o[k[e][0]].aDataSort;for(g=0,h=v.length;g<h;g++)i=o[v[g]].sType,u=m[(i?i:"string")+"-pre"],n[c]._aSortData[v[g]]=u?u(_fnGetCellData(a,c,v[g],"sort")):_fnGetCellData(a,c,v[g],"sort")}a.aiDisplayMaster.sort(function(a,b){var c,d,e,f,g,h;for(c=0;c<t;c++){g=o[k[c][0]].aDataSort;for(d=0,e=g.length;d<e;d++){h=o[g[d]].sType,f=m[(h?h:"string")+"-"+k[c][1]](n[a]._aSortData[g[d]],n[b]._aSortData[g[d]]);if(f!==0)return f}}return m["numeric-asc"](l[a],l[b])})}(b===undefined||b)&&!a.oFeatures.bDeferRender&&_fnSortingClasses(a);for(c=0,d=a.aoColumns.length;c<d;c++){j=o[c].nTh,j.removeAttribute("aria-sort"),j.removeAttribute("aria-label");if(o[c].bSortable)if(k.length>0&&k[0][0]==c){j.setAttribute("aria-sort",k[0][1]=="asc"?"ascending":"descending");var w=o[c].asSorting[k[0][2]+1]?o[c].asSorting[k[0][2]+1]:o[c].asSorting[0];j.setAttribute("aria-label",o[c].sTitle+(w=="asc"?p.sSortAscending:p.sSortDescending))}else j.setAttribute("aria-label",o[c].sTitle+(o[c].asSorting[0]=="asc"?p.sSortAscending:p.sSortDescending));else j.setAttribute("aria-label",o[c].sTitle)}a.bSorted=!0,$(a.oInstance).trigger("sort",a),a.oFeatures.bFilter?_fnFilterComplete(a,a.oPreviousSearch,1):(a.aiDisplay=a.aiDisplayMaster.slice(),a._iDisplayStart=0,_fnCalculateEnd(a),_fnDraw(a))}function _fnSortAttachListener(a,b,c,d){_fnBindAction(b,{},function(b){if(a.aoColumns[c].bSortable===!1)return;var e=function(){var d,e;if(b.shiftKey){var f=!1;for(var g=0;g<a.aaSorting.length;g++)if(a.aaSorting[g][0]==c){f=!0,d=a.aaSorting[g][0],e=a.aaSorting[g][2]+1,a.aoColumns[d].asSorting[e]?(a.aaSorting[g][1]=a.aoColumns[d].asSorting[e],a.aaSorting[g][2]=e):a.aaSorting.splice(g,1);break}f===!1&&a.aaSorting.push([c,a.aoColumns[c].asSorting[0],0])}else a.aaSorting.length==1&&a.aaSorting[0][0]==c?(d=a.aaSorting[0][0],e=a.aaSorting[0][2]+1,a.aoColumns[d].asSorting[e]||(e=0),a.aaSorting[0][1]=a.aoColumns[d].asSorting[e],a.aaSorting[0][2]=e):(a.aaSorting.splice(0,a.aaSorting.length),a.aaSorting.push([c,a.aoColumns[c].asSorting[0],0]));_fnSort(a)};a.oFeatures.bProcessing?(_fnProcessingDisplay(a,!0),setTimeout(function(){e(),a.oFeatures.bServerSide||_fnProcessingDisplay(a,!1)},0)):e(),typeof d=="function"&&d(a)})}function _fnSortingClasses(a){var b,c,d,e,f,g,h,i=a.aoColumns.length,j=a.oClasses;for(b=0;b<i;b++)a.aoColumns[b].bSortable&&$(a.aoColumns[b].nTh).removeClass(j.sSortAsc+" "+j.sSortDesc+" "+a.aoColumns[b].sSortingClass);a.aaSortingFixed!==null?g=a.aaSortingFixed.concat(a.aaSorting):g=a.aaSorting.slice();for(b=0;b<a.aoColumns.length;b++)if(a.aoColumns[b].bSortable){h=a.aoColumns[b].sSortingClass,f=-1;for(d=0;d<g.length;d++)if(g[d][0]==b){h=g[d][1]=="asc"?j.sSortAsc:j.sSortDesc,f=d;break}$(a.aoColumns[b].nTh).addClass(h);if(a.bJUI){var k=$("span."+j.sSortIcon,a.aoColumns[b].nTh);k.removeClass(j.sSortJUIAsc+" "+j.sSortJUIDesc+" "+j.sSortJUI+" "+j.sSortJUIAscAllowed+" "+j.sSortJUIDescAllowed);var l;f==-1?l=a.aoColumns[b].sSortingClassJUI:g[f][1]=="asc"?l=j.sSortJUIAsc:l=j.sSortJUIDesc,k.addClass(l)}}else $(a.aoColumns[b].nTh).addClass(a.aoColumns[b].sSortingClass);h=j.sSortColumn;if(a.oFeatures.bSort&&a.oFeatures.bSortClasses){var m=_fnGetTdNodes(a);if(a.oFeatures.bDeferRender)$(m).removeClass(h+"1 "+h+"2 "+h+"3");else if(m.length>=i)for(b=0;b<i;b++)if(m[b].className.indexOf(h+"1")!=-1)for(d=0,e=m.length/i;d<e;d++)m[i*d+b].className=$.trim(m[i*d+b].className.replace(h+"1",""));else if(m[b].className.indexOf(h+"2")!=-1)for(d=0,e=m.length/i;d<e;d++)m[i*d+b].className=$.trim(m[i*d+b].className.replace(h+"2",""));else if(m[b].className.indexOf(h+"3")!=-1)for(d=0,e=m.length/i;d<e;d++)m[i*d+b].className=$.trim(m[i*d+b].className.replace(" "+h+"3",""));var n=1,o;for(b=0;b<g.length;b++){o=parseInt(g[b][0],10);for(d=0,e=m.length/i;d<e;d++)m[i*d+o].className+=" "+h+n;n<3&&n++}}}function _fnSaveState(a){if(!a.oFeatures.bStateSave||a.bDestroying)return;var b,c,d=a.oScroll.bInfinite,e={iCreate:(new Date).getTime(),iStart:d?0:a._iDisplayStart,iEnd:d?a._iDisplayLength:a._iDisplayEnd,iLength:a._iDisplayLength,aaSorting:$.extend(!0,[],a.aaSorting),oSearch:$.extend(!0,{},a.oPreviousSearch),aoSearchCols:$.extend(!0,[],a.aoPreSearchCols),abVisCols:[]};for(b=0,c=a.aoColumns.length;b<c;b++)e.abVisCols.push(a.aoColumns[b].bVisible);_fnCallbackFire(a,"aoStateSaveParams","stateSaveParams",[a,e]),a.fnStateSave.call(a.oInstance,a,e)}function _fnLoadState(a,b){if(!a.oFeatures.bStateSave)return;var c=a.fnStateLoad.call(a.oInstance,a);if(!c)return;var d=_fnCallbackFire(a,"aoStateLoadParams","stateLoadParams",[a,c]);if($.inArray(!1,d)!==-1)return;a.oLoadedState=$.extend(!0,{},c),a._iDisplayStart=c.iStart,a.iInitDisplayStart=c.iStart,a._iDisplayEnd=c.iEnd,a._iDisplayLength=c.iLength,a.aaSorting=c.aaSorting.slice(),a.saved_aaSorting=c.aaSorting.slice(),$.extend(a.oPreviousSearch,c.oSearch),$.extend(!0,a.aoPreSearchCols,c.aoSearchCols),b.saved_aoColumns=[];for(var e=0;e<c.abVisCols.length;e++)b.saved_aoColumns[e]={},b.saved_aoColumns[e].bVisible=c.abVisCols[e];_fnCallbackFire(a,"aoStateLoaded","stateLoaded",[a,c])}function _fnCreateCookie(sName,sValue,iSecs,sBaseName,fnCallback){var date=new Date;date.setTime(date.getTime()+iSecs*1e3);var aParts=window.location.pathname.split("/"),sNameFile=sName+"_"+aParts.pop().replace(/[\/:]/g,"").toLowerCase(),sFullCookie,oData;fnCallback!==null?(oData=typeof $.parseJSON=="function"?$.parseJSON(sValue):eval("("+sValue+")"),sFullCookie=fnCallback(sNameFile,oData,date.toGMTString(),aParts.join("/")+"/")):sFullCookie=sNameFile+"="+encodeURIComponent(sValue)+"; expires="+date.toGMTString()+"; path="+aParts.join("/")+"/";var sOldName="",iOldTime=9999999999999,iLength=_fnReadCookie(sNameFile)!==null?document.cookie.length:sFullCookie.length+document.cookie.length;if(iLength+10>4096){var aCookies=document.cookie.split(";");for(var i=0,iLen=aCookies.length;i<iLen;i++)if(aCookies[i].indexOf(sBaseName)!=-1){var aSplitCookie=aCookies[i].split("=");try{oData=eval("("+decodeURIComponent(aSplitCookie[1])+")")}catch(e){continue}oData.iCreate&&oData.iCreate<iOldTime&&(sOldName=aSplitCookie[0],iOldTime=oData.iCreate)}sOldName!==""&&(document.cookie=sOldName+"=; expires=Thu, 01-Jan-1970 00:00:01 GMT; path="+aParts.join("/")+"/")}document.cookie=sFullCookie}function _fnReadCookie(a){var b=window.location.pathname.split("/"),c=a+"_"+b[b.length-1].replace(/[\/:]/g,"").toLowerCase()+"=",d=document.cookie.split(";");for(var e=0;e<d.length;e++){var f=d[e];while(f.charAt(0)==" ")f=f.substring(1,f.length);if(f.indexOf(c)===0)return decodeURIComponent(f.substring(c.length,f.length))}return null}function _fnSettingsFromNode(a){for(var b=0;b<DataTable.settings.length;b++)if(DataTable.settings[b].nTable===a)return DataTable.settings[b];return null}function _fnGetTrNodes(a){var b=[],c=a.aoData;for(var d=0,e=c.length;d<e;d++)c[d].nTr!==null&&b.push(c[d].nTr);return b}function _fnGetTdNodes(a,b){var c=[],d,e,f,g=a.aoData.length,h,i,j,k,l=0,m=g;b!==undefined&&(l=b,m=b+1);for(f=l;f<m;f++){j=a.aoData[f];if(j.nTr!==null){e=[];for(h=0,i=j.nTr.childNodes.length;h<i;h++)k=j.nTr.childNodes[h].nodeName.toLowerCase(),(k=="td"||k=="th")&&e.push(j.nTr.childNodes[h]);d=0;for(h=0,i=a.aoColumns.length;h<i;h++)a.aoColumns[h].bVisible?c.push(e[h-d]):(c.push(j._anHidden[h]),d++)}}return c}function _fnLog(a,b,c){var d=a===null?"DataTables warning: "+c:"DataTables warning (table id = '"+a.sTableId+"'): "+c;if(b===0){if(DataTable.ext.sErrMode=="alert")alert(d);else throw d;return}console!==undefined&&console.log&&console.log(d)}function _fnMap(a,b,c,d){d===undefined&&(d=c),b[c]!==undefined&&(a[d]=b[c])}function _fnExtend(a,b){for(var c in a)a.hasOwnProperty(c)&&b[c]!==undefined&&(typeof oInit[c]=="object"&&$.isArray(b[c])===!1?$.extend(!0,a[c],b[c]):a[c]=b[c]);return a}function _fnBindAction(a,b,c){$(a).bind("click.DT",b,function(b){c(b),a.blur()}).bind("keypress.DT",b,function(a){a.which===13&&c(a)}).bind("selectstart.DT",function(){return!1})}function _fnCallbackReg(a,b,c,d){c&&a[b].push({fn:c,sName:d})}function _fnCallbackFire(a,b,c,d){var e=a[b],f=[];for(var g=e.length-1;g>=0;g--)f.push(e[g].fn.apply(a.oInstance,d));return c!==null&&$(a.oInstance).trigger(c,d),f}function _fnExternApiFunc(a){return function(){var b=[_fnSettingsFromNode(this[DataTable.ext.iApiIndex])].concat(Array.prototype.slice.call(arguments));return DataTable.ext.oApi[a].apply(this,b)}}var _fnJsonString=window.JSON?JSON.stringify:function(a){var b=typeof a;if(b!=="object"||a===null)return b==="string"&&(a='"'+a+'"'),a+"";var c,d,e=[],f=$.isArray(a);for(c in a)d=a[c],b=typeof d,b==="string"?d='"'+d+'"':b==="object"&&d!==null&&(d=_fnJsonString(d)),e.push((f?"":'"'+c+'":')+d);return(f?"[":"{")+e+(f?"]":"}")};this.$=function(a,b){var c,d,e=[],f=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);b||(b={}),b=$.extend({},{filter:"none",order:"current",page:"all"},b);if(b.page=="current")for(c=f._iDisplayStart,d=f.fnDisplayEnd();c<d;c++)e.push(f.aoData[f.aiDisplay[c]].nTr);else if(b.order=="current"&&b.filter=="none")for(c=0,d=f.aiDisplayMaster.length;c<d;c++)e.push(f.aoData[f.aiDisplayMaster[c]].nTr);else if(b.order=="current"&&b.filter=="applied")for(c=0,d=f.aiDisplay.length;c<d;c++)e.push(f.aoData[f.aiDisplay[c]].nTr);else if(b.order=="original"&&b.filter=="none")for(c=0,d=f.aoData.length;c<d;c++)e.push(f.aoData[c].nTr);else if(b.order=="original"&&b.filter=="applied")for(c=0,d=f.aoData.length;c<d;c++)$.inArray(c,f.aiDisplay)!==-1&&e.push(f.aoData[c].nTr);else _fnLog(f,1,"Unknown selection options");var g=$(e),h=g.filter(a),i=g.find(a);return $([].concat($.makeArray(h),$.makeArray(i)))},this._=function(a,b){var c=[],d,e,f,g=this.$(a,b);for(d=0,e=g.length;d<e;d++)c.push(this.fnGetData(g[d]));return c},this.fnAddData=function(a,b){if(a.length===0)return[];var c=[],d,e=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);if(typeof a[0]=="object"&&a[0]!==null)for(var f=0;f<a.length;f++){d=_fnAddData(e,a[f]);if(d==-1)return c;c.push(d)}else{d=_fnAddData(e,a);if(d==-1)return c;c.push(d)}return e.aiDisplay=e.aiDisplayMaster.slice(),(b===undefined||b)&&_fnReDraw(e),c},this.fnAdjustColumnSizing=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);_fnAdjustColumnSizing(b),a===undefined||a?this.fnDraw(!1):(b.oScroll.sX!==""||b.oScroll.sY!=="")&&this.oApi._fnScrollDraw(b)},this.fnClearTable=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);_fnClearTable(b),(a===undefined||a)&&_fnDraw(b)},this.fnClose=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);for(var c=0;c<b.aoOpenRows.length;c++)if(b.aoOpenRows[c].nParent==a){var d=b.aoOpenRows[c].nTr.parentNode;return d&&d.removeChild(b.aoOpenRows[c].nTr),b.aoOpenRows.splice(c,1),0}return 1},this.fnDeleteRow=function(a,b,c){var d=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),e,f,g;g=typeof a=="object"?_fnNodeToDataIndex(d,a):a;var h=d.aoData.splice(g,1);for(e=0,f=d.aoData.length;e<f;e++)d.aoData[e].nTr!==null&&(d.aoData[e].nTr._DT_RowIndex=e);var i=$.inArray(g,d.aiDisplay);d.asDataSearch.splice(i,1),_fnDeleteIndex(d.aiDisplayMaster,g),_fnDeleteIndex(d.aiDisplay,g),typeof b=="function"&&b.call(this,d,h),d._iDisplayStart>=d.aiDisplay.length&&(d._iDisplayStart-=d._iDisplayLength,d._iDisplayStart<0&&(d._iDisplayStart=0));if(c===undefined||c)_fnCalculateEnd(d),_fnDraw(d);return h},this.fnDestroy=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),c=b.nTableWrapper.parentNode,d=b.nTBody,e,f;a=a===undefined?!1:!0,b.bDestroying=!0;for(e=0,f=b.aoDestroyCallback.length;e<f;e++)b.aoDestroyCallback[e].fn();for(e=0,f=b.aoColumns.length;e<f;e++)b.aoColumns[e].bVisible===!1&&this.fnSetColumnVis(e,!0);$(b.nTableWrapper).find("*").andSelf().unbind(".DT"),$("tbody>tr>td."+b.oClasses.sRowEmpty,b.nTable).parent().remove(),b.nTable!=b.nTHead.parentNode&&($(b.nTable).children("thead").remove(),b.nTable.appendChild(b.nTHead)),b.nTFoot&&b.nTable!=b.nTFoot.parentNode&&($(b.nTable).children("tfoot").remove(),b.nTable.appendChild(b.nTFoot)),b.nTable.parentNode.removeChild(b.nTable),$(b.nTableWrapper).remove(),b.aaSorting=[],b.aaSortingFixed=[],_fnSortingClasses(b),$(_fnGetTrNodes(b)).removeClass(b.asStripeClasses.join(" ")),$("th, td",b.nTHead).removeClass([b.oClasses.sSortable,b.oClasses.sSortableAsc,b.oClasses.sSortableDesc,b.oClasses.sSortableNone].join(" ")),b.bJUI&&($("th span."+b.oClasses.sSortIcon+", td span."+b.oClasses.sSortIcon,b.nTHead).remove(),$("th, td",b.nTHead).each(function(){var a=$("div."+b.oClasses.sSortJUIWrapper,this),c=a.contents();$(this).append(c),a.remove()})),!a&&b.nTableReinsertBefore?c.insertBefore(b.nTable,b.nTableReinsertBefore):a||c.appendChild(b.nTable);for(e=0,f=b.aoData.length;e<f;e++)b.aoData[e].nTr!==null&&d.appendChild(b.aoData[e].nTr);b.oFeatures.bAutoWidth===!0&&(b.nTable.style.width=_fnStringToCss(b.sDestroyWidth)),$(d).children("tr:even").addClass(b.asDestroyStripes[0]),$(d).children("tr:odd").addClass(b.asDestroyStripes[1]);for(e=0,f=DataTable.settings.length;e<f;e++)DataTable.settings[e]==b&&DataTable.settings.splice(e,1);b=null},this.fnDraw=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);a?(_fnCalculateEnd(b),_fnDraw(b)):_fnReDraw(b)},this.fnFilter=function(a,b,c,d,e,f){var g=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);if(!g.oFeatures.bFilter)return;if(c===undefined||c===null)c=!1;if(d===undefined||d===null)d=!0;if(e===undefined||e===null)e=!0;if(f===undefined||f===null)f=!0;if(b===undefined||b===null){_fnFilterComplete(g,{sSearch:a+"",bRegex:c,bSmart:d,bCaseInsensitive:f},1);if(e&&g.aanFeatures.f){var h=g.aanFeatures.f;for(var i=0,j=h.length;i<j;i++)$("input",h[i]).val(a)}}else $.extend(g.aoPreSearchCols[b],{sSearch:a+"",bRegex:c,bSmart:d,bCaseInsensitive:f}),_fnFilterComplete(g,g.oPreviousSearch,1)},this.fnGetData=function(a,b){var c=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);if(a!==undefined){var d=a;if(typeof a=="object"){var e=a.nodeName.toLowerCase();e==="tr"?d=_fnNodeToDataIndex(c,a):e==="td"&&(d=_fnNodeToDataIndex(c,a.parentNode),b=_fnNodeToColumnIndex(c,d,a))}return b!==undefined?_fnGetCellData(c,d,b,""):c.aoData[d]!==undefined?c.aoData[d]._aData:null}return _fnGetDataMaster(c)},this.fnGetNodes=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);return a!==undefined?b.aoData[a]!==undefined?b.aoData[a].nTr:null:_fnGetTrNodes(b)},this.fnGetPosition=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),c=a.nodeName.toUpperCase();if(c=="TR")return _fnNodeToDataIndex(b,a);if(c=="TD"||c=="TH"){var d=_fnNodeToDataIndex(b,a.parentNode),e=_fnNodeToColumnIndex(b,d,a);return[d,_fnColumnIndexToVisible(b,e),e]}return null},this.fnIsOpen=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),c=b.aoOpenRows;for(var d=0;d<b.aoOpenRows.length;d++)if(b.aoOpenRows[d].nParent==a)return!0;return!1},this.fnOpen=function(a,b,c){var d=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),e=_fnGetTrNodes(d);if($.inArray(a,e)===-1)return;this.fnClose(a);var f=document.createElement("tr"),g=document.createElement("td");f.appendChild(g),g.className=c,g.colSpan=_fnVisbleColumns(d),typeof b=="string"?g.innerHTML=b:$(g).html(b);var h=$("tr",d.nTBody);return $.inArray(a,h)!=-1&&$(f).insertAfter(a),d.aoOpenRows.push({nTr:f,nParent:a}),f},this.fnPageChange=function(a,b){var c=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);_fnPageChange(c,a),_fnCalculateEnd(c),(b===undefined||b)&&_fnDraw(c)},this.fnSetColumnVis=function(a,b,c){var d=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),e,f,g=d.aoColumns,h=d.aoData,i,j,k,l,m,n;if(g[a].bVisible==b)return;if(b){var o=0;for(e=0;e<a;e++)g[e].bVisible&&o++;m=o>=_fnVisbleColumns(d);if(!m)for(e=a;e<g.length;e++)if(g[e].bVisible){n=e;break}for(e=0,f=h.length;e<f;e++)h[e].nTr!==null&&(m?h[e].nTr.appendChild(h[e]._anHidden[a]):h[e].nTr.insertBefore(h[e]._anHidden[a],_fnGetTdNodes(d,e)[n]))}else for(e=0,f=h.length;e<f;e++)h[e].nTr!==null&&(i=_fnGetTdNodes(d,e)[a],h[e]._anHidden[a]=i,i.parentNode.removeChild(i));g[a].bVisible=b,_fnDrawHead(d,d.aoHeader),d.nTFoot&&_fnDrawHead(d,d.aoFooter);for(e=0,f=d.aoOpenRows.length;e<f;e++)d.aoOpenRows[e].nTr.colSpan=_fnVisbleColumns(d);if(c===undefined||c)_fnAdjustColumnSizing(d),_fnDraw(d);_fnSaveState(d)},this.fnSettings=function(){return _fnSettingsFromNode(this[DataTable.ext.iApiIndex])},this.fnSort=function(a){var b=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]);b.aaSorting=a,_fnSort(b)},this.fnSortListener=function(a,b,c){_fnSortAttachListener(_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),a,b,c)},this.fnUpdate=function(a,b,c,d,e){var f=_fnSettingsFromNode(this[DataTable.ext.iApiIndex]),g,h,i,j,k=typeof b=="object"?_fnNodeToDataIndex(f,b):b;if(f.__fnUpdateDeep===undefined&&$.isArray(a)&&typeof a=="object"){f.aoData[k]._aData=a.slice(),f.__fnUpdateDeep=!0;for(h=0;h<f.aoColumns.length;h++)this.fnUpdate(_fnGetCellData(f,k,h),k,h,!1,!1);f.__fnUpdateDeep=undefined}else if(f.__fnUpdateDeep===undefined&&a!==null&&typeof a=="object"){f.aoData[k]._aData=$.extend(!0,{},a),f.__fnUpdateDeep=!0;for(h=0;h<f.aoColumns.length;h++)this.fnUpdate(_fnGetCellData(f,k,h),k,h,!1,!1);f.__fnUpdateDeep=undefined}else{_fnSetCellData(f,k,c,a),j=_fnGetCellData(f,k,c,"display");var l=f.aoColumns[c];l.fnRender!==null&&(j=_fnRender(f,k,c),l.bUseRendered&&_fnSetCellData(f,k,c,j)),f.aoData[k].nTr!==null&&(_fnGetTdNodes(f,k)[c].innerHTML=j)}var m=$.inArray(k,f.aiDisplay);return f.asDataSearch[m]=_fnBuildSearchRow(f,_fnGetRowData(f,k,"filter")),(e===undefined||e)&&_fnAdjustColumnSizing(f),(d===undefined||d)&&_fnReDraw(f),0},this.fnVersionCheck=DataTable.ext.fnVersionCheck,this.oApi={_fnExternApiFunc:_fnExternApiFunc,_fnInitialise:_fnInitialise,_fnInitComplete:_fnInitComplete,_fnLanguageCompat:_fnLanguageCompat,_fnAddColumn:_fnAddColumn,_fnColumnOptions:_fnColumnOptions,_fnAddData:_fnAddData,_fnCreateTr:_fnCreateTr,_fnGatherData:_fnGatherData,_fnBuildHead:_fnBuildHead,_fnDrawHead:_fnDrawHead,_fnDraw:_fnDraw,_fnReDraw:_fnReDraw,_fnAjaxUpdate:_fnAjaxUpdate,_fnAjaxParameters:_fnAjaxParameters,_fnAjaxUpdateDraw:_fnAjaxUpdateDraw,_fnServerParams:_fnServerParams,_fnAddOptionsHtml:_fnAddOptionsHtml,_fnFeatureHtmlTable:_fnFeatureHtmlTable,_fnScrollDraw:_fnScrollDraw,_fnAdjustColumnSizing:_fnAdjustColumnSizing,_fnFeatureHtmlFilter:_fnFeatureHtmlFilter,_fnFilterComplete:_fnFilterComplete,_fnFilterCustom:_fnFilterCustom,_fnFilterColumn:_fnFilterColumn,_fnFilter:_fnFilter,_fnBuildSearchArray:_fnBuildSearchArray,_fnBuildSearchRow:_fnBuildSearchRow,_fnFilterCreateSearch:_fnFilterCreateSearch,_fnDataToSearch:_fnDataToSearch,_fnSort:_fnSort,_fnSortAttachListener:_fnSortAttachListener,_fnSortingClasses:_fnSortingClasses,_fnFeatureHtmlPaginate:_fnFeatureHtmlPaginate,_fnPageChange:_fnPageChange,_fnFeatureHtmlInfo:_fnFeatureHtmlInfo,_fnUpdateInfo:_fnUpdateInfo,_fnFeatureHtmlLength:_fnFeatureHtmlLength,_fnFeatureHtmlProcessing:_fnFeatureHtmlProcessing,_fnProcessingDisplay:_fnProcessingDisplay,_fnVisibleToColumnIndex:_fnVisibleToColumnIndex,_fnColumnIndexToVisible:_fnColumnIndexToVisible,_fnNodeToDataIndex:_fnNodeToDataIndex,_fnVisbleColumns:_fnVisbleColumns,_fnCalculateEnd:_fnCalculateEnd,_fnConvertToWidth:_fnConvertToWidth,_fnCalculateColumnWidths:_fnCalculateColumnWidths,_fnScrollingWidthAdjust:_fnScrollingWidthAdjust,_fnGetWidestNode:_fnGetWidestNode,_fnGetMaxLenString:_fnGetMaxLenString,_fnStringToCss:_fnStringToCss,_fnDetectType:_fnDetectType,_fnSettingsFromNode:_fnSettingsFromNode,_fnGetDataMaster:_fnGetDataMaster,_fnGetTrNodes:_fnGetTrNodes,_fnGetTdNodes:_fnGetTdNodes,_fnEscapeRegex:_fnEscapeRegex,_fnDeleteIndex:_fnDeleteIndex,_fnReOrderIndex:_fnReOrderIndex,_fnColumnOrdering:_fnColumnOrdering,_fnLog:_fnLog,_fnClearTable:_fnClearTable,_fnSaveState:_fnSaveState,_fnLoadState:_fnLoadState,_fnCreateCookie:_fnCreateCookie,_fnReadCookie:_fnReadCookie,_fnDetectHeader:_fnDetectHeader,_fnGetUniqueThs:_fnGetUniqueThs,_fnScrollBarWidth:_fnScrollBarWidth,_fnApplyToChildren:_fnApplyToChildren,_fnMap:_fnMap,_fnGetRowData:_fnGetRowData,_fnGetCellData:_fnGetCellData,_fnSetCellData:_fnSetCellData,_fnGetObjectDataFn:_fnGetObjectDataFn,_fnSetObjectDataFn:_fnSetObjectDataFn,_fnApplyColumnDefs:_fnApplyColumnDefs,_fnBindAction:_fnBindAction,_fnExtend:_fnExtend,_fnCallbackReg:_fnCallbackReg,_fnCallbackFire:_fnCallbackFire,_fnJsonString:_fnJsonString,_fnRender:_fnRender,_fnNodeToColumnIndex:_fnNodeToColumnIndex},$.extend(DataTable.ext.oApi,this.oApi);for(var sFunc in DataTable.ext.oApi)sFunc&&(this[sFunc]=_fnExternApiFunc(sFunc));var _that=this;return this.each(function(){var a=0,b,c,d,e,f,g=this.getAttribute("id"),h=!1,i=!1;if(this.nodeName.toLowerCase()!="table"){_fnLog(null,0,"Attempted to initialise DataTables on a node which is not a table: "+this.nodeName);return}for(a=0,b=DataTable.settings.length;a<b;a++){if(DataTable.settings[a].nTable==this){if(oInit===undefined||oInit.bRetrieve)return DataTable.settings[a].oInstance;if(oInit.bDestroy){DataTable.settings[a].oInstance.fnDestroy();break}_fnLog(DataTable.settings[a],0,"Cannot reinitialise DataTable.\n\nTo retrieve the DataTables object for this table, pass no arguments or see the docs for bRetrieve and bDestroy");return}if(DataTable.settings[a].sTableId==this.id){DataTable.settings.splice(a,1);break}}g===null&&(g="DataTables_Table_"+DataTable.ext._oExternConfig.iNextUnique++,this.id=g);var j=$.extend(!0,{},DataTable.models.oSettings,{nTable:this,oApi:_that.oApi,oInit:oInit,sDestroyWidth:$(this).width(),sInstance:g,sTableId:g});DataTable.settings.push(j),j.oInstance=_that.length===1?_that:$(this).dataTable(),oInit||(oInit={}),oInit.oLanguage&&_fnLanguageCompat(oInit.oLanguage),oInit=_fnExtend($.extend(!0,{},DataTable.defaults),oInit),_fnMap(j.oFeatures,oInit,"bPaginate"),_fnMap(j.oFeatures,oInit,"bLengthChange"),_fnMap(j.oFeatures,oInit,"bFilter"),_fnMap(j.oFeatures,oInit,"bSort"),_fnMap(j.oFeatures,oInit,"bInfo"),_fnMap(j.oFeatures,oInit,"bProcessing"),_fnMap(j.oFeatures,oInit,"bAutoWidth"),_fnMap(j.oFeatures,oInit,"bSortClasses"),_fnMap(j.oFeatures,oInit,"bServerSide"),_fnMap(j.oFeatures,oInit,"bDeferRender"),_fnMap(j.oScroll,oInit,"sScrollX","sX"),_fnMap(j.oScroll,oInit,"sScrollXInner","sXInner"),_fnMap(j.oScroll,oInit,"sScrollY","sY"),_fnMap(j.oScroll,oInit,"bScrollCollapse","bCollapse"),_fnMap(j.oScroll,oInit,"bScrollInfinite","bInfinite"),_fnMap(j.oScroll,oInit,"iScrollLoadGap","iLoadGap"),_fnMap(j.oScroll,oInit,"bScrollAutoCss","bAutoCss"),_fnMap(j,oInit,"asStripClasses","asStripeClasses"),_fnMap(j,oInit,"asStripeClasses"),_fnMap(j,oInit,"fnServerData"),_fnMap(j,oInit,"fnFormatNumber"),_fnMap(j,oInit,"sServerMethod"),_fnMap(j,oInit,"aaSorting"),_fnMap(j,oInit,"aaSortingFixed"),_fnMap(j,oInit,"aLengthMenu"),_fnMap(j,oInit,"sPaginationType"),_fnMap(j,oInit,"sAjaxSource"),_fnMap(j,oInit,"sAjaxDataProp"),_fnMap(j,oInit,"iCookieDuration"),_fnMap(j,oInit,"sCookiePrefix"),_fnMap(j,oInit,"sDom"),_fnMap(j,oInit,"bSortCellsTop"),_fnMap(j,oInit,"iTabIndex"),_fnMap(j,oInit,"oSearch","oPreviousSearch"),_fnMap(j,oInit,"aoSearchCols","aoPreSearchCols"),_fnMap(j,oInit,"iDisplayLength","_iDisplayLength"),_fnMap(j,oInit,"bJQueryUI","bJUI"),_fnMap(j,oInit,"fnCookieCallback"),_fnMap(j,oInit,"fnStateLoad"),_fnMap(j,oInit,"fnStateSave"),_fnMap(j.oLanguage,oInit,"fnInfoCallback"),_fnCallbackReg(j,"aoDrawCallback",oInit.fnDrawCallback,"user"),_fnCallbackReg(j,"aoServerParams",oInit.fnServerParams,"user"),_fnCallbackReg(j,"aoStateSaveParams",oInit.fnStateSaveParams,"user"),_fnCallbackReg(j,"aoStateLoadParams",oInit.fnStateLoadParams,"user"),_fnCallbackReg(j,"aoStateLoaded",oInit.fnStateLoaded,"user"),_fnCallbackReg(j,"aoRowCallback",oInit.fnRowCallback,"user"),_fnCallbackReg(j,"aoRowCreatedCallback",oInit.fnCreatedRow,"user"),_fnCallbackReg(j,"aoHeaderCallback",oInit.fnHeaderCallback,"user"),_fnCallbackReg(j,"aoFooterCallback",oInit.fnFooterCallback,"user"),_fnCallbackReg(j,"aoInitComplete",oInit.fnInitComplete,"user"),_fnCallbackReg(j,"aoPreDrawCallback",oInit.fnPreDrawCallback,"user"),j.oFeatures.bServerSide&&j.oFeatures.bSort&&j.oFeatures.bSortClasses?_fnCallbackReg(j,"aoDrawCallback",_fnSortingClasses,"server_side_sort_classes"):j.oFeatures.bDeferRender&&_fnCallbackReg(j,"aoDrawCallback",_fnSortingClasses,"defer_sort_classes"),oInit.bJQueryUI?($.extend(j.oClasses,DataTable.ext.oJUIClasses),oInit.sDom===DataTable.defaults.sDom&&DataTable.defaults.sDom==="lfrtip"&&(j.sDom='<"H"lfr>t<"F"ip>')):$.extend(j.oClasses,DataTable.ext.oStdClasses),$(this).addClass(j.oClasses.sTable);if(j.oScroll.sX!==""||j.oScroll.sY!=="")j.oScroll.iBarWidth=_fnScrollBarWidth();j.iInitDisplayStart===undefined&&(j.iInitDisplayStart=oInit.iDisplayStart,j._iDisplayStart=oInit.iDisplayStart),oInit.bStateSave&&(j.oFeatures.bStateSave=!0,_fnLoadState(j,oInit),_fnCallbackReg(j,"aoDrawCallback",_fnSaveState,"state_save")),oInit.iDeferLoading!==null&&(j.bDeferLoading=!0,j._iRecordsTotal=oInit.iDeferLoading,j._iRecordsDisplay=oInit.iDeferLoading),oInit.aaData!==null&&(i=!0),oInit.oLanguage.sUrl!==""?(j.oLanguage.sUrl=oInit.oLanguage.sUrl,$.getJSON(j.oLanguage.sUrl,null,function(a){_fnLanguageCompat(a),$.extend(!0,j.oLanguage,oInit.oLanguage,a),_fnInitialise(j)}),h=!0):$.extend(!0,j.oLanguage,oInit.oLanguage);var k=!1,l=$(this).children("tbody").children("tr");for(a=0,b=j.asStripeClasses.length;a<b;a++)if(l.filter(":lt(2)").hasClass(j.asStripeClasses[a])){k=!0;break}k&&(j.asDestroyStripes=["",""],$(l[0]).hasClass(j.oClasses.sStripeOdd)&&(j.asDestroyStripes[0]+=j.oClasses.sStripeOdd+" "),$(l[0]).hasClass(j.oClasses.sStripeEven)&&(j.asDestroyStripes[0]+=j.oClasses.sStripeEven),$(l[1]).hasClass(j.oClasses.sStripeOdd)&&(j.asDestroyStripes[1]+=j.oClasses.sStripeOdd+" "),$(l[1]).hasClass(j.oClasses.sStripeEven)&&(j.asDestroyStripes[1]+=j.oClasses.sStripeEven),l.removeClass(j.asStripeClasses.join(" ")));var m=[],n,o=this.getElementsByTagName("thead");o.length!==0&&(_fnDetectHeader(j.aoHeader,o[0]),m=_fnGetUniqueThs(j));if(oInit.aoColumns===null){n=[];for(a=0,b=m.length;a<b;a++)n.push(null)}else n=oInit.aoColumns;for(a=0,b=n.length;a<b;a++)oInit.saved_aoColumns!==undefined&&oInit.saved_aoColumns.length==b&&(n[a]===null&&(n[a]={}),n[a].bVisible=oInit.saved_aoColumns[a].bVisible),_fnAddColumn(j,m?m[a]:null);_fnApplyColumnDefs(j,oInit.aoColumnDefs,n,function(a,b){_fnColumnOptions(j,a,b)});for(a=0,b=j.aaSorting.length;a<b;a++){j.aaSorting[a][0]>=j.aoColumns.length&&(j.aaSorting[a][0]=0);var p=j.aoColumns[j.aaSorting[a][0]];j.aaSorting[a][2]===undefined&&(j.aaSorting[a][2]=0),oInit.aaSorting===undefined&&j.saved_aaSorting===undefined&&(j.aaSorting[a][1]=p.asSorting[0]);for(c=0,d=p.asSorting.length;c<d;c++)if(j.aaSorting[a][1]==p.asSorting[c]){j.aaSorting[a][2]=c;break}}_fnSortingClasses(j);var q=$(this).children("thead");q.length===0&&(q=[document.createElement("thead")],this.appendChild(q[0])),j.nTHead=q[0];var r=$(this).children("tbody");r.length===0&&(r=[document.createElement("tbody")],this.appendChild(r[0])),j.nTBody=r[0],j.nTBody.setAttribute("role","alert"),j.nTBody.setAttribute("aria-live","polite"),j.nTBody.setAttribute("aria-relevant","all");var s=$(this).children("tfoot");s.length>0&&(j.nTFoot=s[0],_fnDetectHeader(j.aoFooter,j.nTFoot));if(i)for(a=0;a<oInit.aaData.length;a++)_fnAddData(j,oInit.aaData[a]);else _fnGatherData(j);j.aiDisplay=j.aiDisplayMaster.slice(),j.bInitialised=!0,h===!1&&_fnInitialise(j)})};DataTable.version="1.9.0",DataTable.settings=[],DataTable.models={},DataTable.models.ext={afnFiltering:[],afnSortData:[],aoFeatures:[],aTypes:[],fnVersionCheck:function(a){var b=function(a,b){while(a.length<b)a+="0";return a},c=DataTable.ext.sVersion.split("."),d=a.split("."),e="",f="";for(var g=0,h=d.length;g<h;g++)e+=b(c[g],3),f+=b(d[g],3);return parseInt(e,10)>=parseInt(f,10)},iApiIndex:0,ofnSearch:{},oApi:{},oStdClasses:{},oJUIClasses:{},oPagination:{},oSort:{},sVersion:DataTable.version,sErrMode:"alert",_oExternConfig:{iNextUnique:0}},DataTable.models.oSearch={bCaseInsensitive:!0,sSearch:"",bRegex:!1,bSmart:!0},DataTable.models.oRow={nTr:null,_aData:[],_aSortData:[],_anHidden:[],_sRowStripe:""},DataTable.models.oColumn={aDataSort:null,asSorting:null,bSearchable:null,bSortable:null,bUseRendered:null,bVisible:null,_bAutoType:!0,fnCreatedCell:null,fnGetData:null,fnRender:null,fnSetData:null,mDataProp:null,nTh:null,nTf:null,sClass:null,sContentPadding:null,sDefaultContent:null,sName:null,sSortDataType:"std",sSortingClass:null,sSortingClassJUI:null,sTitle:null,sType:null,sWidth:null,sWidthOrig:null},DataTable.defaults={aaData:null,aaSorting:[[0,"asc"]],aaSortingFixed:null,aLengthMenu:[10,25,50,100],aoColumns:null,aoColumnDefs:null,aoSearchCols:[],asStripeClasses:["odd","even"],bAutoWidth:!0,bDeferRender:!1,bDestroy:!1,bFilter:!0,bInfo:!0,bJQueryUI:!1,bLengthChange:!0,bPaginate:!0,bProcessing:!1,bRetrieve:!1,bScrollAutoCss:!0,bScrollCollapse:!1,bScrollInfinite:!1,bServerSide:!1,bSort:!0,bSortCellsTop:!1,bSortClasses:!0,bStateSave:!1,fnCookieCallback:null,fnCreatedRow:null,fnDrawCallback:null,fnFooterCallback:null,fnFormatNumber:function(a){if(a<1e3)return a;var b=a+"",c=b.split(""),d="",e=b.length;for(var f=0;f<e;f++)f%3===0&&f!==0&&(d=this.oLanguage.sInfoThousands+d),d=c[e-f-1]+d;return d},fnHeaderCallback:null,fnInfoCallback:null,fnInitComplete:null,fnPreDrawCallback:null,fnRowCallback:null,fnServerData:function(a,b,c,d){d.jqXHR=$.ajax({url:a,data:b,success:function(a){$(d.oInstance).trigger("xhr",d),c(a)},dataType:"json",cache:!1,type:d.sServerMethod,error:function(a,b,c){b=="parsererror"&&alert("DataTables warning: JSON data from server could not be parsed. This is caused by a JSON formatting error.")}})},fnServerParams:null,fnStateLoad:function(oSettings){var sData=this.oApi._fnReadCookie(oSettings.sCookiePrefix+oSettings.sInstance),oData;try{oData=typeof $.parseJSON=="function"?$.parseJSON(sData):eval("("+sData+")")}catch(e){oData=null}return oData},fnStateLoadParams:null,fnStateLoaded:null,fnStateSave:function(a,b){this.oApi._fnCreateCookie(a.sCookiePrefix+a.sInstance,this.oApi._fnJsonString(b),a.iCookieDuration,a.sCookiePrefix,a.fnCookieCallback)},fnStateSaveParams:null,iCookieDuration:7200,iDeferLoading:null,iDisplayLength:10,iDisplayStart:0,iScrollLoadGap:100,iTabIndex:0,oLanguage:{oAria:{sSortAscending:": activate to sort column ascending",sSortDescending:": activate to sort column descending"},oPaginate:{sFirst:"First",sLast:"Last",sNext:"Next",sPrevious:"Previous"},sEmptyTable:"No data available in table",sInfo:"Showing _START_ to _END_ of _TOTAL_ entries",sInfoEmpty:"Showing 0 to 0 of 0 entries",sInfoFiltered:"(filtered from _MAX_ total entries)",sInfoPostFix:"",sInfoThousands:",",sLengthMenu:"Show _MENU_ entries",sLoadingRecords:"Loading...",sProcessing:"Processing...",sSearch:"Search:",sUrl:"",sZeroRecords:"No matching records found"},oSearch:$.extend({},DataTable.models.oSearch),sAjaxDataProp:"aaData",sAjaxSource:null,sCookiePrefix:"SpryMedia_DataTables_",sDom:"lfrtip",sPaginationType:"two_button",sScrollX:"",sScrollXInner:"",sScrollY:"",sServerMethod:"GET"},DataTable.defaults.columns={aDataSort:null,asSorting:["asc","desc"],bSearchable:!0,bSortable:!0,bUseRendered:!0,bVisible:!0,fnCreatedCell:null,fnRender:null,iDataSort:-1,mDataProp:null,sClass:"",sContentPadding:"",sDefaultContent:null,sName:"",sSortDataType:"std",sTitle:null,sType:null,sWidth:null},DataTable.models.oSettings={oFeatures:{bAutoWidth:null,bDeferRender:null,bFilter:null,bInfo:null,bLengthChange:null,bPaginate:null,bProcessing:null,bServerSide:null,bSort:null,bSortClasses:null,bStateSave:null},oScroll:{bAutoCss:null,bCollapse:null,bInfinite:null,iBarWidth:0,iLoadGap:null,sX:null,sXInner:null,sY:null},oLanguage:{fnInfoCallback:null},aanFeatures:[],aoData:[],aiDisplay:[],aiDisplayMaster:[],aoColumns:[],aoHeader:[],aoFooter:[],asDataSearch:[],oPreviousSearch:{},aoPreSearchCols:[],aaSorting:null,aaSortingFixed:null,asStripeClasses:null,asDestroyStripes:[],sDestroyWidth:0,aoRowCallback:[],aoHeaderCallback:[],aoFooterCallback:[],aoDrawCallback:[],aoRowCreatedCallback:[],aoPreDrawCallback:[],aoInitComplete:[],aoStateSaveParams:[],aoStateLoadParams:[],aoStateLoaded:[],sTableId:"",nTable:null,nTHead:null,nTFoot:null,nTBody:null,nTableWrapper:null,bDeferLoading:!1,bInitialised:!1,aoOpenRows:[],sDom:null,sPaginationType:"two_button",iCookieDuration:0,sCookiePrefix:"",fnCookieCallback:null,aoStateSave:[],aoStateLoad:[],oLoadedState:null,sAjaxSource:null,sAjaxDataProp:null,bAjaxDataGet:!0,jqXHR:null,fnServerData:null,aoServerParams:[],sServerMethod:null,fnFormatNumber:null,aLengthMenu:null,iDraw:0,bDrawing:!1,iDrawError:-1,_iDisplayLength:10,_iDisplayStart:0,_iDisplayEnd:10,_iRecordsTotal:0,_iRecordsDisplay:0,bJUI:null,oClasses:{},bFiltered:!1,bSorted:!1,bSortCellsTop:null,oInit:null,aoDestroyCallback:[],fnRecordsTotal:function(){return this.oFeatures.bServerSide?parseInt(this._iRecordsTotal,10):this.aiDisplayMaster.length},fnRecordsDisplay:function(){return this.oFeatures.bServerSide?parseInt(this._iRecordsDisplay,10):this.aiDisplay.length},fnDisplayEnd:function(){return this.oFeatures.bServerSide?this.oFeatures.bPaginate===!1||this._iDisplayLength==-1?this._iDisplayStart+this.aiDisplay.length:Math.min(this._iDisplayStart+this._iDisplayLength,this._iRecordsDisplay):this._iDisplayEnd},oInstance:null,sInstance:null,iTabIndex:0},DataTable.ext=$.extend(!0,{},DataTable.models.ext),$.extend(DataTable.ext.oStdClasses,{sTable:"dataTable",sPagePrevEnabled:"paginate_enabled_previous",sPagePrevDisabled:"paginate_disabled_previous",sPageNextEnabled:"paginate_enabled_next",sPageNextDisabled:"paginate_disabled_next",sPageJUINext:"",sPageJUIPrev:"",sPageButton:"paginate_button",sPageButtonActive:"paginate_active",sPageButtonStaticDisabled:"paginate_button paginate_button_disabled",sPageFirst:"first",sPagePrevious:"previous",sPageNext:"next",sPageLast:"last",sStripeOdd:"odd",sStripeEven:"even",sRowEmpty:"dataTables_empty",sWrapper:"dataTables_wrapper",sFilter:"dataTables_filter",sInfo:"dataTables_info",sPaging:"dataTables_paginate paging_",sLength:"dataTables_length",sProcessing:"dataTables_processing",sSortAsc:"sorting_asc",sSortDesc:"sorting_desc",sSortable:"sorting",sSortableAsc:"sorting_asc_disabled",sSortableDesc:"sorting_desc_disabled",sSortableNone:"sorting_disabled",sSortColumn:"sorting_",sSortJUIAsc:"",sSortJUIDesc:"",sSortJUI:"",sSortJUIAscAllowed:"",sSortJUIDescAllowed:"",sSortJUIWrapper:"",sSortIcon:"",sScrollWrapper:"dataTables_scroll",sScrollHead:"dataTables_scrollHead",sScrollHeadInner:"dataTables_scrollHeadInner",sScrollBody:"dataTables_scrollBody",sScrollFoot:"dataTables_scrollFoot",sScrollFootInner:"dataTables_scrollFootInner",sFooterTH:""}),$.extend(DataTable.ext.oJUIClasses,DataTable.ext.oStdClasses,{sPagePrevEnabled:"fg-button ui-button ui-state-default ui-corner-left",sPagePrevDisabled:"fg-button ui-button ui-state-default ui-corner-left ui-state-disabled",sPageNextEnabled:"fg-button ui-button ui-state-default ui-corner-right",sPageNextDisabled:"fg-button ui-button ui-state-default ui-corner-right ui-state-disabled",sPageJUINext:"ui-icon ui-icon-circle-arrow-e",sPageJUIPrev:"ui-icon ui-icon-circle-arrow-w",sPageButton:"fg-button ui-button ui-state-default",sPageButtonActive:"fg-button ui-button ui-state-default ui-state-disabled",sPageButtonStaticDisabled:"fg-button ui-button ui-state-default ui-state-disabled",sPageFirst:"first ui-corner-tl ui-corner-bl",sPageLast:"last ui-corner-tr ui-corner-br",sPaging:"dataTables_paginate fg-buttonset ui-buttonset fg-buttonset-multi ui-buttonset-multi paging_",sSortAsc:"ui-state-default",sSortDesc:"ui-state-default",sSortable:"ui-state-default",sSortableAsc:"ui-state-default",sSortableDesc:"ui-state-default",sSortableNone:"ui-state-default",sSortJUIAsc:"css_right ui-icon ui-icon-triangle-1-n",sSortJUIDesc:"css_right ui-icon ui-icon-triangle-1-s",sSortJUI:"css_right ui-icon ui-icon-carat-2-n-s",sSortJUIAscAllowed:"css_right ui-icon ui-icon-carat-1-n",sSortJUIDescAllowed:"css_right ui-icon ui-icon-carat-1-s",sSortJUIWrapper:"DataTables_sort_wrapper",sSortIcon:"DataTables_sort_icon",sScrollHead:"dataTables_scrollHead ui-state-default",sScrollFoot:"dataTables_scrollFoot ui-state-default",sFooterTH:"ui-state-default"}),$.extend(DataTable.ext.oPagination,{two_button:{fnInit:function(a,b,c){var d=a.oLanguage.oPaginate,e=a.oClasses,f=function(b){a.oApi._fnPageChange(a,b.data.action)&&c(a)},g=a.bJUI?'<a class="'+a.oClasses.sPagePrevDisabled+'" tabindex="'+a.iTabIndex+'" role="button"><span class="'+a.oClasses.sPageJUIPrev+'"></span></a>'+'<a class="'+a.oClasses.sPageNextDisabled+'" tabindex="'+a.iTabIndex+'" role="button"><span class="'+a.oClasses.sPageJUINext+'"></span></a>':'<a class="'+a.oClasses.sPagePrevDisabled+'" tabindex="'+a.iTabIndex+'" role="button">'+d.sPrevious+"</a>"+'<a class="'+a.oClasses.sPageNextDisabled+'" tabindex="'+a.iTabIndex+'" role="button">'+d.sNext+"</a>";$(b).append(g);var h=$("a",b),i=h[0],j=h[1];a.oApi._fnBindAction(i,{action:"previous"},f),a.oApi._fnBindAction(j,{action:"next"},f),a.aanFeatures.p||(b.id=a.sTableId+"_paginate",i.id=a.sTableId+"_previous",j.id=a.sTableId+"_next",i.setAttribute("aria-controls",a.sTableId),j.setAttribute("aria-controls",a.sTableId))},fnUpdate:function(a,b){if(!a.aanFeatures.p)return;var c=a.oClasses,d=a.aanFeatures.p;for(var e=0,f=d.length;e<f;e++)d[e].childNodes.length!==0&&(d[e].childNodes[0].className=a._iDisplayStart===0?c.sPagePrevDisabled:c.sPagePrevEnabled,d[e].childNodes[1].className=a.fnDisplayEnd()==a.fnRecordsDisplay()?c.sPageNextDisabled:c.sPageNextEnabled)}},iFullNumbersShowPages:5,full_numbers:{fnInit:function(a,b,c){var d=a.oLanguage.oPaginate,e=a.oClasses,f=function(b){a.oApi._fnPageChange(a,b.data.action)&&c(a)};$(b).append('<a  tabindex="'+a.iTabIndex+'" class="'+e.sPageButton+" "+e.sPageFirst+'">'+d.sFirst+"</a>"+'<a  tabindex="'+a.iTabIndex+'" class="'+e.sPageButton+" "+e.sPagePrevious+'">'+d.sPrevious+"</a>"+"<span></span>"+'<a tabindex="'+a.iTabIndex+'" class="'+e.sPageButton+" "+e.sPageNext+'">'+d.sNext+"</a>"+'<a tabindex="'+a.iTabIndex+'" class="'+e.sPageButton+" "+e.sPageLast+'">'+d.sLast+"</a>");var g=$("a",b),h=g[0],i=g[1],j=g[2],k=g[3];a.oApi._fnBindAction(h,{action:"first"},f),a.oApi._fnBindAction(i,{action:"previous"},f),a.oApi._fnBindAction(j,{action:"next"},f),a.oApi._fnBindAction(k,{action:"last"},f),a.aanFeatures.p||(b.id=a.sTableId+"_paginate",h.id=a.sTableId+"_first",i.id=a.sTableId+"_previous",j.id=a.sTableId+"_next",k.id=a.sTableId+"_last")},fnUpdate:function(a,b){if(!a.aanFeatures.p)return;var c=DataTable.ext.oPagination.iFullNumbersShowPages,d=Math.floor(c/2),e=Math.ceil(a.fnRecordsDisplay()/a._iDisplayLength),f=Math.ceil(a._iDisplayStart/a._iDisplayLength)+1,g="",h,i,j,k,l=a.oClasses,m,n,o,p=a.aanFeatures.p,q=function(c){a.oApi._fnBindAction(this,{page:c+h-1},function(c){a.oApi._fnPageChange(a,c.data.page),b(a),c.preventDefault()})};e<c?(h=1,i=e):f<=d?(h=1,i=c):f>=e-d?(h=e-c+1,i=e):(h=f-Math.ceil(c/2)+1,i=h+c-1);for(j=h;j<=i;j++)g+=f!==j?'<a tabindex="'+a.iTabIndex+'" class="'+l.sPageButton+'">'+a.fnFormatNumber(j)+"</a>":'<a tabindex="'+a.iTabIndex+'" class="'+l.sPageButtonActive+'">'+a.fnFormatNumber(j)+"</a>";for(j=0,k=p.length;j<k;j++){if(p[j].childNodes.length===0)continue;$("span:eq(0)",p[j]).html(g).children("a").each(q),m=p[j].getElementsByTagName("a"),n=[m[0],m[1],m[m.length-2],m[m.length-1]],$(n).removeClass(l.sPageButton+" "+l.sPageButtonActive+" "+l.sPageButtonStaticDisabled),$([n[0],n[1]]).addClass(f==1?l.sPageButtonStaticDisabled:l.sPageButton),$([n[2],n[3]]).addClass(e===0||f===e||a._iDisplayLength===-1?l.sPageButtonStaticDisabled:l.sPageButton)}}}}),$.extend(DataTable.ext.oSort,{"string-pre":function(a){return typeof a!="string"&&(a=""),a.toLowerCase()},"string-asc":function(a,b){return a<b?-1:a>b?1:0},"string-desc":function(a,b){return a<b?1:a>b?-1:0},"html-pre":function(a){return a.replace(/<.*?>/g,"").toLowerCase()},"html-asc":function(a,b){return a<b?-1:a>b?1:0},"html-desc":function(a,b){return a<b?1:a>b?-1:0},"date-pre":function(a){var b=Date.parse(a);if(isNaN(b)||b==="")b=Date.parse("01/01/1970 00:00:00");return b},"date-asc":function(a,b){return a-b},"date-desc":function(a,b){return b-a},"numeric-pre":function(a){return a=="-"||a===""?0:a*1},"numeric-asc":function(a,b){return a-b},"numeric-desc":function(a,b){return b-a}}),$.extend(DataTable.ext.aTypes,[function(a){if(typeof a=="number")return"numeric";if(typeof a!="string")return null;var b="0123456789-",c="0123456789.",d,e=!1;d=a.charAt(0);if(b.indexOf(d)==-1)return null;for(var f=1;f<a.length;f++){d=a.charAt(f);if(c.indexOf(d)==-1)return null;if(d=="."){if(e)return null;e=!0}}return"numeric"},function(a){var b=Date.parse(a);return b!==null&&!isNaN(b)||typeof a=="string"&&a.length===0?"date":null},function(a){return typeof a=="string"&&a.indexOf("<")!=-1&&a.indexOf(">")!=-1?"html":null}]),$.fn.DataTable=DataTable,$.fn.dataTable=DataTable,$.fn.dataTableSettings=DataTable.settings,$.fn.dataTableExt=DataTable.ext})(jQuery,window,document,undefined);
/**
 * @preserve jquery.layout 1.3.0 - Release Candidate 30.3
 * $Date: 2012-03-10 08:00:00 (Sat, 10 Mar 2012) $
 * $Rev: 303003 $
 *
 * Copyright (c) 2012
 *   Fabrizio Balliano (http://www.fabrizioballiano.net)
 *   Kevin Dalman (http://allpro.net)
 *
 * Dual licensed under the GPL (http://www.gnu.org/licenses/gpl.html)
 * and MIT (http://www.opensource.org/licenses/mit-license.php) licenses.
 *
 * Changelog: http://layout.jquery-dev.net/changelog.cfm#1.3.0.rc30.3
 *
 * Docs: http://layout.jquery-dev.net/documentation.html
 * Tips: http://layout.jquery-dev.net/tips.html
 * Help: http://groups.google.com/group/jquery-ui-layout
 */
(function($){function isStr(a){return $.type(a)==="string"}function runPluginCallbacks(Instance,a_fn){if($.isArray(a_fn))for(var i=0,c=a_fn.length;i<c;i++){var fn=a_fn[i];try{isStr(fn)&&(fn=eval(fn)),$.isFunction(fn)&&fn(Instance)}catch(ex){}}}var min=Math.min,max=Math.max,round=Math.floor;$.layout={version:"1.3.rc30.3",revision:.033003,language:{Open:"Open",Close:"Close",Resize:"Resize",Slide:"Slide Open",Pin:"Pin",Unpin:"Un-Pin",noRoomToOpenTip:"Not enough room to show this pane.",minSizeWarning:"Panel has reached its minimum size",maxSizeWarning:"Panel has reached its maximum size",pane:"pane",selector:"selector",errButton:"Error Adding Button \n\nInvalid ",errContainerMissing:"UI Layout Initialization Error\n\nThe specified layout-container does not exist.",errCenterPaneMissing:"UI Layout Initialization Error\n\nThe center-pane element does not exist.\n\nThe center-pane is a required element.",errContainerHeight:"UI Layout Initialization Warning\n\nThe layout-container \"CONTAINER\" has no height.\n\nTherefore the layout is 0-height and hence 'invisible'!"},browser:{mozilla:!!$.browser.mozilla,webkit:!!$.browser.webkit||!!$.browser.safari,msie:!!$.browser.msie,isIE6:!!$.browser.msie&&$.browser.version===6,version:$.browser.version},effects:{slide:{all:{duration:"fast"},north:{direction:"up"},south:{direction:"down"},east:{direction:"right"},west:{direction:"left"}},drop:{all:{duration:"slow"},north:{direction:"up"},south:{direction:"down"},east:{direction:"right"},west:{direction:"left"}},scale:{all:{duration:"fast"}},blind:{},clip:{},explode:{},fade:{},fold:{},puff:{},size:{all:{easing:"swing"}}},config:{optionRootKeys:"effects,panes,north,south,west,east,center".split(","),allPanes:"north,south,west,east,center".split(","),borderPanes:"north,south,west,east".split(","),oppositeEdge:{north:"south",south:"north",east:"west",west:"east"},hidden:{visibility:"hidden"},visible:{visibility:"visible"},resizers:{cssReq:{position:"absolute",padding:0,margin:0,fontSize:"1px",textAlign:"left",overflow:"hidden"},cssDemo:{background:"#DDD",border:"none"}},togglers:{cssReq:{position:"absolute",display:"block",padding:0,margin:0,overflow:"hidden",textAlign:"center",fontSize:"1px",cursor:"pointer",zIndex:1},cssDemo:{background:"#AAA"}},content:{cssReq:{position:"relative"},cssDemo:{overflow:"auto",padding:"10px"},cssDemoPane:{overflow:"hidden",padding:0}},panes:{cssReq:{position:"absolute",margin:0},cssDemo:{padding:"10px",background:"#FFF",border:"1px solid #BBB",overflow:"auto"}},north:{side:"Top",sizeType:"Height",dir:"horz",cssReq:{top:0,bottom:"auto",left:0,right:0,width:"auto"}},south:{side:"Bottom",sizeType:"Height",dir:"horz",cssReq:{top:"auto",bottom:0,left:0,right:0,width:"auto"}},east:{side:"Right",sizeType:"Width",dir:"vert",cssReq:{left:"auto",right:0,top:"auto",bottom:"auto",height:"auto"}},west:{side:"Left",sizeType:"Width",dir:"vert",cssReq:{left:0,right:"auto",top:"auto",bottom:"auto",height:"auto"}},center:{dir:"center",cssReq:{left:"auto",right:"auto",top:"auto",bottom:"auto",height:"auto",width:"auto"}}},callbacks:{},plugins:{draggable:!!$.fn.draggable,effects:{core:!!$.effects,slide:$.effects&&$.effects.slide}},onCreate:[],onLoad:[],onReady:[],onDestroy:[],onUnload:[],afterOpen:[],afterClose:[],scrollbarWidth:function(){return window.scrollbarWidth||$.layout.getScrollbarSize("width")},scrollbarHeight:function(){return window.scrollbarHeight||$.layout.getScrollbarSize("height")},getScrollbarSize:function(a){var b=$('<div style="position: absolute; top: -10000px; left: -10000px; width: 100px; height: 100px; overflow: scroll;"></div>').appendTo("body"),c={width:b.width()-b[0].clientWidth,height:b.height()-b[0].clientHeight};return b.remove(),window.scrollbarWidth=c.width,window.scrollbarHeight=c.height,a.match(/^(width|height)$/)?c[a]:c},showInvisibly:function(a,b){if(!a)return{};a.jquery||(a=$(a));var c={display:a.css("display"),visibility:a.css("visibility")};return b||c.display==="none"?(a.css({display:"block",visibility:"hidden"}),c):{}},getElementDimensions:function(a){var b={},c=b.css={},d={},e,f,g=$.layout.cssNum,h=a.offset();return b.offsetLeft=h.left,b.offsetTop=h.top,$.each("Left,Right,Top,Bottom".split(","),function(g,h){e=c["border"+h]=$.layout.borderWidth(a,h),f=c["padding"+h]=$.layout.cssNum(a,"padding"+h),d[h]=e+f,b["inset"+h]=f}),b.offsetWidth=a.innerWidth(),b.offsetHeight=a.innerHeight(),b.outerWidth=a.outerWidth(),b.outerHeight=a.outerHeight(),b.innerWidth=max(0,b.outerWidth-d.Left-d.Right),b.innerHeight=max(0,b.outerHeight-d.Top-d.Bottom),c.width=a.width(),c.height=a.height(),c.top=g(a,"top",!0),c.bottom=g(a,"bottom",!0),c.left=g(a,"left",!0),c.right=g(a,"right",!0),b},getElementCSS:function(a,b){var c={},d=a[0].style,e=b.split(","),f="Top,Bottom,Left,Right".split(","),g="Color,Style,Width".split(","),h,i,j,k,l,m;for(k=0;k<e.length;k++){h=e[k];if(h.match(/(border|padding|margin)$/))for(l=0;l<4;l++){i=f[l];if(h==="border")for(m=0;m<3;m++)j=g[m],c[h+i+j]=d[h+i+j];else c[h+i]=d[h+i]}else c[h]=d[h]}return c},cssWidth:function(a,b){var c=$.layout.borderWidth,d=$.layout.cssNum;if(b<=0)return 0;if(!$.support.boxModel)return b;var e=b-c(a,"Left")-c(a,"Right")-d(a,"paddingLeft")-d(a,"paddingRight");return max(0,e)},cssHeight:function(a,b){var c=$.layout.borderWidth,d=$.layout.cssNum;if(b<=0)return 0;if(!$.support.boxModel)return b;var e=b-c(a,"Top")-c(a,"Bottom")-d(a,"paddingTop")-d(a,"paddingBottom");return max(0,e)},cssNum:function(a,b,c){a.jquery||(a=$(a));var d=$.layout.showInvisibly(a),e=$.curCSS(a[0],b,!0),f=c&&e=="auto"?e:parseInt(e,10)||0;return a.css(d),f},borderWidth:function(a,b){a.jquery&&(a=a[0]);var c="border"+b.substr(0,1).toUpperCase()+b.substr(1);return $.curCSS(a,c+"Style",!0)==="none"?0:parseInt($.curCSS(a,c+"Width",!0),10)||0},isMouseOverElem:function(a,b){var c=$(b||this),d=c.offset(),e=d.top,f=d.left,g=f+c.outerWidth(),h=e+c.outerHeight(),i=a.pageX,j=a.pageY;return $.layout.browser.msie&&i<0&&j<0||i>=f&&i<=g&&j>=e&&j<=h},msg:function(a,b,c,d){if($.isPlainObject(a)&&window.debugData){typeof b=="string"?(d=c,c=b):typeof c=="object"&&(d=c,c=null);var e=c||"log( <object> )",f=$.extend({sort:!1,returnHTML:!1,display:!1},d);b===!0||f.display?debugData(a,e,f):window.console&&console.log(debugData(a,e,f))}else b?alert(a):window.console&&console.log(a)}};var lang=$.layout.language;$.layout.defaults={name:"",containerClass:"ui-layout-container",scrollToBookmarkOnLoad:!0,resizeWithWindow:!0,resizeWithWindowDelay:200,resizeWithWindowMaxDelay:0,onresizeall_start:null,onresizeall_end:null,onload_start:null,onload_end:null,onunload_start:null,onunload_end:null,autoBindCustomButtons:!1,initPanes:!0,showErrorMessages:!0,showDebugMessages:!1,zIndex:null,zIndexes:{pane_normal:0,content_mask:1,resizer_normal:2,pane_sliding:100,pane_animate:1e3,resizer_drag:1e4},panes:{applyDemoStyles:!1,closable:!0,resizable:!0,slidable:!0,initClosed:!1,initHidden:!1,contentSelector:".ui-layout-content",contentIgnoreSelector:".ui-layout-ignore",findNestedContent:!1,paneClass:"ui-layout-pane",resizerClass:"ui-layout-resizer",togglerClass:"ui-layout-toggler",buttonClass:"ui-layout-button",minSize:0,maxSize:0,spacing_open:6,spacing_closed:6,togglerLength_open:50,togglerLength_closed:50,togglerAlign_open:"center",togglerAlign_closed:"center",togglerTip_open:lang.Close,togglerTip_closed:lang.Open,togglerContent_open:"",togglerContent_closed:"",resizerDblClickToggle:!0,autoResize:!0,autoReopen:!0,resizerDragOpacity:1,maskContents:!1,maskObjects:!1,maskZindex:null,resizingGrid:!1,livePaneResizing:!1,liveContentResizing:!1,liveResizingTolerance:1,noRoomToOpenTip:lang.noRoomToOpenTip,resizerTip:lang.Resize,sliderTip:lang.Slide,sliderCursor:"pointer",slideTrigger_open:"click",slideTrigger_close:"mouseleave",slideDelay_open:300,slideDelay_close:300,hideTogglerOnSlide:!1,preventQuickSlideClose:$.layout.browser.webkit,preventPrematureSlideClose:!1,showOverflowOnHover:!1,enableCursorHotkey:!0,customHotkeyModifier:"SHIFT",fxName:"slide",fxSpeed:null,fxSettings:{},fxOpacityFix:!0,animatePaneSizing:!1,childOptions:null,initChildLayout:!0,destroyChildLayout:!0,resizeChildLayout:!0,triggerEventsOnLoad:!1,triggerEventsDuringLiveResize:!0,onshow_start:null,onshow_end:null,onhide_start:null,onhide_end:null,onopen_start:null,onopen_end:null,onclose_start:null,onclose_end:null,onresize_start:null,onresize_end:null,onsizecontent_start:null,onsizecontent_end:null,onswap_start:null,onswap_end:null,ondrag_start:null,ondrag_end:null},north:{paneSelector:".ui-layout-north",size:"auto",resizerCursor:"n-resize",customHotkey:""},south:{paneSelector:".ui-layout-south",size:"auto",resizerCursor:"s-resize",customHotkey:""},east:{paneSelector:".ui-layout-east",size:200,resizerCursor:"e-resize",customHotkey:""},west:{paneSelector:".ui-layout-west",size:200,resizerCursor:"w-resize",customHotkey:""},center:{paneSelector:".ui-layout-center",minWidth:0,minHeight:0}},$.layout.optionsMap={layout:"stateManagement,effects,zIndexes,name,zIndex,scrollToBookmarkOnLoad,showErrorMessages,resizeWithWindow,resizeWithWindowDelay,resizeWithWindowMaxDelay,onresizeall,onresizeall_start,onresizeall_end,onload,onunload,autoBindCustomButtons".split(","),center:"paneClass,contentSelector,contentIgnoreSelector,findNestedContent,applyDemoStyles,triggerEventsOnLoad,showOverflowOnHover,maskContents,maskObjects,liveContentResizing,childOptions,initChildLayout,resizeChildLayout,destroyChildLayout,onresize,onresize_start,onresize_end,onsizecontent,onsizecontent_start,onsizecontent_end".split(","),noDefault:"paneSelector,resizerCursor,customHotkey".split(",")},$.layout.transformData=function(a){var b={panes:{},center:{}},c,d,e,f,g,h,i,j;if(typeof a!="object")return b;for(e in a){d=b,c=$.layout.optionsMap.layout,h=a[e],f=e.split("__"),j=f.length-1;for(i=0;i<=j;i++)g=f[i],i===j?d[g]=h:d[g]||(d[g]={}),d=d[g]}return b},$.layout.backwardCompatibility={map:{applyDefaultStyles:"applyDemoStyles",resizeNestedLayout:"resizeChildLayout",resizeWhileDragging:"livePaneResizing",resizeContentWhileDragging:"liveContentResizing",triggerEventsWhileDragging:"triggerEventsDuringLiveResize",maskIframesOnResize:"maskContents",useStateCookie:"stateManagement.enabled","cookie.autoLoad":"stateManagement.autoLoad","cookie.autoSave":"stateManagement.autoSave","cookie.keys":"stateManagement.stateKeys","cookie.name":"stateManagement.cookie.name","cookie.domain":"stateManagement.cookie.domain","cookie.path":"stateManagement.cookie.path","cookie.expires":"stateManagement.cookie.expires","cookie.secure":"stateManagement.cookie.secure"},renameOptions:function(a){function g(b,c){var d=b.split("."),e=d.length-1,f={branch:a,key:d[e]},g=0,h,i;for(;g<e;g++)h=d[g],f.branch[h]==undefined?c?f.branch=f.branch[h]={}:f.branch={}:f.branch=f.branch[h];return f}var b=$.layout.backwardCompatibility.map,c,d,e;for(var f in b)c=g(f),e=c.branch[c.key],e!==undefined&&(d=g(b[f],!0),d.branch[d.key]=e,delete c.branch[c.key])},renameAllOptions:function(a){var b=$.layout.backwardCompatibility.renameOptions;return b(a),a.defaults&&(typeof a.panes!="object"&&(a.panes={}),$.extend(!0,a.panes,a.defaults),delete a.defaults),a.panes&&b(a.panes),$.each($.layout.config.allPanes,function(c,d){a[d]&&b(a[d])}),a}},$.fn.layout=function(opts){function keyDown(a){if(!a)return!0;var b=a.keyCode;if(b<33)return!0;var c={38:"north",40:"south",37:"west",39:"east"},d=a.altKey,e=a.shiftKey,f=a.ctrlKey,g=f&&b>=37&&b<=40,h,i,j,k;return g&&options[c[b]].enableCursorHotkey?k=c[b]:(f||e)&&$.each(_c.borderPanes,function(a,c){h=options[c],i=h.customHotkey,j=h.customHotkeyModifier;if(e&&j=="SHIFT"||f&&j=="CTRL"||f&&e)if(i&&b===(isNaN(i)||i<=9?i.toUpperCase().charCodeAt(0):i))return k=c,!1}),!k||!$Ps[k]||!options[k].closable||state[k].isHidden?!0:(toggle(k),a.stopPropagation(),a.returnValue=!1,!1)}function allowOverflow(a){if(!isInitialized())return;this&&this.tagName&&(a=this);var b;isStr(a)?b=$Ps[a]:$(a).data("layoutRole")?b=$(a):$(a).parents().each(function(){if($(this).data("layoutRole"))return b=$(this),!1});if(!b||!b.length)return;var c=b.data("layoutEdge"),d=state[c];d.cssSaved&&resetOverflow(c);if(d.isSliding||d.isResizing||d.isClosed){d.cssSaved=!1;return}var e={zIndex:options.zIndexes.resizer_normal+1},f={},g=b.css("overflow"),h=b.css("overflowX"),i=b.css("overflowY");g!="visible"&&(f.overflow=g,e.overflow="visible"),h&&!h.match(/visible|auto/)&&(f.overflowX=h,e.overflowX="visible"),i&&!i.match(/visible|auto/)&&(f.overflowY=h,e.overflowY="visible"),d.cssSaved=f,b.css(e),$.each(_c.allPanes,function(a,b){b!=c&&resetOverflow(b)})}function resetOverflow(a){if(!isInitialized())return;this&&this.tagName&&(a=this);var b;isStr(a)?b=$Ps[a]:$(a).data("layoutRole")?b=$(a):$(a).parents().each(function(){if($(this).data("layoutRole"))return b=$(this),!1});if(!b||!b.length)return;var c=b.data("layoutEdge"),d=state[c],e=d.cssSaved||{};!d.isSliding&&!d.isResizing&&b.css("zIndex",options.zIndexes.pane_normal),b.css(e),d.cssSaved=!1}var browser=$.layout.browser,lang=$.layout.language,_c=$.layout.config,cssW=$.layout.cssWidth,cssH=$.layout.cssHeight,elDims=$.layout.getElementDimensions,elCSS=$.layout.getElementCSS,options=$.extend(!0,{},$.layout.defaults),effects=options.effects=$.extend(!0,{},$.layout.effects),state={id:"layout"+$.now(),initialized:!1,container:{},north:{},south:{},east:{},west:{},center:{}},children={north:null,south:null,east:null,west:null,center:null},timer={data:{},set:function(a,b,c){timer.clear(a),timer.data[a]=setTimeout(b,c)},clear:function(a){var b=timer.data;b[a]&&(clearTimeout(b[a]),delete b[a])}},_log=function(a,b){$.layout.msg(a,b&&options.showErrorMessages)},_execCallback=function(pane,v_fn){if(!v_fn)return;var fn;try{if(typeof v_fn=="function")fn=v_fn;else{if(!isStr(v_fn))return;if(v_fn.match(/,/)){var args=v_fn.split(","),fn=eval(args[0]);if(typeof fn=="function"&&args.length>1)return fn(args[1])}else fn=eval(v_fn)}if($.isFunction(fn))return pane&&$Ps[pane]?fn(pane,$Ps[pane],state[pane],options[pane],options.name):fn(Instance,state,options,options.name)}catch(ex){}},trigger=function(a,b){var c=options,d=b&&c[b]?c[b][a]:c[a];d&&_execCallback(b||null,d)},_fixIframe=function(a){if(browser.mozilla)return;var b=$Ps[a];state[a].tagName==="IFRAME"?b.css(_c.hidden).css(_c.visible):b.find("IFRAME").css(_c.hidden).css(_c.visible)},cssSize=function(a,b){var c=_c[a].dir=="horz"?cssH:cssW;return c($Ps[a],b)},cssMinDims=function(a){var b=$Ps[a];return dir=_c[a].dir,d={minWidth:1001-cssW(b,1e3),minHeight:1001-cssH(b,1e3)},dir==="horz"&&(d.minSize=d.minHeight),dir==="vert"&&(d.minSize=d.minWidth),d},setOuterWidth=function(a,b,c){var d=a,e;isStr(a)?d=$Ps[a]:a.jquery||(d=$(a)),e=cssW(d,b),d.css({width:e}),e>0?c&&d.data("autoHidden")&&d.innerHeight()>0&&(d.show().data("autoHidden",!1),browser.mozilla||d.css(_c.hidden).css(_c.visible)):c&&!d.data("autoHidden")&&d.hide().data("autoHidden",!0)},setOuterHeight=function(a,b,c){var d=a,e;isStr(a)?d=$Ps[a]:a.jquery||(d=$(a)),e=cssH(d,b),d.css({height:e,visibility:"visible"}),e>0&&d.innerWidth()>0?c&&d.data("autoHidden")&&(d.show().data("autoHidden",!1),browser.mozilla||d.css(_c.hidden).css(_c.visible)):c&&!d.data("autoHidden")&&d.hide().data("autoHidden",!0)},setOuterSize=function(a,b,c){_c[pane].dir=="horz"?setOuterHeight(a,b,c):setOuterWidth(a,b,c)},_parseSize=function(a,b,c){c||(c=_c[a].dir),isStr(b)&&b.match(/%/)&&(b=b==="100%"?-1:parseInt(b,10)/100);if(b===0)return 0;if(b>=1)return parseInt(b,10);var d=options,e=0;c=="horz"?e=sC.innerHeight-($Ps.north?d.north.spacing_open:0)-($Ps.south?d.south.spacing_open:0):c=="vert"&&(e=sC.innerWidth-($Ps.west?d.west.spacing_open:0)-($Ps.east?d.east.spacing_open:0));if(b===-1)return e;if(b>0)return round(e*b);if(a=="center")return 0;var f=$Ps[a],g=c==="horz"?"height":"width",h=$.layout.showInvisibly(f),i=f.css(g);return f.css(g,"auto"),b=g==="height"?f.outerHeight():f.outerWidth(),f.css(g,i).css(h),b},getPaneSize=function(a,b){var c=$Ps[a],d=options[a],e=state[a],f=b?d.spacing_open:0,g=b?d.spacing_closed:0;return!c||e.isHidden?0:e.isClosed||e.isSliding&&b?g:_c[a].dir==="horz"?c.outerHeight()+f:c.outerWidth()+f},setSizeLimits=function(a,b){if(!isInitialized())return;var c=options[a],d=state[a],e=_c[a],f=e.dir,g=e.side.toLowerCase(),h=e.sizeType.toLowerCase(),i=b!=undefined?b:d.isSliding,j=$Ps[a],k=c.spacing_open,l=_c.oppositeEdge[a],m=state[l],n=$Ps[l],o=!n||m.isVisible===!1||m.isSliding?0:f=="horz"?n.outerHeight():n.outerWidth(),p=(!n||m.isHidden?0:options[l][m.isClosed!==!1?"spacing_closed":"spacing_open"])||0,q=f=="horz"?sC.innerHeight:sC.innerWidth,r=cssMinDims("center"),s=f=="horz"?max(options.center.minHeight,r.minHeight):max(options.center.minWidth,r.minWidth),t=q-k-(i?0:_parseSize("center",s,f)+o+p),u=d.minSize=max(_parseSize(a,c.minSize),cssMinDims(a).minSize),v=d.maxSize=min(c.maxSize?_parseSize(a,c.maxSize):1e5,t),w=d.resizerPosition={},x=sC.insetTop,y=sC.insetLeft,z=sC.innerWidth,A=sC.innerHeight,B=c.spacing_open;switch(a){case"north":w.min=x+u,w.max=x+v;break;case"west":w.min=y+u,w.max=y+v;break;case"south":w.min=x+A-v-B,w.max=x+A-u-B;break;case"east":w.min=y+z-v-B,w.max=y+z-u-B}},calcNewCenterPaneDims=function(){var a={top:getPaneSize("north",!0),bottom:getPaneSize("south",!0),left:getPaneSize("west",!0),right:getPaneSize("east",!0),width:0,height:0};return a.width=sC.innerWidth-a.left-a.right,a.height=sC.innerHeight-a.bottom-a.top,a.top+=sC.insetTop,a.bottom+=sC.insetBottom,a.left+=sC.insetLeft,a.right+=sC.insetRight,a},getHoverClasses=function(a,b){var c=$(a),d=c.data("layoutRole"),e=c.data("layoutEdge"),f=options[e],g=f[d+"Class"],h="-"+e,i="-open",j="-closed",k="-sliding",l="-hover ",m=c.hasClass(g+j)?j:i,n=m===j?i:j,o=g+l+(g+h+l)+(g+m+l)+(g+h+m+l);return b&&(o+=g+n+l+(g+h+n+l)),d=="resizer"&&c.hasClass(g+k)&&(o+=g+k+l+(g+h+k+l)),$.trim(o)},addHover=function(a,b){var c=$(b||this);a&&c.data("layoutRole")==="toggler"&&a.stopPropagation(),c.addClass(getHoverClasses(c))},removeHover=function(a,b){var c=$(b||this);c.removeClass(getHoverClasses(c,!0))},onResizerEnter=function(a){$.fn.disableSelection&&$("body").disableSelection()},onResizerLeave=function(a,b){var c=b||this,d=$(c).data("layoutEdge"),e=d+"ResizerLeave";timer.clear(d+"_openSlider"),timer.clear(e),b?!state[d].isResizing&&$.fn.enableSelection&&$("body").enableSelection():timer.set(e,function(){onResizerLeave(a,c)},200)},_create=function(){initOptions();var a=options;state.creatingLayout=!0,runPluginCallbacks(Instance,$.layout.onCreate);if(!1===_execCallback(null,a.onload_start))return"cancel";_initContainer(),initHotkeys(),$(window).bind("unload."+sID,unload),runPluginCallbacks(Instance,$.layout.onLoad);var b=$N.data("parentLayout");if(b){Instance.hasParentLayout=!0;var c=$N.data("layoutEdge");b[c].child=b.children[c]=Instance}return a.initPanes&&_initLayoutElements(),delete state.creatingLayout,state.initialized},isInitialized=function(){return state.initialized||state.creatingLayout?!0:_initLayoutElements()},_initLayoutElements=function(a){var b=options;if(!$N.is(":visible"))return!a&&browser.webkit&&$N[0].tagName==="BODY"&&setTimeout(function(){_initLayoutElements(!0)},50),!1;if(!getPane("center").length)return _log(lang.errCenterPaneMissing,!0),!1;state.creatingLayout=!0,$.extend(sC,elDims($N)),$N.data("layoutRole")==="pane"&&(b.resizeWithWindow=!1),initPanes();if(b.scrollToBookmarkOnLoad){var c=self.location;c.hash&&c.replace(c.hash)}return b.resizeWithWindow&&$(window).bind("resize."+sID,windowResize),delete state.creatingLayout,state.initialized=!0,runPluginCallbacks(Instance,$.layout.onReady),_execCallback(null,b.onload_end||b.onload),!0},_initChildLayouts=function(){$.each(_c.allPanes,function(a,b){options[b].initChildLayout&&createChildLayout(b)})},createChildLayout=function(a,b){var c=$Ps[a],d=b||options[a].childOptions,e=children,f="layout",g=c?e[a]=c.data(f)||null:!1;!g&&c&&d&&(g=e[a]=c.layout(d)||null),g&&(g.hasParentLayout=!0),Instance[a].child=e[a]},windowResize=function(){var a=Number(options.resizeWithWindowDelay);a<10&&(a=100),timer.clear("winResize"),timer.set("winResize",function(){timer.clear("winResize"),timer.clear("winResizeRepeater");var a=elDims($N);(a.innerWidth!==sC.innerWidth||a.innerHeight!==sC.innerHeight)&&resizeAll()},a),timer.data.winResizeRepeater||setWindowResizeRepeater()},setWindowResizeRepeater=function(){var a=Number(options.resizeWithWindowMaxDelay);a>0&&timer.set("winResizeRepeater",function(){setWindowResizeRepeater(),resizeAll()},a)},unload=function(){var a=options;_execCallback(null,a.onunload_start),runPluginCallbacks(Instance,$.layout.onUnload),_execCallback(null,a.onunload_end||a.onunload)},_initContainer=function(){var a=$N[0],b=sC.tagName=a.tagName,c=sC.id=a.id,d=sC.className=a.className,e=options,f=e.name,g=b==="BODY",h="overflow,position,margin,padding,border",i={},j="hidden";sC.selector=$N.selector.split(".slice")[0],sC.ref=(e.name?e.name+" layout / ":"")+b+(c?"#"+c:d?".["+d+"]":""),$N.data("layout",Instance).data("layoutContainer",sID).addClass(e.containerClass);var k="layoutCSS";if(!$N.data(k)){if(g){i=$.extend(elCSS($N,h),{height:$N.css("height"),overflow:$N.css("overflow"),overflowX:$N.css("overflowX"),overflowY:$N.css("overflowY")});var l=$("html");l.data(k,{height:"auto",overflow:l.css("overflow"),overflowX:l.css("overflowX"),overflowY:l.css("overflowY")})}else i=elCSS($N,h+",top,bottom,left,right,width,height,overflow,overflowX,overflowY");$N.data(k,i)}try{if(g)$("html").css({height:"100%",overflow:j,overflowX:j,overflowY:j}),$("body").css({position:"relative",height:"100%",overflow:j,overflowX:j,overflowY:j,margin:0,padding:0,border:"none"}),$.extend(sC,elDims($N));else{i={overflow:j,overflowX:j,overflowY:j};var m=$N.css("position"),n=$N.css("height");!$N.data("layoutRole")&&(!m||!m.match(/fixed|absolute|relative/))&&(i.position="relative"),$N.css(i),$N.is(":visible")&&($.extend(sC,elDims($N)),e.showErrorMessages&&sC.innerHeight<1&&_log(lang.errContainerHeight.replace(/CONTAINER/,sC.ref),!0))}}catch(o){}},initHotkeys=function(a){a=a?a.split(","):_c.borderPanes,$.each(a,function(a,b){var c=options[b];if(c.enableCursorHotkey||c.customHotkey)return $(document).bind("keydown."+sID,keyDown),!1})},initOptions=function(){function l(a){var b=options[a],c=options.panes;b.fxSettings||(b.fxSettings={}),c.fxSettings||(c.fxSettings={}),$.each(["_open","_close","_size"],function(d,e){var f="fxName"+e,g="fxSpeed"+e,h="fxSettings"+e,i=b[f]=b[f]||c[f]||b.fxName||c.fxName||"none";if(i==="none"||!$.effects||!$.effects[i]||!options.effects[i])i=b[f]="none";var j=options.effects[i]||{},k=j.all||null,l=j[a]||null;b[g]=b[g]||c[g]||b.fxSpeed||c.fxSpeed||null,b[h]=$.extend({},k,l,c.fxSettings,b.fxSettings,c[h],b[h])}),delete b.fxName,delete b.fxSpeed,delete b.fxSettings}var a,b,c,d,e,f,g,h;opts=$.layout.transformData(opts),opts=$.layout.backwardCompatibility.renameAllOptions(opts);if(!$.isEmptyObject(opts.panes)){a=$.layout.optionsMap.noDefault;for(f=0,g=a.length;f<g;f++)d=a[f],delete opts.panes[d];a=$.layout.optionsMap.layout;for(f=0,g=a.length;f<g;f++)d=a[f],delete opts.panes[d]}a=$.layout.optionsMap.layout;var i=$.layout.config.optionRootKeys;for(d in opts)e=opts[d],$.inArray(d,i)<0&&$.inArray(d,a)<0&&(opts.panes[d]||(opts.panes[d]=$.isPlainObject(e)?$.extend(!0,{},e):e),delete opts[d]);$.extend(!0,options,opts),$.each(_c.allPanes,function(c,e){_c[e]=$.extend(!0,{},_c.panes,_c[e]),b=options.panes,h=options[e];if(e==="center"){a=$.layout.optionsMap.center;for(c=0,g=a.length;c<g;c++)d=a[c],!opts.center[d]&&(opts.panes[d]||!h[d])&&(h[d]=b[d])}else h=options[e]=$.extend({},b,h),l(e),h.resizerClass||(h.resizerClass="ui-layout-resizer"),h.togglerClass||(h.togglerClass="ui-layout-toggler");h.paneClass||(h.paneClass="ui-layout-pane")});var j=opts.zIndex,k=options.zIndexes;j>0&&(k.pane_normal=j,k.content_mask=max(j+1,k.content_mask),k.resizer_normal=max(j+2,k.resizer_normal)),delete options.panes},getPane=function(a){var b=options[a].paneSelector;if(b.substr(0,1)==="#")return $N.find(b).eq(0);var c=$N.children(b).eq(0);return c.length?c:$N.children("form:first").children(b).eq(0)},initPanes=function(){$.each(_c.allPanes,function(a,b){addPane(b,!0)}),initHandles(),$.each(_c.borderPanes,function(a,b){$Ps[b]&&state[b].isVisible&&(setSizeLimits(b),makePaneFit(b))}),sizeMidPanes("center"),$.each(_c.allPanes,function(a,b){var c=options[b];$Ps[b]&&(state[b].isVisible&&(sizeContent(b),c.triggerEventsOnLoad&&_execCallback(b,c.onresize_end||c.onresize),resizeChildLayout(b)),c.initChildLayout&&c.childOptions&&createChildLayout(b))})},addPane=function(a,b){if(!b&&!isInitialized())return;var c=options[a],d=state[a],e=_c[a],f=d.fx,g=e.dir,h=c.spacing_open||0,i=a==="center",j={},k=$Ps[a],l,m,n;k?removePane(a,!1,!0,!1):$Cs[a]=!1,k=$Ps[a]=getPane(a);if(!k.length){$Ps[a]=!1;return}if(!k.data("layoutCSS")){var o="position,top,left,bottom,right,width,height,overflow,zIndex,display,backgroundColor,padding,margin,border";k.data("layoutCSS",elCSS(k,o))}k.data("parentLayout",Instance).data("layoutRole","pane").data("layoutEdge",a).css(e.cssReq).css("zIndex",options.zIndexes.pane_normal).css(c.applyDemoStyles?e.cssDemo:{}).addClass(c.paneClass+" "+c.paneClass+"-"+a).bind("mouseenter."+sID,addHover).bind("mouseleave."+sID,removeHover),Instance[a]={name:a,pane:$Ps[a],options:options[a],state:state[a],child:children[a]},initContent(a,!1),i||(l=d.size=_parseSize(a,c.size),m=_parseSize(a,c.minSize)||1,n=_parseSize(a,c.maxSize)||1e5,l>0&&(l=max(min(l,n),m)),d.isClosed=!1,d.isSliding=!1,d.isResizing=!1,d.isHidden=!1,d.pins||(d.pins=[])),d.tagName=k[0].tagName,d.edge=a,d.noRoom=!1,d.isVisible=!0;switch(a){case"north":j.top=sC.insetTop,j.left=sC.insetLeft,j.right=sC.insetRight;break;case"south":j.bottom=sC.insetBottom,j.left=sC.insetLeft,j.right=sC.insetRight;break;case"west":j.left=sC.insetLeft;break;case"east":j.right=sC.insetRight;break;case"center":}g==="horz"?j.height=cssH(k,l):g==="vert"&&(j.width=cssW(k,l)),k.css(j),g!="horz"&&sizeMidPanes(a,!0),c.initClosed&&c.closable&&!c.initHidden?close(a,!0,!0):c.initHidden||c.initClosed?hide(a):d.noRoom||k.css("display","block"),k.css("visibility","visible"),c.showOverflowOnHover&&k.hover(allowOverflow,resetOverflow),state.initialized&&(initHandles(a),initHotkeys(a),resizeAll(),d.isVisible&&(c.triggerEventsOnLoad&&_execCallback(a,c.onresize_end||c.onresize),resizeChildLayout(a)),c.initChildLayout&&c.childOptions&&createChildLayout(a))},initHandles=function(a){a=a?a.split(","):_c.borderPanes,$.each(a,function(a,b){var c=$Ps[b];$Rs[b]=!1,$Ts[b]=!1;if(!c)return;var d=options[b],e=state[b],f=_c[b],g=d.resizerClass,h=d.togglerClass,i=f.side.toLowerCase(),j=e.isVisible?d.spacing_open:d.spacing_closed,k="-"+b,l=e.isVisible?"-open":"-closed",m=Instance[b],n=m.resizer=$Rs[b]=$("<div></div>"),o=m.toggler=d.closable?$Ts[b]=$("<div></div>"):!1;!e.isVisible&&d.slidable&&n.attr("title",d.sliderTip).css("cursor",d.sliderCursor),n.attr("id",d.paneSelector.substr(0,1)=="#"?d.paneSelector.substr(1)+"-resizer":"").data("parentLayout",Instance).data("layoutRole","resizer").data("layoutEdge",b).css(_c.resizers.cssReq).css("zIndex",options.zIndexes.resizer_normal).css(d.applyDemoStyles?_c.resizers.cssDemo:{}).addClass(g+" "+g+k).hover(addHover,removeHover).hover(onResizerEnter,onResizerLeave).appendTo($N),o&&(o.attr("id",d.paneSelector.substr(0,1)=="#"?d.paneSelector.substr(1)+"-toggler":"").data("parentLayout",Instance).data("layoutRole","toggler").data("layoutEdge",b).css(_c.togglers.cssReq).css(d.applyDemoStyles?_c.togglers.cssDemo:{}).addClass(h+" "+h+k).hover(addHover,removeHover).bind("mouseenter",onResizerEnter).appendTo(n),d.togglerContent_open&&$("<span>"+d.togglerContent_open+"</span>").data("layoutRole","togglerContent").data("layoutEdge",b).addClass("content content-open").css("display","none").appendTo(o),d.togglerContent_closed&&$("<span>"+d.togglerContent_closed+"</span>").data("layoutRole","togglerContent").data("layoutEdge",b).addClass("content content-closed").css("display","none").appendTo(o),enableClosable(b)),initResizable(b),e.isVisible?setAsOpen(b):(setAsClosed(b),bindStartSlidingEvent(b,!0))}),sizeHandles()},initContent=function(a,b){if(!isInitialized())return;var c=options[a],d=c.contentSelector,e=Instance[a],f=$Ps[a],g;d&&(g=e.content=$Cs[a]=c.findNestedContent?f.find(d).eq(0):f.children(d).eq(0)),g&&g.length?(g.data("layoutRole","content"),g.data("layoutCSS")||g.data("layoutCSS",elCSS(g,"height")),g.css(_c.content.cssReq),c.applyDemoStyles&&(g.css(_c.content.cssDemo),f.css(_c.content.cssDemoPane)),state[a].content={},b!==!1&&sizeContent(a)):e.content=$Cs[a]=!1},initResizable=function(a){var b=$.layout.plugins.draggable,c;a=a?a.split(","):_c.borderPanes,$.each(a,function(a,c){var e=options[c];if(!b||!$Ps[c]||!e.resizable)return e.resizable=!1,!0;var f=state[c],g=options.zIndexes,h=_c[c],i=h.dir=="horz"?"top":"left",j=_c.oppositeEdge[c],k=c+",center,"+j+(h.dir=="horz"?",west,east":""),l=$Ps[c],m=$Rs[c],n=e.resizerClass,o=0,p,q,r=n+"-drag",s=n+"-"+c+"-drag",t=n+"-dragging",u=n+"-"+c+"-dragging",v=n+"-dragging-limit",w=n+"-"+c+"-dragging-limit",x=!1;f.isClosed||m.attr("title",e.resizerTip).css("cursor",e.resizerCursor),m.draggable({containment:$N[0],axis:h.dir=="horz"?"y":"x",delay:0,distance:1,grid:e.resizingGrid,helper:"clone",opacity:e.resizerDragOpacity,addClasses:!1,zIndex:g.resizer_drag,start:function(a,b){e=options[c],f=state[c],q=e.livePaneResizing;if(!1===_execCallback(c,e.ondrag_start))return!1;f.isResizing=!0,timer.clear(c+"_closeSlider"),setSizeLimits(c),p=f.resizerPosition,o=b.position[i],m.addClass(r+" "+s),x=!1,$("body").disableSelection(),showMasks(k)},drag:function(a,b){x||(b.helper.addClass(t+" "+u).css({right:"auto",bottom:"auto"}).children().css("visibility","hidden"),x=!0,f.isSliding&&$Ps[c].css("zIndex",g.pane_sliding));var h=0;b.position[i]<p.min?(b.position[i]=p.min,h=-1):b.position[i]>p.max&&(b.position[i]=p.max,h=1),h?(b.helper.addClass(v+" "+w),window.defaultStatus=h>0&&c.match(/north|west/)||h<0&&c.match(/south|east/)?lang.maxSizeWarning:lang.minSizeWarning):(b.helper.removeClass(v+" "+w),window.defaultStatus=""),q&&Math.abs(b.position[i]-o)>=e.liveResizingTolerance&&(o=b.position[i],d(a,b,c))},stop:function(a,b){$("body").enableSelection(),window.defaultStatus="",m.removeClass(r+" "+s),f.isResizing=!1,d(a,b,c,!0,k)}})});var d=function(a,b,c,d,e){var f=b.position,g=_c[c],h=options[c],i=state[c],j;switch(c){case"north":j=f.top;break;case"west":j=f.left;break;case"south":j=sC.offsetHeight-f.top-h.spacing_open;break;case"east":j=sC.offsetWidth-f.left-h.spacing_open}var k=j-sC["inset"+g.side];if(!d){if(Math.abs(k-i.size)<h.liveResizingTolerance)return;manualSizePane(c,k,!1,!0),sizeMasks()}else!1!==_execCallback(c,h.ondrag_end||h.ondrag)&&manualSizePane(c,k,!1,!0),hideMasks(),i.isSliding&&e&&showMasks(e,!0)}},sizeMask=function(){var a=$(this),b=a.data("layoutMask"),c=state[b];c.tagName=="IFRAME"&&c.isVisible&&a.css({top:c.offsetTop,left:c.offsetLeft,width:c.outerWidth,height:c.outerHeight})},sizeMasks=function(){$Ms.each(sizeMask)},showMasks=function(a,b){var c=a?a.split(","):$.layout.config.allPanes,d=options.zIndexes,e,f;$.each(c,function(a,c){f=state[c],e=options[c],f.isVisible&&(!b&&e.maskContents||e.maskObjects)&&getMasks(c).each(function(){sizeMask.apply(this),this.style.zIndex=f.isSliding?d.pane_sliding+1:d.pane_normal+1,this.style.display="block"})})},hideMasks=function(){var a;$.each($.layout.config.borderPanes,function(b,c){if(state[c].isResizing)return a=!0,!1}),a||$Ms.hide()},getMasks=function(a){var b=$([]),c,d=0,e=$Ms.length;for(;d<e;d++)c=$Ms.eq(d),c.data("layoutMask")===a&&(b=b.add(c));return b.length?b:createMasks(a)},createMasks=function(a){var b=$Ps[a],c=state[a],d=options[a],e=options.zIndexes,f=$([]),g,h,i,j,k;if(!d.maskContents&&!d.maskObjects)return f;for(k=0;k<(d.maskObjects?2:1);k++)g=d.maskObjects&&k==0,h=document.createElement(g?"iframe":"div"),i=$(h).data("layoutMask",a),h.className="ui-layout-mask ui-layout-mask-"+a,j=h.style,j.display="block",j.position="absolute",g&&(h.frameborder=0,h.src="about:blank",j.opacity=0,j.filter="Alpha(Opacity='0')",j.border=0),c.tagName=="IFRAME"?(j.zIndex=e.pane_normal+1,$N.append(h)):(i.addClass("ui-layout-mask-inside-pane"),j.zIndex=d.maskZindex||e.content_mask,j.top=0,j.left=0,j.width="100%",j.height="100%",b.append(h)),f=f.add(h),$Ms=$Ms.add(h);return f},destroy=function(a){$(window).unbind("."+sID),$(document).unbind("."+sID),$N.clearQueue().removeData("layout").removeData("layoutContainer").removeClass(options.containerClass),$Ms.remove(),$.each(_c.allPanes,function(b,c){removePane(c,!1,!0,a)});var b="layoutCSS";$N.data(b)&&!$N.data("layoutRole")&&$N.css($N.data(b)).removeData(b),sC.tagName==="BODY"&&($N=$("html")).data(b)&&$N.css($N.data(b)).removeData(b),runPluginCallbacks(Instance,$.layout.onDestroy),unload();for(n in Instance)n.match(/^(container|options)$/)||delete Instance[n];Instance.destroyed=!0},removePane=function(a,b,c,d){if(!isInitialized())return;var e=$Ps[a],f=$Cs[a],g=$Rs[a],h=$Ts[a];e&&$.isEmptyObject(e.data())&&(e=!1),f&&$.isEmptyObject(f.data())&&(f=!1),g&&$.isEmptyObject(g.data())&&(g=!1),h&&$.isEmptyObject(h.data())&&(h=!1),e&&e.stop(!0,!0);var i=options[a],j=state[a],k="layout",l="layoutCSS",m=children[a]||(e?e.data(k):0)||(f?f.data(k):0)||null,n=d!==undefined?d:i.destroyChildLayout;n&&m&&!m.destroyed&&(m.destroy(!0),m.destroyed&&(m=null));if(e&&b&&!m)e.remove();else if(e){var o=i.paneClass,p=o+"-"+a,q="-open",r="-sliding",s="-closed",t=[o,o+q,o+s,o+r,p,p+q,p+s,p+r];$.merge(t,getHoverClasses(e,!0)),e.removeClass(t.join(" ")).removeData("layoutParent").removeData("layoutRole").removeData("layoutEdge").removeData("autoHidden").unbind("."+sID),f&&f.data(k)?(f.width(f.width()),m.resizeAll()):f&&f.css(f.data(l)).removeData(l).removeData("layoutRole"),e.data(k)||e.css(e.data(l)).removeData(l)}h&&h.remove(),g&&g.remove(),Instance[a]=$Ps[a]=$Cs[a]=$Rs[a]=$Ts[a]=children[a]=!1,j={removed:!0},c||resizeAll()},hide=function(a,b){if(!isInitialized())return;var c=options[a],d=state[a],e=$Ps[a],f=$Rs[a];if(!e||d.isHidden)return;if(state.initialized&&!1===_execCallback(a,c.onhide_start))return;d.isSliding=!1,f&&f.hide(),!state.initialized||d.isClosed?(d.isClosed=!0,d.isHidden=!0,d.isVisible=!1,e.hide(),sizeMidPanes(_c[a].dir==="horz"?"":"center"),(state.initialized||c.triggerEventsOnLoad)&&_execCallback(a,c.onhide_end||c.onhide)):(d.isHiding=!0,close(a,!1,b))},show=function(a,b,c,d){if(!isInitialized())return;var e=options[a],f=state[a],g=$Ps[a],h=$Rs[a];if(!g||!f.isHidden)return;if(!1===_execCallback(a,e.onshow_start))return;f.isSliding=!1,f.isShowing=!0,b===!1?close(a,!0):open(a,!1,c,d)},toggle=function(a,b){if(!isInitialized())return;isStr(a)||(a.stopImmediatePropagation(),a=$(this).data("layoutEdge"));var c=state[a];c.isHidden?show(a):c.isClosed?open(a,!!b):close(a)},_closePane=function(a,b){var c=$Ps[a],d=state[a];c.hide(),d.isClosed=!0,d.isVisible=!1},close=function(a,b,c,d){function o(){i.isMoving=!1,bindStartSlidingEvent(a,!0);var b=_c.oppositeEdge[a];state[b].noRoom&&(setSizeLimits(b),makePaneFit(b)),hideMasks(),!d&&(state.initialized||h.triggerEventsOnLoad)&&(l||_execCallback(a,h.onclose_end||h.onclose),l&&_execCallback(a,h.onshow_end||h.onshow),m&&_execCallback(a,h.onhide_end||h.onhide))}if(!state.initialized&&$Ps[a]){_closePane(a);return}if(!isInitialized())return;var e=$Ps[a],f=$Rs[a],g=$Ts[a],h=options[a],i=state[a],j=_c[a],k,l,m,n;$N.queue(function(d){if(!e||!h.closable&&!i.isShowing&&!i.isHiding||!b&&i.isClosed&&!i.isShowing)return d();l=i.isShowing,m=i.isHiding,n=i.isSliding,delete i.isShowing,delete i.isHiding;if(!l&&!1===_execCallback(a,h.onclose_start))return d();k=!c&&!i.isClosed&&h.fxName_close!="none",i.isMoving=!0,i.isClosed=!0,i.isVisible=!1,m?i.isHidden=!0:l&&(i.isHidden=!1),i.isSliding?bindStopSlidingEvents(a,!1):sizeMidPanes(_c[a].dir==="horz"?"":"center",!1),setAsClosed(a);if(k){var f="center"+(j.dir=="horz"?",west,east":"");showMasks(f,!0),lockPaneForFX(a,!0),e.hide(h.fxName_close,h.fxSettings_close,h.fxSpeed_close,function(){lockPaneForFX(a,!1),i.isClosed&&o(),d()})}else e.hide(),o(),d()})},setAsClosed=function(a){var b=$Ps[a],c=$Rs[a],d=$Ts[a],e=options[a],f=state[a],g=_c[a].side.toLowerCase(),h="inset"+_c[a].side,i=e.resizerClass,j=e.togglerClass,k="-"+a,l="-open",m="-sliding",n="-closed";c.css(g,sC[h]).removeClass(i+l+" "+i+k+l).removeClass(i+m+" "+i+k+m).addClass(i+n+" "+i+k+n).unbind("dblclick."+sID),e.resizable&&$.layout.plugins.draggable&&c.draggable("disable").removeClass("ui-state-disabled").css("cursor","default").attr("title",""),d&&(d.removeClass(j+l+" "+j+k+l).addClass(j+n+" "+j+k+n).attr("title",e.togglerTip_closed),d.children(".content-open").hide(),d.children(".content-closed").css("display","block")),syncPinBtns(a,!1),state.initialized&&sizeHandles()},open=function(a,b,c,d){function m(){i.isMoving=!1,_fixIframe(a),i.isSliding||(hideMasks(),sizeMidPanes(_c[a].dir=="vert"?"center":"",!1)),setAsOpen(a)}if(!isInitialized())return;var e=$Ps[a],f=$Rs[a],g=$Ts[a],h=options[a],i=state[a],j=_c[a],k,l;$N.queue(function(f){if(!e||!h.resizable&&!h.closable&&!i.isShowing||i.isVisible&&!i.isSliding)return f();if(i.isHidden&&!i.isShowing){show(a,!0);return}h.autoResize&&i.size!=h.size?sizePane(a,h.size,!0,!0,!0):setSizeLimits(a,b);if(!1===_execCallback(a,h.onopen_start))return;setSizeLimits(a,b);if(i.minSize>i.maxSize)return syncPinBtns(a,!1),!d&&h.noRoomToOpenTip&&alert(h.noRoomToOpenTip),f();b?bindStopSlidingEvents(a,!0):i.isSliding?bindStopSlidingEvents(a,!1):h.slidable&&bindStartSlidingEvent(a,!1),i.noRoom=!1,makePaneFit(a),l=i.isShowing,delete i.isShowing,k=!c&&i.isClosed&&h.fxName_open!="none",i.isMoving=!0,i.isVisible=!0,i.isClosed=!1,l&&(i.isHidden=!1);if(k){var g="center"+(j.dir=="horz"?",west,east":"");i.isSliding&&(g+=","+_c.oppositeEdge[a]),showMasks(g,!0),lockPaneForFX(a,!0),e.show(h.fxName_open,h.fxSettings_open,h.fxSpeed_open,function(){lockPaneForFX(a,!1),i.isVisible&&m(),f()})}else e.show(),m(),f()})},setAsOpen=function(a,b){var c=$Ps[a],d=$Rs[a],e=$Ts[a],f=options[a],g=state[a],h=_c[a].side.toLowerCase(),i="inset"+_c[a].side,j=f.resizerClass,k=f.togglerClass,l="-"+a,m="-open",n="-closed",o="-sliding";d.css(h,sC[i]+getPaneSize(a)).removeClass(j+n+" "+j+l+n).addClass(j+m+" "+j+l+m),g.isSliding?d.addClass(j+o+" "+j+l+o):d.removeClass(j+o+" "+j+l+o),f.resizerDblClickToggle&&d.bind("dblclick",toggle),removeHover(0,d),f.resizable&&$.layout.plugins.draggable?d.draggable("enable").css("cursor",f.resizerCursor).attr("title",f.resizerTip):g.isSliding||d.css("cursor","default"),e&&(e.removeClass(k+n+" "+k+l+n).addClass(k+m+" "+k+l+m).attr("title",f.togglerTip_open),removeHover(0,e),e.children(".content-closed").hide(),e.children(".content-open").css("display","block")),syncPinBtns(a,!g.isSliding),$.extend(g,elDims(c)),state.initialized&&(sizeHandles(),sizeContent(a,!0)),!b&&(state.initialized||f.triggerEventsOnLoad)&&c.is(":visible")&&(_execCallback(a,f.onopen_end||f.onopen),g.isShowing&&_execCallback(a,f.onshow_end||f.onshow),state.initialized&&(_execCallback(a,f.onresize_end||f.onresize),resizeChildLayout(a)))},slideOpen=function(a){function f(){d.isClosed?d.isMoving||open(c,!0):bindStopSlidingEvents(c,!0)}if(!isInitialized())return;var b=isStr(a)?null:a,c=b?$(this).data("layoutEdge"):a,d=state[c],e=options[c].slideDelay_open;b&&b.stopImmediatePropagation(),d.isClosed&&b&&b.type==="mouseenter"&&e>0?timer.set(c+"_openSlider",f,e):f()},slideClose=function(a){function g(){e.isClosed?bindStopSlidingEvents(c,!1):e.isMoving||close(c)}if(!isInitialized())return;var b=isStr(a)?null:a,c=b?$(this).data("layoutEdge"):a,d=options[c],e=state[c],f=e.isMoving?1e3:300;if(e.isClosed||e.isResizing)return;if(d.slideTrigger_close==="click")g();else{if(d.preventQuickSlideClose&&e.isMoving)return;if(d.preventPrematureSlideClose&&b&&$.layout.isMouseOverElem(b,$Ps[c]))return;b?timer.set(c+"_closeSlider",g,max(d.slideDelay_close,f)):g()}},slideToggle=function(a){toggle(a,!0)},lockPaneForFX=function(a,b){var c=$Ps[a],d=state[a],e=options[a],f=options.zIndexes;b?(c.css({zIndex:f.pane_animate}),a=="south"?c.css({top:sC.insetTop+sC.innerHeight-c.outerHeight()}):a=="east"&&c.css({left:sC.insetLeft+sC.innerWidth-c.outerWidth()})):(c.css({zIndex:d.isSliding?f.pane_sliding:f.pane_normal}),a=="south"?c.css({top:"auto"}):a=="east"&&c.css({left:"auto"}),browser.msie&&e.fxOpacityFix&&e.fxName_open!="slide"&&c.css("filter")&&c.css("opacity")==1&&c[0].style.removeAttribute("filter"))},bindStartSlidingEvent=function(a,b){var c=options[a],d=$Ps[a],e=$Rs[a],f=c.slideTrigger_open.toLowerCase();if(!e||b&&!c.slidable)return;f.match(/mouseover/)?f=c.slideTrigger_open="mouseenter":f.match(/click|dblclick|mouseenter/)||(f=c.slideTrigger_open="click"),e[b?"bind":"unbind"](f+"."+sID,slideOpen).css("cursor",b?c.sliderCursor:"default").attr("title",b?c.sliderTip:"")},bindStopSlidingEvents=function(a,b){function k(b){timer.clear(a+"_closeSlider"),b.stopPropagation()}var c=options[a],d=state[a],e=_c[a],f=options.zIndexes,g=c.slideTrigger_close.toLowerCase(),h=b?"bind":"unbind",i=$Ps[a],j=$Rs[a];d.isSliding=b,timer.clear(a+"_closeSlider"),b&&bindStartSlidingEvent(a,!1),i.css("zIndex",b?f.pane_sliding:f.pane_normal),j.css("zIndex",b?f.pane_sliding+2:f.resizer_normal),g.match(/click|mouseleave/)||(g=c.slideTrigger_close="mouseleave"),j[h](g,slideClose),g==="mouseleave"&&(i[h]("mouseleave."+sID,slideClose),j[h]("mouseenter."+sID,k),i[h]("mouseenter."+sID,k)),b?g==="click"&&!c.resizable&&(j.css("cursor",b?c.sliderCursor:"default"),j.attr("title",b?c.togglerTip_open:"")):timer.clear(a+"_closeSlider")},makePaneFit=function(a,b,c,d){var e=options[a],f=state[a],g=_c[a],h=$Ps[a],i=$Rs[a],j=g.dir==="vert",k=!1;if(a==="center"||j&&f.noVerticalRoom)k=f.maxHeight>=0,k&&f.noRoom?(h.show(),i&&i.show(),f.isVisible=!0,f.noRoom=!1,j&&(f.noVerticalRoom=!1),_fixIframe(a)):!k&&!f.noRoom&&(h.hide(),i&&i.hide(),f.isVisible=!1,f.noRoom=!0);if(a!=="center")if(f.minSize<=f.maxSize){k=!0;if(f.size>f.maxSize)sizePane(a,f.maxSize,c,d,!0);else if(f.size<f.minSize)sizePane(a,f.minSize,c,d,!0);else if(i&&h.is(":visible")){var l=g.side.toLowerCase(),m=f.size+sC["inset"+g.side];$.layout.cssNum(i,l)!=m&&i.css(l,m)}f.noRoom&&(f.wasOpen&&e.closable?e.autoReopen?open(a,!1,!0,!0):f.noRoom=!1:show(a,f.wasOpen,!0,!0))}else f.noRoom||(f.noRoom=!0,f.wasOpen=!f.isClosed&&!f.isSliding,f.isClosed||(e.closable?close(a,!0,!0):hide(a,!0)))},manualSizePane=function(a,b,c,d){if(!isInitialized())return;var e=options[a],f=state[a],g=e.livePaneResizing&&!f.isResizing;e.autoResize=!1,sizePane(a,b,c,g,d)},sizePane=function(a,b,c,d,e){function q(){var e=k==="width"?h.outerWidth():h.outerHeight(),n=[{pane:a,count:1,target:b,actual:e,correct:b===e,attempt:b,cssSize:p}],q=n[0],r="Inaccurate size after resizing the "+a+"-pane.";while(!q.correct){thisTry={pane:a,count:q.count+1,target:b},q.actual>b?thisTry.attempt=max(0,q.attempt-(q.actual-b)):thisTry.attempt=max(0,q.attempt+(b-q.actual)),thisTry.cssSize=cssSize(a,thisTry.attempt),h.css(k,thisTry.cssSize),thisTry.actual=k=="width"?h.outerWidth():h.outerHeight(),thisTry.correct=b===thisTry.actual,options.showDebugMessages&&(n.length===1&&(_log(r,!1),_log(q,!1)),_log(thisTry,!1));if(n.length>3)break;n.push(thisTry),q=n[n.length-1]}g.size=b,$.extend(g,elDims(h)),i&&h.is(":visible")&&i.css(j,b+sC[l]),sizeContent(a),!c&&!m&&state.initialized&&g.isVisible&&(_execCallback(a,f.onresize_end||f.onresize),resizeChildLayout(a)),c||(g.isSliding||sizeMidPanes(_c[a].dir=="horz"?"":"center",m,d),sizeHandles());var t=_c.oppositeEdge[a];b<o&&state[t].noRoom&&(setSizeLimits(t),makePaneFit(t,!1,c)),options.showDebugMessages&&n.length>1&&_log(r+"\nSee the Error Console for details.",!0)}if(!isInitialized())return;var f=options[a],g=state[a],h=$Ps[a],i=$Rs[a],j=_c[a].side.toLowerCase(),k=_c[a].sizeType.toLowerCase(),l="inset"+_c[a].side,m=g.isResizing&&!f.triggerEventsDuringLiveResize,n=e!==!0&&f.animatePaneSizing,o,p;$N.queue(function(e){setSizeLimits(a),o=g.size,b=_parseSize(a,b),b=max(b,_parseSize(a,f.minSize)),b=min(b,g.maxSize);if(b<g.minSize)return makePaneFit(a,!1,c),e();if(!d&&b===o)return e();!c&&state.initialized&&g.isVisible&&_execCallback(a,f.onresize_start),p=cssSize(a,b);if(n&&h.is(":visible")){var i=$.layout.effects.size[a]||$.layout.effects.size.all,j=f.fxSettings_size.easing||i.easing,l=options.zIndexes,m={};m[k]=p+"px",g.isMoving=!0,h.css({zIndex:l.pane_animate}).show().animate(m,f.fxSpeed_size,j,function(){h.css({zIndex:g.isSliding?l.pane_sliding:l.pane_normal}),g.isMoving=!1,q(),e()})}else h.css(k,p),h.is(":visible")?q():(g.size=b,$.extend(g,elDims(h))),e()})},sizeMidPanes=function(a,b,c){a=(a?a:"east,west,center").split(","),$.each(a,function(a,d){if(!$Ps[d])return;var e=options[d],f=state[d],g=$Ps[d],h=$Rs[d],i=d=="center",j=!0,k={},l=calcNewCenterPaneDims();$.extend(f,elDims(g));if(d==="center"){if(!c&&f.isVisible&&l.width===f.outerWidth&&l.height===f.outerHeight)return!0;$.extend(f,cssMinDims(d),{maxWidth:l.width,maxHeight:l.height}),k=l,k.width=cssW(g,k.width),k.height=cssH(g,k.height),j=k.width>=0&&k.height>=0;if(!state.initialized&&e.minWidth>f.outerWidth){var m=e.minWidth-f.outerWidth,n=options.east.minSize||0,o=options.west.minSize||0,p=state.east.size,q=state.west.size,r=p,s=q;m>0&&state.east.isVisible&&p>n&&(r=max(p-n,p-m),m-=p-r),m>0&&state.west.isVisible&&q>o&&(s=max(q-o,q-m),m-=q-s);if(m===0){p!=n&&sizePane("east",r,!0,c,!0),q!=o&&sizePane("west",s,!0,c,!0),sizeMidPanes("center",b,c);return}}}else{f.isVisible&&!f.noVerticalRoom&&$.extend(f,elDims(g),cssMinDims(d));if(!c&&!f.noVerticalRoom&&l.height===f.outerHeight)return!0;k.top=l.top,k.bottom=l.bottom,k.height=cssH(g,l.height),f.maxHeight=k.height,j=f.maxHeight>=0,j||(f.noVerticalRoom=!0)}j?(!b&&state.initialized&&_execCallback(d,e.onresize_start),g.css(k),f.noRoom&&!f.isClosed&&!f.isHidden&&makePaneFit(d),f.isVisible&&($.extend(f,elDims(g)),state.initialized&&sizeContent(d))):!f.noRoom&&f.isVisible&&makePaneFit(d);if(!f.isVisible)return!0;if(d==="center"){var t=$.layout.browser,u=t.isIE6||t.msie&&!$.support.boxModel;$Ps.north&&(u||state.north.tagName=="IFRAME")&&$Ps.north.css("width",cssW($Ps.north,sC.innerWidth)),$Ps.south&&(u||state.south.tagName=="IFRAME")&&$Ps.south.css("width",cssW($Ps.south,sC.innerWidth))}!b&&state.initialized&&(_execCallback(d,e.onresize_end||e.onresize),resizeChildLayout(d))})},resizeAll=function(){if(!state.initialized){_initLayoutElements();return}var a=sC.innerWidth,b=sC.innerHeight;if(!$N.is(":visible:"))return;$.extend(state.container,elDims($N));if(!sC.outerHeight)return;if(!1===_execCallback(null,options.onresizeall_start))return!1;var c=sC.innerHeight<b,d=sC.innerWidth<a,e,f,g,h;$.each(["south","north","east","west"],function(a,b){if(!$Ps[b])return;g=state[b],f=options[b],h=_c[b].dir,f.autoResize&&g.size!=f.size?sizePane(b,f.size,!0,!0,!0):(setSizeLimits(b),makePaneFit(b,!1,!0,!0))}),sizeMidPanes("",!0,!0),sizeHandles(),f=options,$.each(_c.allPanes,function(a,b){e=$Ps[b];if(!e)return;state[b].isVisible&&(_execCallback(b,f[b].onresize_end||f[b].onresize),resizeChildLayout(b))}),_execCallback(null,f.onresizeall_end||f.onresizeall)},resizeChildLayout=function(a){if(!options[a].resizeChildLayout)return;var b=$Ps[a],c=$Cs[a],d="layout",e=Instance[a],f=children[a];if(e.child&&!f){var g=e.child.container;f=children[a]=(g?g.data(d):0)||null}f&&f.destroyed&&(f=children[a]=null),f||(f=children[a]=b.data(d)||(c?c.data(d):0)||null),e.child=children[a],f&&f.resizeAll()},sizeContent=function(a,b){if(!isInitialized())return;a=a?a.split(","):_c.allPanes,$.each(a,function(a,c){function j(a){return max(g.css.paddingBottom,parseInt(a.css("marginBottom"),10)||0)}function k(){var a=options[c].contentIgnoreSelector,b=e.nextAll().not(a||":lt(0)"),d=b.filter(":visible"),f=d.filter(":last");h={top:e[0].offsetTop,height:e.outerHeight(),numFooters:b.length,hiddenFooters:b.length-d.length,spaceBelow:0},h.spaceAbove=h.top,h.bottom=h.top+h.height,f.length?h.spaceBelow=f[0].offsetTop+f.outerHeight()-h.bottom+j(f):h.spaceBelow=j(e)}var d=$Ps[c],e=$Cs[c],f=options[c],g=state[c],h=g.content;if(!d||!e||!d.is(":visible"))return!0;if(!1===_execCallback(null,f.onsizecontent_start))return;if(!g.isMoving&&!g.isResizing||f.liveContentResizing||b||h.top==undefined)k(),h.hiddenFooters>0&&d.css("overflow")==="hidden"&&(d.css("overflow","visible"),k(),d.css("overflow","hidden"));var i=g.innerHeight-(h.spaceAbove-g.css.paddingTop)-(h.spaceBelow-g.css.paddingBottom);if(!e.is(":visible")||h.height!=i)setOuterHeight(e,i,!0),h.height=i;state.initialized&&(_execCallback(c,f.onsizecontent_end||f.onsizecontent),resizeChildLayout(c))})},sizeHandles=function(a){a=a?a.split(","):_c.borderPanes,$.each(a,function(a,b){var c=options[b],d=state[b],e=$Ps[b],f=$Rs[b],g=$Ts[b],h;if(!e||!f)return;var i=_c[b].dir,j=d.isClosed?"_closed":"_open",k=c["spacing"+j],l=c["togglerAlign"+j],m=c["togglerLength"+j],n,o,p={};if(k===0){f.hide();return}!d.noRoom&&!d.isHidden&&f.show(),i==="horz"?(n=e.outerWidth(),d.resizerLength=n,f.css({width:cssW(f,n),height:cssH(f,k),left:$.layout.cssNum(e,"left")})):(n=e.outerHeight(),d.resizerLength=n,f.css({height:cssH(f,n),width:cssW(f,k),top:sC.insetTop+getPaneSize("north",!0)})),removeHover(c,f);if(g){if(m===0||d.isSliding&&c.hideTogglerOnSlide){g.hide();return}g.show();if(!(m>0)||m==="100%"||m>n)m=n,o=0;else if(isStr(l))switch(l){case"top":case"left":o=0;break;case"bottom":case"right":o=n-m;break;case"middle":case"center":default:o=round((n-m)/2)}else{var q=parseInt(l,10);l>=0?o=q:o=n-m+q}if(i==="horz"){var r=cssW(g,m);g.css({width:r,height:cssH(g,k),left:o,top:0}),g.children(".content").each(function(){h=$(this),h.css("marginLeft",round((r-h.outerWidth())/2))})}else{var s=cssH(g,m);g.css({height:s,width:cssW(g,k),top:o,left:0}),g.children(".content").each(function(){h=$(this),h.css("marginTop",round((s-h.outerHeight())/2))})}removeHover(0,g)}!state.initialized&&(c.initHidden||d.noRoom)&&(f.hide(),g&&g.hide())})},enableClosable=function(a){if(!isInitialized())return;var b=$Ts[a],c=options[a];if(!b)return;c.closable=!0,b.bind("click."+sID,function(b){b.stopPropagation(),toggle(a)}).css("visibility","visible").css("cursor","pointer").attr("title",state[a].isClosed?c.togglerTip_closed:c.togglerTip_open).show()},disableClosable=function(a,b){if(!isInitialized())return;var c=$Ts[a];if(!c)return;options[a].closable=!1,state[a].isClosed&&open(a,!1,!0),c.unbind("."+sID).css("visibility",b?"hidden":"visible").css("cursor","default").attr("title","")},enableSlidable=function(a){if(!isInitialized())return;var b=$Rs[a],c=options[a];if(!b||!b.data("draggable"))return;options[a].slidable=!0,s.isClosed&&bindStartSlidingEvent(a,!0)},disableSlidable=function(a){if(!isInitialized())return;var b=$Rs[a];if(!b)return;options[a].slidable=!1,state[a].isSliding?close(a,!1,!0):(bindStartSlidingEvent(a,!1),b.css("cursor","default").attr("title",""),removeHover(null,b[0]))},enableResizable=function(a){if(!isInitialized())return;var b=$Rs[a],c=options[a];if(!b||!b.data("draggable"))return;c.resizable=!0,b.draggable("enable"),state[a].isClosed||b.css("cursor",c.resizerCursor).attr("title",c.resizerTip)},disableResizable=function(a){if(!isInitialized())return;var b=$Rs[a];if(!b||!b.data("draggable"))return;options[a].resizable=!1,b.draggable("disable").css("cursor","default").attr("title",""),removeHover(null,b[0])},swapPanes=function(a,b){function g(a){var b=$Ps[a],c=$Cs[a];return b?{pane:a,P:b?b[0]:!1,C:c?c[0]:!1,state:$.extend(!0,{},state[a]),options:$.extend(!0,{},options[a])}:!1}function h(a,b){if(!a)return;var c=a.P,d=a.C,e=a.pane,g=_c[b],h=g.side.toLowerCase(),i="inset"+g.side,j=$.extend({},state[b]),k=options[b],l={resizerCursor:k.resizerCursor},m,n,o;$.each("fxName,fxSpeed,fxSettings".split(","),function(a,b){l[b+"_open"]=k[b+"_open"],l[b+"_close"]=k[b+"_close"],l[b+"_size"]=k[b+"_size"]}),$Ps[b]=$(c).data("layoutEdge",b).css(_c.hidden).css(g.cssReq),$Cs[b]=d?$(d):!1,options[b]=$.extend({},a.options,l),state[b]=$.extend({},a.state),m=new RegExp(k.paneClass+"-"+e,"g"),c.className=c.className.replace(m,k.paneClass+"-"+b),initHandles(b),g.dir!=_c[e].dir?(n=f[b]||0,setSizeLimits(b),n=max(n,state[b].minSize),manualSizePane(b,n,!0,!0)):$Rs[b].css(h,sC[i]+(state[b].isVisible?getPaneSize(b):0)),a.state.isVisible&&!j.isVisible?setAsOpen(b,!0):(setAsClosed(b),bindStartSlidingEvent(b,!0)),a=null}if(!isInitialized())return;state[a].edge=b,state[b].edge=a;var c=!1;!1===_execCallback(a,options[a].onswap_start)&&(c=!0),!c&&!1===_execCallback(b,options[b].onswap_start)&&(c=!0);if(c){state[a].edge=a,state[b].edge=b;return}var d=g(a),e=g(b),f={};f[a]=d?d.state.size:0,f[b]=e?e.state.size:0,$Ps[a]=!1,$Ps[b]=!1,state[a]={},state[b]={},$Ts[a]&&$Ts[a].remove(),$Ts[b]&&$Ts[b].remove(),$Rs[a]&&$Rs[a].remove(),$Rs[b]&&$Rs[b].remove(),$Rs[a]=$Rs[b]=$Ts[a]=$Ts[b]=!1,h(d,b),h(e,a),d=e=f=null,$Ps[a]&&$Ps[a].css(_c.visible),$Ps[b]&&$Ps[b].css(_c.visible),resizeAll(),_execCallback(a,options[a].onswap_end||options[a].onswap),_execCallback(b,options[b].onswap_end||options[b].onswap);return},syncPinBtns=function(a,b){$.layout.plugins.buttons&&$.each(state[a].pins,function(c,d){$.layout.buttons.setPinState(Instance,$(d),a,b)})},$N=$(this).eq(0);if(!$N.length)return options.showErrorMessages&&_log(lang.errContainerMissing,!0),null;if($N.data("layoutContainer")&&$N.data("layout"))return $N.data("layout");var $Ps={},$Cs={},$Rs={},$Ts={},$Ms=$([]),sC=state.container,sID=state.id,Instance={options:options,state:state,container:$N,panes:$Ps,contents:$Cs,resizers:$Rs,togglers:$Ts,hide:hide,show:show,toggle:toggle,open:open,close:close,slideOpen:slideOpen,slideClose:slideClose,slideToggle:slideToggle,setSizeLimits:setSizeLimits,_sizePane:sizePane,sizePane:manualSizePane,sizeContent:sizeContent,swapPanes:swapPanes,createChildLayout:createChildLayout,destroy:destroy,addPane:addPane,removePane:removePane,initPanes:isInitialized,initContent:initContent,resizeAll:resizeAll,allowOverflow:allowOverflow,resetOverflow:resetOverflow,enableClosable:enableClosable,disableClosable:disableClosable,enableSlidable:enableSlidable,disableSlidable:disableSlidable,enableResizable:enableResizable,disableResizable:disableResizable,trigger:trigger,hasParentLayout:!1,children:children,north:!1,south:!1,west:!1,east:!1,center:!1};return _create()==="cancel"?null:Instance},$.ui||($.ui={}),$.ui.cookie={acceptsCookies:!!navigator.cookieEnabled,read:function(a){var b=document.cookie,c=b?b.split(";"):[],d;for(var e=0,f=c.length;e<f;e++){d=$.trim(c[e]).split("=");if(d[0]==a)return decodeURIComponent(d[1])}return null},write:function(a,b,c){var d="",e="",f=!1,g=c||{},h=g.expires;if(h&&h.toUTCString)e=h;else if(h===null||typeof h=="number")e=new Date,h>0?e.setDate(e.getDate()+h):(e.setFullYear(1970),f=!0);e&&(d+=";expires="+e.toUTCString()),g.path&&(d+=";path="+g.path),g.domain&&(d+=";domain="+g.domain),g.secure&&(d+=";secure"),document.cookie=a+"="+(f?"":encodeURIComponent(b))+d},clear:function(a){$.ui.cookie.write(a,"",{expires:-1})}},$.cookie||($.cookie=function(a,b,c){var d=$.ui.cookie;if(b===null)d.clear(a);else{if(b===undefined)return d.read(a);d.write(a,b,c)}}),$.layout.plugins.stateManagement=!0,$.layout.config.optionRootKeys.push("stateManagement"),$.layout.defaults.stateManagement={enabled:!1,autoSave:!0,autoLoad:!0,stateKeys:"north.size,south.size,east.size,west.size,north.isClosed,south.isClosed,east.isClosed,west.isClosed,north.isHidden,south.isHidden,east.isHidden,west.isHidden",cookie:{name:"",domain:"",path:"",expires:"",secure:!1}},$.layout.optionsMap.layout.push("stateManagement"),$.layout.state={saveCookie:function(a,b,c){var d=a.options,e=d.stateManagement,f=$.extend(!0,{},e.cookie,c||null),g=a.state.stateData=a.readState(b||e.stateKeys);return $.ui.cookie.write(f.name||d.name||"Layout",$.layout.state.encodeJSON(g),f),$.extend(!0,{},g)},deleteCookie:function(a){var b=a.options;$.ui.cookie.clear(b.stateManagement.cookie.name||b.name||"Layout")},readCookie:function(a){var b=a.options,c=$.ui.cookie.read(b.stateManagement.cookie.name||b.name||"Layout");return c?$.layout.state.decodeJSON(c):{}},loadCookie:function(a){var b=$.layout.state.readCookie(a);return b&&(a.state.stateData=$.extend(!0,{},b),a.loadState(b)),b},loadState:function(a,b,c){b=$.layout.transformData(b);if($.isEmptyObject(b))return;$.extend(!0,a.options,b);if(a.state.initialized){var d,e,f,g,h,i,j=c===!1;$.each($.layout.config.borderPanes,function(c,d){state=a.state[d],f=b[d];if(typeof f!="object")return;g=f.size,i=f.initClosed,h=f.initHidden,e=state.isVisible,e||a.sizePane(d,g,!1,!1),h===!0?a.hide(d,j):i===!1?a.open(d,!1,j):i===!0?a.close(d,!1,j):h===!1&&a.show(d,!1,j),e&&a.sizePane(d,g,!1,j)})}},readState:function(a,b){var c={},d={isClosed:"initClosed",isHidden:"initHidden"},e=a.state,f=$.layout.config.allPanes,g,h,i,j;b||(b=a.options.stateManagement.stateKeys),$.isArray(b)&&(b=b.join(",")),b=b.replace(/__/g,".").split(",");for(var k=0,l=b.length;k<l;k++){g=b[k].split("."),h=g[0],i=g[1];if($.inArray(h,f)<0)continue;j=e[h][i];if(j==undefined)continue;i=="isClosed"&&e[h].isSliding&&(j=!0),(c[h]||(c[h]={}))[d[i]?d[i]:i]=j}return c},encodeJSON:function(a){function b(a){var c=[],d=0,e,f,g;for(e in a)f=a[e],g=typeof f,g=="string"?f='"'+f+'"':g=="object"&&(f=b(f)),c[d++]='"'+e+'":'+f;return"{"+c.join(",")+"}"}return b(a)},decodeJSON:function(a){try{return $.parseJSON?$.parseJSON(a):window.eval("("+a+")")||{}}catch(b){return{}}},_create:function(a){var b=$.layout.state;$.extend(a,{readCookie:function(){return b.readCookie(a)},deleteCookie:function(){b.deleteCookie(a)},saveCookie:function(c,d){return b.saveCookie(a,c,d)},loadCookie:function(){return b.loadCookie(a)},loadState:function(c,d){b.loadState(a,c,d)},readState:function(c){return b.readState(a,c)},encodeJSON:b.encodeJSON,decodeJSON:b.decodeJSON}),a.state.stateData={};var c=a.options.stateManagement;c.enabled&&(c.autoLoad?a.loadCookie():a.state.stateData=a.readCookie())},_unload:function(a){var b=a.options.stateManagement;b.enabled&&(b.autoSave?a.saveCookie():a.state.stateData=a.readState())}},$.layout.onCreate.push($.layout.state._create),$.layout.onUnload.push($.layout.state._unload),$.layout.plugins.buttons=!0,$.layout.defaults.autoBindCustomButtons=!1,$.layout.optionsMap.layout.push("autoBindCustomButtons");var lang=$.layout.language;$.layout.buttons={init:function(a){var b="ui-layout-button-",c=a.options.name||"",d;$.each("toggle,open,close,pin,toggle-slide,open-slide".split(","),function(e,f){$.each($.layout.config.borderPanes,function(e,g){$("."+b+f+"-"+g).each(function(){d=$(this).data("layoutName")||$(this).attr("layoutName"),(d==undefined||d===c)&&a.bindButton(this,f,g)})})})},get:function(a,b,c,d){var e=$(b),f=a.options,g=f.showErrorMessages;if(!e.length)g&&$.layout.msg(lang.errButton+lang.selector+": "+b,!0);else if($.inArray(c,$.layout.config.borderPanes)<0)g&&$.layout.msg(lang.errButton+lang.pane+": "+c,!0),e=$("");else{var h=f[c].buttonClass+"-"+d;e.addClass(h+" "+h+"-"+c).data("layoutName",f.name)}return e},bind:function(a,b,c,d){var e=$.layout.buttons;switch(c.toLowerCase()){case"toggle":e.addToggle(a,b,d);break;case"open":e.addOpen(a,b,d);break;case"close":e.addClose(a,b,d);break;case"pin":e.addPin(a,b,d);break;case"toggle-slide":e.addToggle(a,b,d,!0);break;case"open-slide":e.addOpen(a,b,d,!0)}return a},addToggle:function(a,b,c,d){return $.layout.buttons.get(a,b,c,"toggle").click(function(b){a.toggle(c,!!d),b.stopPropagation()}),a},addOpen:function(a,b,c,d){return $.layout.buttons.get(a,b,c,"open").attr("title",lang.Open).click(function(b){a.open(c,!!d),b.stopPropagation()}),a},addClose:function(a,b,c){return $.layout.buttons.get(a,b,c,"close").attr("title",lang.Close).click(function(b){a.close(c),b.stopPropagation()}),a},addPin:function(a,b,c){var d=$.layout.buttons,e=d.get(a,b,c,"pin");if(e.length){var f=a.state[c];e.click(function(b){d.setPinState(a,$(this),c,f.isSliding||f.isClosed),f.isSliding||f.isClosed?a.open(c):a.close(c),b.stopPropagation()}),d.setPinState(a,e,c,!f.isClosed&&!f.isSliding),f.pins.push(b)}return a},setPinState:function(a,b,c,d){var e=b.attr("pin");if(e&&d===(e=="down"))return;var f=a.options[c].buttonClass+"-pin",g=f+"-"+c,h=f+"-up "+g+"-up",i=f+"-down "+g+"-down";b.attr("pin",d?"down":"up").attr("title",d?lang.Unpin:lang.Pin).removeClass(d?h:i).addClass(d?i:h)},syncPinBtns:function(a,b,c){$.each(state[b].pins,function(d,e){$.layout.buttons.setPinState(a,$(e),b,c)})},_load:function(a){var b=$.layout.buttons;$.extend(a,{bindButton:function(c,d,e){return b.bind(a,c,d,e)},addToggleBtn:function(c,d,e){return b.addToggle(a,c,d,e)},addOpenBtn:function(c,d,e){return b.addOpen(a,c,d,e)},addCloseBtn:function(c,d){return b.addClose(a,c,d)},addPinBtn:function(c,d){return b.addPin(a,c,d)}});for(var c=0;c<4;c++){var d=$.layout.config.borderPanes[c];a.state[d].pins=[]}a.options.autoBindCustomButtons&&b.init(a)},_unload:function(a){}},$.layout.onLoad.push($.layout.buttons._load),$.layout.plugins.browserZoom=!0,$.layout.defaults.browserZoomCheckInterval=1e3,$.layout.optionsMap.layout.push("browserZoomCheckInterval"),$.layout.browserZoom={_init:function(a){$.layout.browserZoom._setTimer(a)},_setTimer:function(a){if(a.destroyed)return;var b=a.options,c=a.state,d=c.browserZoom=$.layout.browserZoom.ratio();b.resizeWithWindow&&d!==!1&&setTimeout(function(){if(a.destroyed)return;var b=$.layout.browserZoom.ratio();b!==c.browserZoom&&(c.browserZoom=b,a.resizeAll()),$.layout.browserZoom._setTimer(a)},Math.max(b.browserZoomCheckInterval,100))},ratio:function(){function j(a,b){return(parseInt(a,10)/parseInt(b,10)*100).toFixed()}var a=window,b=screen,c=document,d=c.documentElement||c.body,e=$.layout.browser,f=e.version,g,h,i;return e.msie&&f>8||!e.msie?!1:b.deviceXDPI?j(b.deviceXDPI,b.systemXDPI):e.webkit&&(g=c.body.getBoundingClientRect)?j(g.left-g.right,c.body.offsetWidth):e.webkit&&(h=a.outerWidth)?j(h,a.innerWidth):(h=b.width)&&(i=d.clientWidth)?j(h,i):!1}},$.layout.onReady.push($.layout.browserZoom._init)})(jQuery);
/*
* qTip2 - Pretty powerful tooltips
* http://craigsworks.com/projects/qtip2/
*
* Version: 2.0.0pre
* Copyright 2009-2010 Craig Michael Thompson - http://craigsworks.com
*
* Dual licensed under MIT or GPLv2 licenses
*   http://en.wikipedia.org/wiki/MIT_License
*   http://en.wikipedia.org/wiki/GNU_General_Public_License
*
* Date: Wed Feb 23 23:51:34 2011 +0000
*/
"use strict",function(a,b,c){function d(b){var c=this,d=b.elements,e=d.tooltip,f=".bgiframe-"+b.id,g="tooltipmove"+f+" tooltipshow"+f;a.extend(c,{init:function(){d.bgiframe=a('<iframe class="ui-tooltip-bgiframe" frameborder="0" tabindex="-1" src="javascript:\'\';"  style="display:block; position:absolute; z-index:-1; filter:alpha(opacity=0);"></iframe>'),d.bgiframe.appendTo(e),e.bind(g,c.adjust)},adjust:function(){var a=b.get("dimensions"),c=b.plugins.tip,f=b.elements.tip,g,h;h=parseInt(e.css("border-left-width"),10)||0,h={left:-h,top:-h},c&&f&&(g=c.corner.precedance==="x"?["width","left"]:["height","top"],h[g[1]]-=f[g[0]]()),d.bgiframe.css(h).css(a)},destroy:function(){c.iframe.remove(),e.unbind(g)}}),c.init()}function e(c){var d=this,e=c.options.show.modal,f=c.elements,g=f.tooltip,h="#qtip-overlay",i=".qtipmodal",j="tooltipshow"+i+" tooltiphide"+i;c.checks.modal={"^show.modal.(on|blur)$":function(){d.init(),f.overlay.toggle(g.is(":visible"))}},a.extend(d,{init:function(){e.on&&(g.unbind(i).bind(j,function(b,c,g){var h=b.type.replace("tooltip","");a.isFunction(e[h])?e[h].call(f.overlay,g,c):d[h](g)}),d.create(),e.blur===m&&f.overlay.unbind(i+c.id).bind("click"+i+c.id,function(){c.hide.call(c)}),f.overlay.css("cursor",e.blur?"pointer":""))},create:function(){var c=a(h),d;return c.length?(f.overlay=c,c):(d=f.overlay=a("<div />",{id:h.substr(1),css:{position:"absolute",top:0,left:0,display:"none"},mousedown:function(){return n}}).appendTo(document.body),a(b).bind("resize"+i,function(){d.css({height:Math.max(a(b).height(),a(document).height()),width:Math.max(a(b).width(),a(document).width())})}).trigger("resize"),d)},toggle:function(b){var e=f.overlay,h=c.options.show.modal.effect,i=b?"show":"hide",j;e||(e=d.create());if(!e.is(":animated")||b)e.stop(m,n),b&&(j=parseInt(a.css(g[0],"z-index"),10),e.css("z-index",(j||p.zindex)-1)),a.isFunction(h)?h.call(e,b):h===n?e[i]():e.fadeTo(90,b?.7:0,function(){b||a(this).hide()})},show:function(){d.toggle(m)},hide:function(){d.toggle(n)},destroy:function(){var d=f.overlay;d&&(a(h).each(function(){var b=a(this).data("qtip");if(b&&b.id!==b.id&&b.options.show.modal)return d=n}),d?(f.overlay.remove(),a(b).unbind(i)):f.overlay.unbind(i+c.id)),g.unbind(j)}}),d.init()}function f(b,d){function e(a){var b=a.precedance==="y",c=s[b?"width":"height"],d=s[b?"height":"width"],e=a.string().indexOf("center")>-1,f=c*(e?.5:1),g=Math.pow,h=Math.round,i,j,k,l=Math.sqrt(g(f,2)+g(d,2)),m=[u/f*l,u/d*l];return m[2]=Math.sqrt(g(m[0],2)-g(u,2)),m[3]=Math.sqrt(g(m[1],2)-g(u,2)),i=l+m[2]+m[3]+(e?0:m[0]),j=i/l,k=[h(j*d),h(j*c)],{height:k[b?0:1],width:k[b?1:0]}}function f(b){var c=l.titlebar&&b.y==="top",d=c?l.titlebar:l.content,e=a.browser.mozilla,f=e?"-moz-":a.browser.webkit?"-webkit-":"",g=b.y+(e?"":"-")+b.x,h=f+(e?"border-radius-"+g:"border-"+g+"-radius");return parseInt(d.css(h),10)||parseInt(p.css(h),10)||0}function h(a,b,c){b=b?b:a[a.precedance];var d=l.titlebar&&a.y==="top",e=d?l.titlebar:l.content,f="border-"+b+"-width",g=parseInt(e.css(f),10);return(c?g||parseInt(p.css(f),10):g)||0}function i(b,d,e,f){if(l.tip){var g=a.extend({},j.corner),h=e.adjusted,i;j.corner.fixed!==m&&(h.left&&(g.x=g.x==="center"?h.left>0?"left":"right":g.x==="left"?"right":"left"),h.top&&(g.y=g.y==="center"?h.top>0?"top":"bottom":g.y==="top"?"bottom":"top"),g.string()!==r.corner&&(r.top!==h.top||r.left!==h.left)&&(i=j.update(g))),i||(i=j.position(g,0)),i.right!==c&&(i.left=i.right),i.bottom!==c&&(i.top=i.bottom),i.option=Math.max(0,k.offset),e.left-=i.left.charAt?i.option:(i.right?-1:1)*i.left,e.top-=i.top.charAt?i.option:(i.bottom?-1:1)*i.top,r.left=h.left,r.top=h.top,r.corner=g.string()}}var j=this,k=b.options.style.tip,l=b.elements,p=l.tooltip,r={top:0,left:0,corner:""},s={width:k.width,height:k.height},t={},u=k.border||0,v=".qtip-tip",w=a("<canvas />")[0].getContext;j.corner=o,j.mimic=o,b.checks.tip={"^position.my|style.tip.(corner|mimic|border)$":function(){j.init()||j.destroy(),b.reposition()},"^style.tip.(height|width)$":function(){s={width:k.width,height:k.height},j.create(),j.update(),b.reposition()},"^content.title.text|style.(classes|widget)$":function(){l.tip&&j.update()}},a.extend(j,{init:function(){var b=j.detectCorner()&&(w||a.browser.msie);return b&&(j.create(),j.update(),p.unbind(v).bind("tooltipmove"+v,i)),b},detectCorner:function(){var a=k.corner,c=b.options.position,d=c.at,e=c.my.string?c.my.string():c.my;return a===n||e===n&&d===n?n:(a===m?j.corner=new q.Corner(e):a.string||(j.corner=new q.Corner(a),j.corner.fixed=m),j.corner.string()!=="centercenter")},detectColours:function(){var c=l.tip.css({backgroundColor:"",border:""}),d=j.corner,e=d[d.precedance],f="border-"+e+"-color",g="border"+e.charAt(0)+e.substr(1)+"Color",h=/rgba?\(0, 0, 0(, 0)?\)|transparent/i,i="background-color",m="transparent",n=l.titlebar&&(d.y==="top"||d.y==="center"&&c.position().top+s.height/2+k.offset<l.titlebar.outerHeight(1)),o=n?l.titlebar:l.content;t.fill=c.css(i)||m,t.border=c[0].style[g];if(!t.fill||h.test(t.fill))t.fill=o.css(i),h.test(t.fill)&&(t.fill=p.css(i));if(!t.border||h.test(t.border)){t.border=p.css(f);if(h.test(t.border)||t.border===a(document.body).css("color"))t.border=o.css(f)!==a(b.elements.content).css("color")?o.css(f):m}a("*",c).add(c).css(i,m).css("border","0px dashed transparent")},create:function(){var b=s.width,c=s.height,d;l.tip&&l.tip.remove(),l.tip=a("<div />",{"class":"ui-tooltip-tip"}).css({width:b,height:c}).prependTo(p),w?a("<canvas />").appendTo(l.tip)[0].getContext("2d").save():(d='<vml:shape coordorigin="0,0" style="display:block; position:absolute; behavior:url(#default#VML);"></vml:shape>',l.tip.html(u?d+=d:d))},update:function(b){var c=l.tip,d=c.children(),f=s.width,i=s.height,p="px solid ",r="px dashed transparent",v=k.mimic,x=Math.round,y,z,A,B,C;return b||(b=j.corner),v===n?v=b:(v=new q.Corner(v),v.precedance=b.precedance,v.x==="inherit"?v.x=b.x:v.y==="inherit"?v.y=b.y:v.x===v.y&&(v[b.precedance]=b[b.precedance])),y=v.precedance,j.detectColours(),u=t.border==="transparent"||t.border==="#123456"?0:k.border===m?h(b,o,m):k.border,A=g(v,f,i),C=e(b),c.css(C),b.precedance==="y"?B=[x(v.x==="left"?u:v.x==="right"?C.width-f-u:(C.width-f)/2),x(v.y==="top"?C.height-i:0)]:B=[x(v.x==="left"?C.width-f:0),x(v.y==="top"?u:v.y==="bottom"?C.height-i-u:(C.height-i)/2)],w?(d.attr(C),z=d[0].getContext("2d"),z.restore(),z.save(),z.clearRect(0,0,3e3,3e3),z.translate(B[0],B[1]),z.beginPath(),z.moveTo(A[0][0],A[0][1]),z.lineTo(A[1][0],A[1][1]),z.lineTo(A[2][0],A[2][1]),z.closePath(),z.fillStyle=t.fill,z.strokeStyle=t.border,z.lineWidth=u*2,z.lineJoin="miter",z.miterLimit=100,z.stroke(),z.fill()):(A="m"+A[0][0]+","+A[0][1]+" l"+A[1][0]+","+A[1][1]+" "+A[2][0]+","+A[2][1]+" xe",B[2]=u&&/^(r|b)/i.test(b.string())?1:0,d.css({antialias:""+(v.string().indexOf("center")>-1),left:B[0]-B[2]*Number(y==="x"),top:B[1]-B[2]*Number(y==="y"),width:f+u,height:i+u}).each(function(b){var c=a(this);c.attr({coordsize:f+u+" "+(i+u),path:A,fillcolor:t.fill,filled:!!b,stroked:!b}).css({display:u||b?"block":"none"}),!b&&u>0&&c.html()===""&&c.html('<vml:stroke weight="'+u*2+'px" color="'+t.border+'" miterlimit="1000" joinstyle="miter"  style="behavior:url(#default#VML); display:block;" />')})),j.position(b,1)},position:function(b,c){var d=l.tip,g={},i=Math.max(0,k.offset),o,p,q;return k.corner===n||!d?n:(b=b||j.corner,o=b.precedance,p=e(b),q=a.browser.msie&&u&&/^(b|r)/i.test(b.string())?1:0,a.each(o==="y"?[b.x,b.y]:[b.y,b.x],function(a,c){var d,e;c==="center"?(d=o==="y"?"left":"top",g[d]="50%",g["margin-"+d]=-Math.round(p[o==="y"?"width":"height"]/2)+i):(d=h(b,c,m),e=f(b),g[c]=a||!u?h(b,c)+(a?0:e):i+(e>d?e:0))}),g[b[o]]-=p[o==="x"?"width":"height"]+q,c&&d.css({top:"",bottom:"",left:"",right:"",margin:""}).css(g),g)},destroy:function(){l.tip&&l.tip.remove(),p.unbind(v)}}),j.init()}function g(a,b,c){var d=Math.ceil(b/2),e=Math.ceil(c/2),f={bottomright:[[0,0],[b,c],[b,0]],bottomleft:[[0,0],[b,0],[0,c]],topright:[[0,c],[b,0],[b,c]],topleft:[[0,0],[0,c],[b,c]],topcenter:[[0,c],[d,0],[b,c]],bottomcenter:[[0,0],[b,0],[d,c]],rightcenter:[[0,0],[b,e],[0,c]],leftcenter:[[b,0],[b,c],[0,e]]};return f.lefttop=f.bottomright,f.righttop=f.bottomleft,f.leftbottom=f.topright,f.rightbottom=f.topleft,f[a.string()]}function h(b){var c=this,d=b.elements.tooltip,e=b.options.content.ajax,f=".qtip-ajax",g=/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi;b.checks.ajax={"^content.ajax":function(a,b,d){b==="ajax"&&(e=d),b==="once"?c.once(e.once):e&&e.url?c.load():c.once(0)}},a.extend(c,{init:function(){e&&e.url&&(c.load(),d.one("tooltipshow",function(){c.once(e.once)}))},once:function(a){d[(a?"un":"")+"bind"]("tooltipshow"+f,c.load)},load:function(){function d(a,c,d){b.set("content.text",c+": "+d)}function f(c){j&&(c=a("<div/>").append(c.replace(g,"")).find(j)),b.set("content.text",c)}var h=e.url.indexOf(" "),i=e.url,j;return h>-1&&(j=i.substr(h),i=i.substr(0,h)),a.ajax(a.extend({success:f,error:d,context:b},e,{url:i})),c}}),c.init()}function i(b,c){var d,e,f,g,h=a(this),i=a(document.body),r=this===document?i:h,s=h.metadata?h.metadata(c.metadata):o,t=c.metadata.type==="html5"&&s?s[c.metadata.name]:o,u=h.data(c.metadata.name||"qtipopts");try{u=typeof u=="string"?(new Function("return "+u))():u}catch(v){l("Unable to parse HTML5 attribute data: "+u)}g=a.extend(m,{},p.defaults,c,typeof u=="object"?k(u):o,k(t||s)),s&&a.removeData(this,"metadata"),e=g.position,g.id=b;if("boolean"==typeof g.content.text){f=h.attr(g.content.attr);if(g.content.attr!==n&&f)g.content.text=f;else return n}e.container===n&&(e.container=i),e.target===n&&(e.target=r),g.show.target===n&&(g.show.target=r),g.show.solo===m&&(g.show.solo=i),g.hide.target===n&&(g.hide.target=r),g.position.viewport===m&&(g.position.viewport=e.container),e.at=new q.Corner(e.at),e.my=new q.Corner(e.my);if(a.data(this,"qtip"))if(g.overwrite)h.qtip("destroy");else if(g.overwrite===n)return n;return a.attr(this,"title")&&(a.data(this,z,a.attr(this,"title")),h.removeAttr("title")),d=new j(h,g,b,!!f),a.data(this,"qtip",d),h.bind("remove.qtip",function(){d.destroy()}),d}function j(d,e,f,g){function h(c,d,g,h){h=parseInt(h,10)!==0;var i=".qtip-"+f,j={show:c&&e.show.target[0],hide:d&&e.hide.target[0],tooltip:g&&G.rendered&&L.tooltip[0],content:g&&G.rendered&&L.content[0],container:h&&e.position.container[0]===H?document:e.position.container[0],window:h&&b};G.rendered?a([]).pushStack(a.grep([j.show,j.hide,j.tooltip,j.container,j.content,j.window],function(a){return typeof a=="object"})).unbind(i):c&&e.show.target.unbind(i+"-create")}function i(c,g,h,i){function j(a){E()&&G.reposition(a)}function k(a){if(K.hasClass(u))return n;clearTimeout(G.timers.inactive),G.timers.inactive=setTimeout(function(){G.hide(a)},e.hide.inactive)}function l(b){if(K.hasClass(u))return n;var c=a(b.relatedTarget||b.target),d=c.closest(v)[0]===K[0],f=c[0]===s.show[0];clearTimeout(G.timers.show),clearTimeout(G.timers.hide);if(q.target==="mouse"&&d||e.hide.fixed&&/mouse(out|leave|move)/.test(b.type)&&(d||f))return b.stopPropagation(),b.preventDefault(),n;K.stop(1,1),e.hide.delay>0?G.timers.hide=setTimeout(function(){G.hide(b)},e.hide.delay):G.hide(b)}function m(a){if(K.hasClass(u))return n;s.show.trigger("qtip-"+f+"-inactive"),clearTimeout(G.timers.show),clearTimeout(G.timers.hide);var b=function(){G.show(a)};e.show.delay>0?G.timers.show=setTimeout(b,e.show.delay):b()}var o=".qtip-"+f,q=e.position,s={show:e.show.target,hide:e.hide.target,container:q.container[0]===H?a(document):q.container,doc:a(document)},t={show:String(e.show.event).split(" "),hide:String(e.hide.event).split(" ")},w=a.browser.msie&&parseInt(a.browser.version,10)===6;h&&(e.hide.fixed&&(s.hide=s.hide.add(K),K.bind("mouseover"+o,function(){K.hasClass(u)||clearTimeout(G.timers.hide)})),q.target==="mouse"&&e.hide.event&&K.bind("mouseleave"+o,function(a){(a.relatedTarget||a.target)!==s.show[0]&&G.hide(a)}),K.bind("mouseenter"+o+" mouseleave"+o,function(a){G[a.type==="mouseenter"?"focus":"blur"](a)})),g&&("number"==typeof e.hide.inactive&&(s.show.bind("qtip-"+f+"-inactive",k),a.each(p.inactiveEvents,function(a,b){s.hide.add(L.tooltip).bind(b+o+"-inactive",k)})),a.each(t.hide,function(b,c){var d=a.inArray(c,t.show),e=a(s.hide);d>-1&&e.add(s.show).length===e.length||c==="unfocus"?(s.show.bind(c+o,function(a){E()?l(a):m(a)}),delete t.show[d]):s.hide.bind(c+o,l)})),c&&a.each(t.show,function(a,b){s.show.bind(b+o,m)}),i&&((q.adjust.resize||q.viewport)&&a(a.event.special.resize?q.viewport:b).bind("resize"+o,j),(q.viewport||w&&K.css("position")==="fixed")&&a(q.viewport).bind("scroll"+o,j),/unfocus/i.test(e.hide.event)&&s.doc.bind("mousedown"+o,function(b){var c=a(b.target);c.parents(v).length===0&&c.add(d).length>1&&E()&&!K.hasClass(u)&&G.hide(b)}),q.target==="mouse"&&s.doc.bind("mousemove"+o,function(a){q.adjust.mouse&&!K.hasClass(u)&&E()&&G.reposition(a||r)}))}function j(b,c){var e=L.content;return!G.rendered||!b?n:(a.isFunction(b)&&(b=b.call(d,G)||""),b.jquery&&b.length>0?e.empty().append(b.css({display:"block"})):e.html(b),K.queue("fx",function(b){function c(a){d=d.not(a),d.length===0&&(G.redraw(),G.rendered&&E()&&G.reposition(M.event),b())}var d=e.find("img:not([height]):not([width])");d.each(function(b,d){var e=["abort","error","load","unload",""].join(".qtip-image ");return a(this).bind(e,function(){clearTimeout(G.timers.img[b]),c(this)}),function f(){if(d.height&&d.width)return c(d);G.timers.img[b]=setTimeout(f,20)}(),m}),d.length===0&&c(d)}),G)}function l(b){var c=L.title;if(!G.rendered||!b)return n;a.isFunction(b)&&(b=b.call(d,G)||""),b.jquery&&b.length>0?c.empty().append(b.css({display:"block"})):c.html(b),G.redraw(),G.rendered&&E()&&G.reposition(M.event)}function y(a){var b=L.button,c=L.title;if(!G.rendered)return n;a?(c||A(),B()):b.remove()}function A(){var b=I+"-title";L.titlebar&&C(),L.titlebar=a("<div />",{"class":s+"-titlebar "+(e.style.widget?"ui-widget-header":"")}).append(L.title=a("<div />",{id:b,"class":s+"-title","aria-atomic":m})).insertBefore(L.content),e.content.title.button?B():G.rendered&&G.redraw()}function B(){var b=e.content.title.button;L.button&&L.button.remove(),b.jquery?L.button=b:L.button=a("<a />",{"class":"ui-state-default "+(e.style.widget?"":s+"-icon"),title:"Close tooltip","aria-label":"Close tooltip"}).prepend(a("<span />",{"class":"ui-icon ui-icon-close",html:"&times;"})),L.button.appendTo(L.titlebar).attr("role","button").hover(function(b){a(this).toggleClass("ui-state-hover",b.type==="mouseenter")}).click(function(a){return K.hasClass(u)||G.hide(a),n}).bind("mousedown keydown mouseup keyup mouseout",function(b){a(this).toggleClass("ui-state-active ui-state-focus",b.type.substr(-4)==="down")}),G.redraw()}function C(){L.title&&(L.titlebar.remove(),L.titlebar=L.title=L.button=o,G.reposition())}function D(){var a=e.style.widget;K.toggleClass(t,a),L.content.toggleClass(t+"-content",a),L.titlebar&&L.titlebar.toggleClass(t+"-header",a),L.button&&L.button.toggleClass(s+"-icon",!a)}function E(){return K&&K.css("left")!==x&&K.css("visibility")!=="hidden"}function F(a){var b=0,c,d=e,f=a.split(".");while(d=d[f[b++]])b<f.length&&(c=d);return[c||e,f.pop()]}var G=this,H=document.body,I=s+"-"+f,J=0,K,L,M;G.id=f,G.rendered=n,G.elements=L={target:d},G.timers={img:[]},G.options=e,G.checks={},G.plugins={},G.cache=M={event:{},target:o,disabled:n,attr:g},G.checks.builtin={"^id$":function(b,c,d){var e=d===m?p.nextid:d,f=s+"-"+e;e!==n&&e.length>0&&!a("#"+f).length&&(K[0].id=f,L.content[0].id=f+"-content",L.title[0].id=f+"-title")},"^content.text$":function(a,b,c){j(c)},"^content.title.text$":function(a,b,c){if(!c)return C();!L.title&&c&&A(),l(c)},"^content.title.button$":function(a,b,c){y(c)},"^position.(my|at)$":function(a,b,c){"string"==typeof c&&(a[b]=new q.Corner(c))},"^position.container$":function(a,b,c){G.rendered&&K.appendTo(c)},"^(show|hide).(event|target|fixed|delay|inactive)$":function(a,b,c,d,e){var f=[1,0,0];f[e[0]==="show"?"push":"unshift"](0),h.apply(G,f),i.apply(G,[1,1,0,0])},"^show.ready$":function(){G.rendered||G.show()},"^style.classes$":function(b,c,d){a.attr(K[0],"class",s+" qtip ui-helper-reset "+d)},"^style.widget|content.title":D,"^events.(render|show|move|hide|focus|blur)$":function(b,c,d){K[(a.isFunction(d)?"":"un")+"bind"]("tooltip"+c,d)}},a.extend(G,{render:function(b){if(G.rendered)return n;var c=e.content.text,f=e.content.title.text,g=a.Event("tooltiprender");return a.attr(d[0],"aria-describedby",I),K=L.tooltip=a("<div/>").attr({id:I,"class":s+" qtip ui-helper-reset "+e.style.classes,role:"alert","aria-live":"polite","aria-atomic":n,"aria-describedby":I+"-content","aria-hidden":m}).toggleClass(u,M.disabled).data("qtip",G).appendTo(e.position.container).append(L.content=a("<div />",{"class":s+"-content",id:I+"-content","aria-atomic":m})),G.rendered=m,f&&(A(),l(f)),j(c),D(),a.each(q,function(){this.initialize==="render"&&this(G)}),i(1,1,1,1),a.each(e.events,function(a,b){if(b){var c=a==="toggle"?"tooltipshow tooltiphide":"tooltip"+a;K.bind(c,b)}}),K.css("visibility","hidden").queue("fx",function(a){g.originalEvent=M.event,K.trigger(g,[G]),(e.show.ready||b)&&G.show(M.event),a()}),G},get:function(a){var b,c;switch(a.toLowerCase()){case"dimensions":b={height:K.outerHeight(),width:K.outerWidth()};break;case"offset":b=q.offset(K,e.position.container);break;default:c=F(a.toLowerCase()),b=c[0][c[1]],b=b.precedance?b.string():b}return b},set:function(b,c){function d(a,b){var c,d,e;if(G.rendered){for(c in h)for(d in h[c])if(e=(new RegExp(d,"i")).exec(a))b.push(e),h[c][d].apply(G,b)}else a==="show.ready"&&b[2]&&(J=0,G.render(m))}var f=/^position.(my|at|adjust|target|container)|style|content/i,g=n,h=G.checks,i;return"string"==typeof b?(i=b,b={},b[i]=c):b=a.extend(m,{},b),a.each(b,function(c,d){var e=F(c.toLowerCase()),h;h=e[0][e[1]],e[0][e[1]]="object"==typeof d&&d.nodeType?a(d):d,b[c]=[e[0],e[1],d,h],g=f.test(c)||g}),k(e),J=1,a.each(b,d),J=0,g&&E()&&G.rendered&&G.reposition(),G},toggle:function(b,c){function d(){b?a.browser.msie&&K[0].style.removeAttribute("filter"):K.css({display:"",visibility:"hidden",width:"",opacity:"",left:"",top:""})}if(!G.rendered)if(b)G.render(1);else return n;var g=b?"show":"hide",h=e[g],i=E(),j;(typeof b).search("boolean|number")&&(b=!i);if(i===b)return G;if(c){if(/over|enter/.test(c.type)&&/out|leave/.test(M.event.type)&&c.target===e.show.target[0]&&K.has(c.relatedTarget).length)return G;M.event=a.extend({},c)}return j=a.Event("tooltip"+g),j.originalEvent=c?M.event:o,K.trigger(j,[G,90]),j.isDefaultPrevented()?G:(a.attr(K[0],"aria-hidden",!b),b?(K.hide().css({visibility:""}),G.focus(c),G.reposition(c,0),h.solo&&a(v,h.solo).not(K).qtip("hide",j)):(clearTimeout(G.timers.show),G.blur(c)),K.stop(1,1),a.isFunction(h.effect)?(h.effect.call(K,G),K.queue("fx",function(a){d.call(this,a),a()})):h.effect===n?(K[g](),d.call(K)):K.fadeTo(90,b?1:0,d),b&&h.target.trigger("qtip-"+f+"-inactive"),G)},show:function(a){return G.toggle(m,a)},hide:function(a){return G.toggle(n,a)},focus:function(b){if(!G.rendered)return n;var c=a(v),d=parseInt(K[0].style.zIndex,10),e=p.zindex+c.length,f=a.extend({},b),g,h;return K.hasClass(w)||(d!==e&&(c.each(function(){this.style.zIndex>d&&(this.style.zIndex=this.style.zIndex-1)}),c.filter("."+w).qtip("blur",f)),h=a.Event("tooltipfocus"),h.originalEvent=f,K.trigger(h,[G,e]),h.isDefaultPrevented()||(K.addClass(w)[0].style.zIndex=e)),G},blur:function(b){var c=a.extend({},b),d;return K.removeClass(w),d=a.Event("tooltipblur"),d.originalEvent=c,K.trigger(d,[G]),G},reposition:function(d,f){if(!G.rendered||J)return n;J=m;var g=e.position.target,h=e.position,i=h.my,j=h.at,k=h.adjust,l=K.outerWidth(),o=K.outerHeight(),t=0,u=0,v=a.Event("tooltipmove"),w=K.css("position")==="fixed",x=h.viewport.jquery?h.viewport:a(b),y={left:0,top:0},z=(G.plugins.tip||{}).corner,A={left:function(a){var b=x.scrollLeft,c=i.x==="left"?l:i.x==="right"?-l:-l/2,d=j.x==="left"?t:j.x==="right"?-t:-t/2,e=z&&z.precedance==="x"?p.defaults.style.tip.width:0,f=b-a-e,g=a+l-x.width-b+e,h=c-(i.precedance==="x"||i.x===i.y?d:0),m=i.x==="center";return f>0&&(i.x!=="left"||g>0)?y.left-=h+(m?0:2*k.x):g>0&&(i.x!=="right"||f>0)&&(y.left-=m?-h:h+2*k.x),y.left!==a&&m&&(y.left-=k.x),y.left<0&&-y.left>g&&(y.left=a),y.left-a},top:function(a){var b=x.scrollTop,c=i.y==="top"?o:i.y==="bottom"?-o:-o/2,d=j.y==="top"?u:j.y==="bottom"?-u:-u/2,e=z&&z.precedance==="y"?p.defaults.style.tip.height:0,f=b-a-e,g=a+o-x.height-b+e,h=c-(i.precedance==="y"||i.x===i.y?d:0),l=i.y==="center";return f>0&&(i.y!=="top"||g>0)?y.top-=h+(l?0:2*k.y):g>0&&(i.y!=="bottom"||f>0)&&(y.top-=l?-h:h+2*k.y),y.top!==a&&l&&(y.top-=k.y),y.top<0&&-y.top>g&&(y.top=a),y.top-a}};f=f===c||!!f||n,x=x?{elem:x,height:x[(x[0]===b?"h":"outerH")+"eight"](),width:x[(x[0]===b?"w":"outerW")+"idth"](),scrollLeft:x.scrollLeft(),scrollTop:x.scrollTop()}:n;if(g==="mouse")j={x:"left",y:"top"},d=!d||d.type!=="resize"&&d.type!=="scroll"?k.mouse||!d||!d.pageX?a.extend({},r):d:M.event,y={top:d.pageY,left:d.pageX};else{g==="event"&&(d&&d.target&&d.type!=="scroll"&&d.type!=="resize"?g=M.target=a(d.target):g=M.target),g=a(g).eq(0);if(g.length===0)return G;g[0]===document||g[0]===b?(t=g.width(),u=g.height(),g[0]===b&&(y={top:w?0:x.scrollTop,left:w?0:x.scrollLeft})):g.is("area")&&q.imagemap?y=q.imagemap(g,j):g[0].namespaceURI=="http://www.w3.org/2000/svg"&&q.svg?y=q.svg(g,j):(t=g.outerWidth(),u=g.outerHeight(),y=q.offset(g,h.container)),y.offset&&(t=y.width,u=y.height,y=y.offset),y.left+=j.x==="right"?t:j.x==="center"?t/2:0,y.top+=j.y==="bottom"?u:j.y==="center"?u/2:0}return y.left+=k.x+(i.x==="right"?-l:i.x==="center"?-l/2:0),y.top+=k.y+(i.y==="bottom"?-o:i.y==="center"?-o/2:0),h.viewport.jquery&&g[0]!==b&&g[0]!==H?y.adjusted={left:A.left(y.left),top:A.top(y.top)}:y.adjusted={left:0,top:0},K.attr("class",function(b,c){return a.attr(this,"class").replace(/ui-tooltip-pos-\w+/i,"")}).addClass(s+"-pos-"+i.abbreviation()),v.originalEvent=a.extend({},d),K.trigger(v,[G,y,x.elem]),v.isDefaultPrevented()?G:(delete y.adjusted,f&&isNaN(y.left,y.top)?E()&&a.isFunction(h.effect)&&(h.effect.call(K,G,y),K.queue(function(b){var c=a(this);c.css({opacity:"",height:""}),a.browser.msie&&this.style&&this.style.removeAttribute("filter"),b()})):K.css(y),J=n,G)},redraw:function(){if(!G.rendered||!a.browser.msie||a.browser.version>=8)return n;var b=s+"-fluid",c;return K.css({width:"auto",height:"auto"}).addClass(b),c={height:K.outerHeight(),width:K.outerWidth()},a.each(["width","height"],function(a,b){var d=parseInt(K.css("max-"+b),10)||0,e=parseInt(K.css("min-"+b),10)||0;c[b]=d+e?Math.min(Math.max(c[b],e),d):c[b]}),K.css(c).removeClass(b),G},disable:function(b){var c=u;return"boolean"!=typeof b&&(b=!K.hasClass(c)&&!M.disabled),G.rendered?(K.toggleClass(c,b),a.attr(K[0],"aria-disabled",b)):M.disabled=!!b,G},enable:function(){G.disable(n)},destroy:function(){var b=d[0],c=a.data(b,z);return G.rendered&&(K.remove(),a.each(G.plugins,function(){this.destroy&&this.destroy()})),clearTimeout(G.timers.show),clearTimeout(G.timers.hide),h(1,1,1,1),a.removeData(b,"qtip"),c&&a.attr(b,"title",c),d.removeAttr("aria-describedby").unbind(".qtip"),d}})}function k(b){var c;if(!b||"object"!=typeof b)return n;"object"!=typeof b.metadata&&(b.metadata={type:b.metadata});if("content"in b){if("object"!=typeof b.content||b.content.jquery)b.content={text:b.content};c=b.content.text||n,!a.isFunction(c)&&(!c&&!c.attr||c.length<1||"object"==typeof c&&!c.jquery)&&(b.content.text=n),"title"in b.content&&("object"!=typeof b.content.title&&(b.content.title={text:b.content.title}),c=b.content.title.text||n,!a.isFunction(c)&&(!c&&!c.attr||c.length<1||"object"==typeof c&&!c.jquery)&&(b.content.title.text=n))}return"position"in b&&"object"!=typeof b.position&&(b.position={my:b.position,at:b.position}),"show"in b&&"object"!=typeof b.show&&(b.show.jquery?b.show={target:b.show}:b.show={event:b.show}),"hide"in b&&"object"!=typeof b.hide&&(b.hide.jquery?b.hide={target:b.hide}:b.hide={event:b.hide}),"style"in b&&"object"!=typeof b.style&&(b.style={classes:b.style}),a.each(q,function(){this.sanitize&&this.sanitize(b)}),b}function l(){var c=b.console;return c&&(c.error||c.log||a.noop).apply(c,arguments)}var m=!0,n=!1,o=null,p,q,r,s="ui-tooltip",t="ui-widget",u="ui-state-disabled",v="div.qtip."+s,w=s+"-focus",x="-31000px",y="_replacedByqTip",z="oldtitle";p=a.fn.qtip=function(b,d,e){var f=String(b).toLowerCase(),g=o,h=f==="disable"?[m]:a.makeArray(arguments).slice(1,10),i=h[h.length-1],j=this[0]?a.data(this[0],"qtip"):o;if(!arguments.length&&j||f==="api")return j;if("string"==typeof b)return this.each(function(){var b=a.data(this,"qtip");if(!b)return m;i&&i.timeStamp&&(b.cache.event=i);if(f==="option"&&d)if(a.isPlainObject(d)||e!==c)b.set(d,e);else return g=b.get(d),n;else b[f]&&b[f].apply(b[f],h)}),g!==o?g:this;if("object"==typeof b||!arguments.length)return j=k(a.extend(m,{},b)),p.bind.call(this,j,i)},p.bind=function(b,c){return this.each(function(d){function e(b){function c(){l.render(typeof b=="object"||f.show.ready),g.show.unbind(h.show),g.hide.unbind(h.hide)}if(l.cache.disabled)return n;l.cache.event=a.extend({},b),f.show.delay>0?(clearTimeout(l.timers.show),l.timers.show=setTimeout(c,f.show.delay),h.show!==h.hide&&g.hide.bind(h.hide,function(){clearTimeout(l.timers.show)})):c()}var f,g,h,j=!b.id||b.id===n||b.id.length<1||a("#"+s+"-"+b.id).length?p.nextid++:b.id,k=".qtip-"+j+"-create",l=i.call(this,j,b);if(l===n)return m;f=l.options,a.each(q,function(){this.initialize==="initialize"&&this(l)}),g={show:f.show.target,hide:f.hide.target},h={show:String(f.show.event).replace(" ",k+" ")+k,hide:String(f.hide.event).replace(" ",k+" ")+k},g.show.bind(h.show,e),(f.show.ready||f.prerender)&&e(c)})},q=p.plugins={Corner:function(a){a=String(a).replace(/([A-Z])/," $1").replace(/middle/gi,"center").toLowerCase(),this.x=(a.match(/left|right/i)||a.match(/center/)||["inherit"])[0].toLowerCase(),this.y=(a.match(/top|bottom|center/i)||["inherit"])[0].toLowerCase(),this.precedance=a.charAt(0).search(/^(t|b)/)>-1?"y":"x",this.string=function(){return this.precedance==="y"?this.y+this.x:this.x+this.y},this.abbreviation=function(){var a=this.x.substr(0,1),b=this.y.substr(0,1);return a===b?a:a==="c"||a!=="c"&&b!=="c"?b+a:a+b}},offset:function(c,d){function e(a,b){f.left+=b*a.scrollLeft(),f.top+=b*a.scrollTop()}var f=c.offset(),g=d,h=0,i=document.body,j;if(g){do{if(g[0]===i)break;g.css("position")!=="static"&&(j=g.position(),f.left-=j.left+(parseInt(g.css("borderLeftWidth"),10)||0),f.top-=j.top+(parseInt(g.css("borderTopWidth"),10)||0),h++)}while(g=g.offsetParent());(d[0]!==i||h>1)&&e(d,1),q.iOS&&e(a(b),-1)}return f},iOS:parseFloat((/CPU.+OS ([0-9_]{3}).*AppleWebkit.*Mobile/i.exec(navigator.userAgent)||[0,"4_2"])[1].replace("_","."))<4.1,fn:{attr:function(b,c){if(this.length){var d=this[0],e="title",f=a.data(d,"qtip");if(b===e){if(arguments.length<2)return a.data(d,z);if(typeof f=="object")return f&&f.rendered&&f.options.content.attr===e&&f.cache.attr&&f.set("content.text",c),a.fn["attr"+y].apply(this,arguments),a.data(d,z,a.attr(d,e)),this.removeAttr("title")}}},clone:function(b){var c=a([]),d;return a("*",this).add(this).each(function(){var b=a.data(this,z);b&&(a.attr(this,"title",b),c=c.add(this))}),d=a.fn["clone"+y].apply(this,arguments),c.removeAttr("title"),d},remove:a.ui?o:function(b,c){a(this).each(function(){c||(!b||a.filter(b,[this]).length)&&a("*",this).add(this).each(function(){a(this).triggerHandler("remove")})})}}},a.each(q.fn,function(b,c){if(!c)return m;var d=a.fn[b+y]=a.fn[b];a.fn[b]=function(){return c.apply(this,arguments)||d.apply(this,arguments)}}),a(b).bind("load.qtip",function(){var b="mousemove";a(document).bind(b+".qtip",function(a){r={pageX:a.pageX,pageY:a.pageY,type:b}})}),p.version="2.0.0pre",p.nextid=0,p.inactiveEvents="click dblclick mousedown mouseup mousemove mouseleave mouseenter".split(" "),p.zindex=15e3,p.defaults={prerender:n,id:n,overwrite:m,content:{text:m,attr:"title",title:{text:n,button:n}},position:{my:"top left",at:"bottom right",target:n,container:n,viewport:n,adjust:{x:0,y:0,mouse:m,resize:m},effect:m},show:{target:n,event:"mouseenter",effect:m,delay:90,solo:n,ready:n},hide:{target:n,event:"mouseleave",effect:m,delay:0,fixed:n,inactive:n},style:{classes:"",widget:n},events:{render:o,move:o,show:o,hide:o,toggle:o,focus:o,blur:o}},q.ajax=function(a){var b=a.plugins.ajax;return"object"==typeof b?b:a.plugins.ajax=new h(a)},q.ajax.initialize="render",q.ajax.sanitize=function(a){var b=a.content,c;b&&"ajax"in b&&(c=b.ajax,typeof c!="object"&&(c=a.content.ajax={url:c}),"boolean"!=typeof c.once&&c.once&&(c.once=!!c.once))},a.extend(m,p.defaults,{content:{ajax:{once:m}}}),q.tip=function(a){var b=a.plugins.tip;return"object"==typeof b?b:a.plugins.tip=new f(a)},q.tip.initialize="render",q.tip.sanitize=function(a){var b=a.style,c;b&&"tip"in b&&(c=a.style.tip,typeof c!="object"&&(a.style.tip={corner:c}),/string|boolean/i.test(typeof c.corner)||(c.corner=m),typeof c.width!="number"&&delete c.width,typeof c.height!="number"&&delete c.height,typeof c.border!="number"&&c.border!==m&&delete c.border,typeof c.offset!="number"&&delete c.offset)},a.extend(m,p.defaults,{style:{tip:{corner:m,mimic:n,width:6,height:6,border:m,offset:0}}}),q.imagemap=function(b,c){function d(a,b){var d=0,e=1,f=1,g=0,h=0,i=a.width,j=a.height;while(i>0&&j>0&&e>0&&f>0){i=Math.floor(i/2),j=Math.floor(j/2),c.x==="left"?e=i:c.x==="right"?e=a.width-i:e+=Math.floor(i/2),c.y==="top"?f=j:c.y==="bottom"?f=a.height-j:f+=Math.floor(j/2),d=b.length;while(d--){if(b.length<2)break;g=b[d][0]-a.offset.left,h=b[d][1]-a.offset.top,(c.x==="left"&&g>=e||c.x==="right"&&g<=e||c.x==="center"&&(g<e||g>a.width-e)||c.y==="top"&&h>=f||c.y==="bottom"&&h<=f||c.y==="center"&&(h<f||h>a.height-f))&&b.splice(d,1)}}return{left:b[0][0],top:b[0][1]}}var e=b.attr("shape").toLowerCase(),f=b.attr("coords").split(","),g=[],h=a('img[usemap="#'+b.parent("map").attr("name")+'"]'),i=h.offset(),j={width:0,height:0,offset:{top:1e10,right:0,bottom:0,left:1e10}},k=0,l=0;i.left+=Math.ceil((h.outerWidth()-h.width())/2),i.top+=Math.ceil((h.outerHeight()-h.height())/2);if(e==="poly"){k=f.length;while(k--)l=[parseInt(f[--k],10),parseInt(f[k+1],10)],l[0]>j.offset.right&&(j.offset.right=l[0]),l[0]<j.offset.left&&(j.offset.left=l[0]),l[1]>j.offset.bottom&&(j.offset.bottom=l[1]),l[1]<j.offset.top&&(j.offset.top=l[1]),g.push(l)}else g=a.map(f,function(a){return parseInt(a,10)});switch(e){case"rect":j={width:Math.abs(g[2]-g[0]),height:Math.abs(g[3]-g[1]),offset:{left:g[0],top:g[1]}};break;case"circle":j={width:g[2]+2,height:g[2]+2,offset:{left:g[0],top:g[1]}};break;case"poly":a.extend(j,{width:Math.abs(j.offset.right-j.offset.left),height:Math.abs(j.offset.bottom-j.offset.top)}),c.string()==="centercenter"?j.offset={left:j.offset.left+j.width/2,top:j.offset.top+j.height/2}:j.offset=d(j,g.slice()),j.width=j.height=0}return j.offset.left+=i.left,j.offset.top+=i.top,j},q.svg=function(b,c){var d=a(document),e=b[0],f={width:0,height:0,offset:{top:1e10,left:1e10}},g,h,i,j,k;if(e.getBBox&&e.parentNode){g=e.getBBox(),h=e.getScreenCTM(),i=e.farthestViewportElement||e;if(!i.createSVGPoint)return f;j=i.createSVGPoint(),j.x=g.x,j.y=g.y,k=j.matrixTransform(h),f.offset.left=k.x,f.offset.top=k.y,j.x+=g.width,j.y+=g.height,k=j.matrixTransform(h),f.width=k.x-f.offset.left,f.height=k.y-f.offset.top,f.offset.left+=d.scrollLeft(),f.offset.top+=d.scrollTop()}return f},q.modal=function(a){var b=a.plugins.modal;return"object"==typeof b?b:a.plugins.modal=new e(a)},q.modal.initialize="render",q.modal.sanitize=function(a){a.show&&(typeof a.show.modal!="object"?a.show.modal={on:!!a.show.modal}:typeof a.show.modal.on=="undefined"&&(a.show.modal.on=m))},a.extend(m,p.defaults,{show:{modal:{on:n,effect:m,blur:m}}}),q.bgiframe=function(b){var c=a.browser,e=b.plugins.bgiframe;return!q.bgiframe.needBGI||!c.msie||c.version.charAt(0)!=="6"?n:"object"==typeof e?e:b.plugins.bgiframe=new d(b)},q.bgiframe.initialize="render",q.bgiframe.needBGI=a("select, object").length>0}(jQuery,window);
/*!
 * jQuery UI AriaTabs (31.01.11)
 * http://github.com/fnagel/jQuery-Accessible-RIA
 *
 * Copyright (c) 2009 Felix Nagel for Namics (Deustchland) GmbH
 * Copyright (c) 2010 Felix Nagel
 * Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php
 *
 * Depends: ui.core.js 1.8.x
 *   		ui.tabs.js
 */
(function(a){a.fn.extend(a.ui.tabs.prototype,{_create:function(){var b=this,c=this.options;if(a.address){var d={enable:!0,title:{enable:!0,split:" | "}};a.isEmptyObject(c.jqAddress)?c.jqAddress={}:a.extend(!0,d,c.jqAddress),a.extend(!0,c.jqAddress,d)}if(a.address&&c.jqAddress.enable)var e="#"+a.address.value().replace("/","");b._tabify(!0),this.anchors.bind(c.event+".tabs-accessibility",function(){this.focus()}),b.list.attr("role","tablist");for(x=0;x<b.anchors.length;x++)a.address&&c.jqAddress.enable&&e!="#"&&a(b.anchors[x]).attr("href")==e&&b.select(x),b._ariaInit(x);b.list.keydown(function(d){var e=!1;switch(d.keyCode){case a.ui.keyCode.RIGHT:b.select(c.selected+1);break;case a.ui.keyCode.DOWN:b.select(c.selected+1),e=!0;break;case a.ui.keyCode.UP:b.select(c.selected-1);break;case a.ui.keyCode.LEFT:b.select(c.selected-1);break;case a.ui.keyCode.END:b.select(b.anchors.length-1);break;case a.ui.keyCode.HOME:b.select(0)}return e}),a.address&&this.options.jqAddress.enable&&a.address.externalChange(function(c){var d="#"+c.value.replace("/",""),e=0;while(e<b.anchors.length){if(a(b.anchors[e]).attr("href")==d){b.select(e);return}e++}}),b.initiated=!0},_original_load:a.ui.tabs.prototype.load,load:function(b){a.address&&this.options.jqAddress.enable&&(a(this.anchors[0]).attr("aria-selected")!==undefined?(this.options.forceFirst===0&&b!==0&&(a.address.value()==""&&a.address.history(!1),a.address.value(a(this.anchors[0]).attr("href").replace(/^#/,"")),a.address.history(!0),this.options.forceFirst=!1),this.options.jqAddress.title.enable&&a.address.title(a.address.title().split(this.options.jqAddress.title.split)[0]+this.options.jqAddress.title.split+a(this.anchors[b]).text()),a.address.value(a(this.anchors[b]).attr("href").replace(/^#/,""))):this.options.forceFirst=b);for(x=0;x<this.anchors.length;x++)this._ariaSet(x,!1),a.data(this.anchors[x],"href.tabs")&&a(this.panels[x]).removeAttr("aria-live").removeAttr("aria-busy");a.data(this.anchors[b],"href.tabs")&&a(this.panels[b]).attr("aria-live","polite").attr("aria-busy","true"),this._original_load(b),a.data(this.anchors[b],"href.tabs")&&a(this.panels[b]).attr("aria-busy","false"),this._ariaSet(b,!0)},_ariaSet:function(b,c){var d=c?0:-1,e=a(this.anchors[b]);e.attr("tabindex",d).attr("aria-selected",c),c?!a.browser.msie&&this.initiated&&e.focus():e.closest("li").removeClass("ui-state-focus"),a(this.panels[b]).attr("aria-hidden",!c).attr("aria-expanded",c),a.browser.msie&&this.initiated&&(this.options.timeout=window.setTimeout(function(){e.focus()},100)),c&&this._updateVirtualBuffer()},_ariaInit:function(b){var c=this,d=a(this.panels[b]).attr("id");a(this.anchors[b]).attr("aria-controls",d).attr("id",d+"-tab").parent().attr("role","tab"),a(this.panels[b]).attr("role","tabpanel").attr("tabindex",0).attr("aria-labelledby",d+"-tab"),this.options.collapsible&&a(this.anchors[b]).bind(this.options.event,function(d){c._ariaSet(b,!a(c.panels[b]).hasClass("ui-tabs-hide"))})},_original_add:a.ui.tabs.prototype.add,add:function(a,b,c){this._original_add(a,b,c),this.element.attr("aria-live","polite").attr("aria-relevant","additions"),c?(this._ariaInit(c),this._ariaSet(c,!1)):(this._ariaInit(this.anchors.length-1),this._ariaSet(this.anchors.length-1,!1))},_original_remove:a.ui.tabs.prototype.remove,remove:function(a){this._original_remove(a),this.element.attr("aria-live","polite").attr("aria-relevant","removals")},_original_destroy:a.ui.tabs.prototype.destroy,destroy:function(){var b=this,c=this.options;b.element.removeAttr("role").removeAttr("aria-live").removeAttr("aria-relevant"),b.list.removeAttr("role");for(x=0;x<b.anchors.length;x++)a(b.anchors[x]).removeAttr("aria-selected").removeAttr("aria-controls").removeAttr("role").removeAttr("id").removeAttr("tabindex").parent().removeAttr("role"),a(b.panels[x]).removeAttr("aria-hidden").removeAttr("aria-expanded").removeAttr("aria-labelledby").removeAttr("aria-live").removeAttr("aria-busy").removeAttr("aria-relevant").removeAttr("role");a("body>form #virtualBufferForm").parent().remove(),this._original_destroy()},_updateVirtualBuffer:function(){var b=a("body>form #virtualBufferForm");b.length?(b.val()=="1"?b.val("0"):b.val("1"),b.hasClass("ui-accessibility-odd")?b.addClass("ui-accessibility-even").removeClass("ui-accessibility-odd"):b.addClass("ui-accessibility-odd").removeClass("ui-accessibility-even")):a("body").append('<form><input id="virtualBufferForm" type="hidden" value="1" /></form>')}})})(jQuery);
/*!
 * Modernizr v2.0.6
 * http://www.modernizr.com
 *
 * Copyright (c) 2009-2011 Faruk Ates, Paul Irish, Alex Sexton
 * Dual-licensed under the BSD or MIT licenses: www.modernizr.com/license/
 */
window.Modernizr=function(a,b,c){function B(a){k.cssText=a}function C(a,b){return B(o.join(a+";")+(b||""))}function D(a,b){return typeof a===b}function E(a,b){return!!~(""+a).indexOf(b)}function F(a,b){for(var d in a)if(k[a[d]]!==c)return b=="pfx"?a[d]:!0;return!1}function G(a,b){var c=a.charAt(0).toUpperCase()+a.substr(1),d=(a+" "+p.join(c+" ")+c).split(" ");return F(d,b)}function I(){e.input=function(a){for(var b=0,c=a.length;b<c;b++)t[a[b]]=a[b]in l;return t}("autocomplete autofocus list placeholder max min multiple pattern required step".split(" ")),e.inputtypes=function(a){for(var d=0,e,f,h,i=a.length;d<i;d++)l.setAttribute("type",f=a[d]),e=l.type!=="text",e&&(l.value=m,l.style.cssText="position:absolute;visibility:hidden;",/^range$/.test(f)&&l.style.WebkitAppearance!==c?(g.appendChild(l),h=b.defaultView,e=h.getComputedStyle&&h.getComputedStyle(l,null).WebkitAppearance!=="textfield"&&l.offsetHeight!==0,g.removeChild(l)):/^(search|tel)$/.test(f)||(/^(url|email)$/.test(f)?e=l.checkValidity&&l.checkValidity()===!1:/^color$/.test(f)?(g.appendChild(l),g.offsetWidth,e=l.value!=m,g.removeChild(l)):e=l.value!=m)),s[a[d]]=!!e;return s}("search tel url email datetime date month week time datetime-local number range color".split(" "))}var d="2.0.6",e={},f=!0,g=b.documentElement,h=b.head||b.getElementsByTagName("head")[0],i="modernizr",j=b.createElement(i),k=j.style,l=b.createElement("input"),m=":)",n=Object.prototype.toString,o=" -webkit- -moz- -o- -ms- -khtml- ".split(" "),p="Webkit Moz O ms Khtml".split(" "),q={svg:"http://www.w3.org/2000/svg"},r={},s={},t={},u=[],v,w=function(a,c,d,e){var f,h,j,k=b.createElement("div");if(parseInt(d,10))while(d--)j=b.createElement("div"),j.id=e?e[d]:i+(d+1),k.appendChild(j);return f=["&shy;","<style>",a,"</style>"].join(""),k.id=i,k.innerHTML+=f,g.appendChild(k),h=c(k,a),k.parentNode.removeChild(k),!!h},x=function(b){if(a.matchMedia)return matchMedia(b).matches;var c;return w("@media "+b+" { #"+i+" { position: absolute; } }",function(b){c=(a.getComputedStyle?getComputedStyle(b,null):b.currentStyle)["position"]=="absolute"}),c},y=function(){function d(d,e){e=e||b.createElement(a[d]||"div"),d="on"+d;var f=d in e;return f||(e.setAttribute||(e=b.createElement("div")),e.setAttribute&&e.removeAttribute&&(e.setAttribute(d,""),f=D(e[d],"function"),D(e[d],c)||(e[d]=c),e.removeAttribute(d))),e=null,f}var a={select:"input",change:"input",submit:"form",reset:"form",error:"img",load:"img",abort:"img"};return d}(),z={}.hasOwnProperty,A;!D(z,c)&&!D(z.call,c)?A=function(a,b){return z.call(a,b)}:A=function(a,b){return b in a&&D(a.constructor.prototype[b],c)};var H=function(c,d){var f=c.join(""),g=d.length;w(f,function(c,d){var f=b.styleSheets[b.styleSheets.length-1],h=f.cssRules&&f.cssRules[0]?f.cssRules[0].cssText:f.cssText||"",i=c.childNodes,j={};while(g--)j[i[g].id]=i[g];e.touch="ontouchstart"in a||j.touch.offsetTop===9,e.csstransforms3d=j.csstransforms3d.offsetLeft===9,e.generatedcontent=j.generatedcontent.offsetHeight>=1,e.fontface=/src/i.test(h)&&h.indexOf(d.split(" ")[0])===0},g,d)}(['@font-face {font-family:"font";src:url("https://")}',["@media (",o.join("touch-enabled),("),i,")","{#touch{top:9px;position:absolute}}"].join(""),["@media (",o.join("transform-3d),("),i,")","{#csstransforms3d{left:9px;position:absolute}}"].join(""),['#generatedcontent:after{content:"',m,'";visibility:hidden}'].join("")],["fontface","touch","csstransforms3d","generatedcontent"]);r.flexbox=function(){function a(a,b,c,d){b+=":",a.style.cssText=(b+o.join(c+";"+b)).slice(0,-b.length)+(d||"")}function c(a,b,c,d){a.style.cssText=o.join(b+":"+c+";")+(d||"")}var d=b.createElement("div"),e=b.createElement("div");a(d,"display","box","width:42px;padding:0;"),c(e,"box-flex","1","width:10px;"),d.appendChild(e),g.appendChild(d);var f=e.offsetWidth===42;return d.removeChild(e),g.removeChild(d),f},r.canvas=function(){var a=b.createElement("canvas");return!!a.getContext&&!!a.getContext("2d")},r.canvastext=function(){return!!e.canvas&&!!D(b.createElement("canvas").getContext("2d").fillText,"function")},r.webgl=function(){return!!a.WebGLRenderingContext},r.touch=function(){return e.touch},r.geolocation=function(){return!!navigator.geolocation},r.postmessage=function(){return!!a.postMessage},r.websqldatabase=function(){var b=!!a.openDatabase;return b},r.indexedDB=function(){for(var b=-1,c=p.length;++b<c;)if(a[p[b].toLowerCase()+"IndexedDB"])return!0;return!!a.indexedDB},r.hashchange=function(){return y("hashchange",a)&&(b.documentMode===c||b.documentMode>7)},r.history=function(){return!!a.history&&!!history.pushState},r.draganddrop=function(){return y("dragstart")&&y("drop")},r.websockets=function(){for(var b=-1,c=p.length;++b<c;)if(a[p[b]+"WebSocket"])return!0;return"WebSocket"in a},r.rgba=function(){return B("background-color:rgba(150,255,150,.5)"),E(k.backgroundColor,"rgba")},r.hsla=function(){return B("background-color:hsla(120,40%,100%,.5)"),E(k.backgroundColor,"rgba")||E(k.backgroundColor,"hsla")},r.multiplebgs=function(){return B("background:url(https://),url(https://),red url(https://)"),/(url\s*\(.*?){3}/.test(k.background)},r.backgroundsize=function(){return G("backgroundSize")},r.borderimage=function(){return G("borderImage")},r.borderradius=function(){return G("borderRadius")},r.boxshadow=function(){return G("boxShadow")},r.textshadow=function(){return b.createElement("div").style.textShadow===""},r.opacity=function(){return C("opacity:.55"),/^0.55$/.test(k.opacity)},r.cssanimations=function(){return G("animationName")},r.csscolumns=function(){return G("columnCount")},r.cssgradients=function(){var a="background-image:",b="gradient(linear,left top,right bottom,from(#9f9),to(white));",c="linear-gradient(left top,#9f9, white);";return B((a+o.join(b+a)+o.join(c+a)).slice(0,-a.length)),E(k.backgroundImage,"gradient")},r.cssreflections=function(){return G("boxReflect")},r.csstransforms=function(){return!!F(["transformProperty","WebkitTransform","MozTransform","OTransform","msTransform"])},r.csstransforms3d=function(){var a=!!F(["perspectiveProperty","WebkitPerspective","MozPerspective","OPerspective","msPerspective"]);return a&&"webkitPerspective"in g.style&&(a=e.csstransforms3d),a},r.csstransitions=function(){return G("transitionProperty")},r.fontface=function(){return e.fontface},r.generatedcontent=function(){return e.generatedcontent},r.video=function(){var a=b.createElement("video"),c=!1;try{if(c=!!a.canPlayType){c=new Boolean(c),c.ogg=a.canPlayType('video/ogg; codecs="theora"');var d='video/mp4; codecs="avc1.42E01E';c.h264=a.canPlayType(d+'"')||a.canPlayType(d+', mp4a.40.2"'),c.webm=a.canPlayType('video/webm; codecs="vp8, vorbis"')}}catch(e){}return c},r.audio=function(){var a=b.createElement("audio"),c=!1;try{if(c=!!a.canPlayType)c=new Boolean(c),c.ogg=a.canPlayType('audio/ogg; codecs="vorbis"'),c.mp3=a.canPlayType("audio/mpeg;"),c.wav=a.canPlayType('audio/wav; codecs="1"'),c.m4a=a.canPlayType("audio/x-m4a;")||a.canPlayType("audio/aac;")}catch(d){}return c},r.localstorage=function(){try{return!!localStorage.getItem}catch(a){return!1}},r.sessionstorage=function(){try{return!!sessionStorage.getItem}catch(a){return!1}},r.webworkers=function(){return!!a.Worker},r.applicationcache=function(){return!!a.applicationCache},r.svg=function(){return!!b.createElementNS&&!!b.createElementNS(q.svg,"svg").createSVGRect},r.inlinesvg=function(){var a=b.createElement("div");return a.innerHTML="<svg/>",(a.firstChild&&a.firstChild.namespaceURI)==q.svg},r.smil=function(){return!!b.createElementNS&&/SVG/.test(n.call(b.createElementNS(q.svg,"animate")))},r.svgclippaths=function(){return!!b.createElementNS&&/SVG/.test(n.call(b.createElementNS(q.svg,"clipPath")))};for(var J in r)A(r,J)&&(v=J.toLowerCase(),e[v]=r[J](),u.push((e[v]?"":"no-")+v));return e.input||I(),e.addTest=function(a,b){if(typeof a=="object")for(var d in a)A(a,d)&&e.addTest(d,a[d]);else{a=a.toLowerCase();if(e[a]!==c)return;b=typeof b=="boolean"?b:!!b(),g.className+=" "+(b?"":"no-")+a,e[a]=b}return e},B(""),j=l=null,a.attachEvent&&function(){var a=b.createElement("div");return a.innerHTML="<elem></elem>",a.childNodes.length!==1}()&&function(a,b){function s(a){var b=-1;while(++b<g)a.createElement(f[b])}a.iepp=a.iepp||{};var d=a.iepp,e=d.html5elements||"abbr|article|aside|audio|canvas|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",f=e.split("|"),g=f.length,h=new RegExp("(^|\\s)("+e+")","gi"),i=new RegExp("<(/*)("+e+")","gi"),j=/^\s*[\{\}]\s*$/,k=new RegExp("(^|[^\\n]*?\\s)("+e+")([^\\n]*)({[\\n\\w\\W]*?})","gi"),l=b.createDocumentFragment(),m=b.documentElement,n=m.firstChild,o=b.createElement("body"),p=b.createElement("style"),q=/print|all/,r;d.getCSS=function(a,b){if(a+""===c)return"";var e=-1,f=a.length,g,h=[];while(++e<f){g=a[e];if(g.disabled)continue;b=g.media||b,q.test(b)&&h.push(d.getCSS(g.imports,b),g.cssText),b="all"}return h.join("")},d.parseCSS=function(a){var b=[],c;while((c=k.exec(a))!=null)b.push(((j.exec(c[1])?"\n":c[1])+c[2]+c[3]).replace(h,"$1.iepp_$2")+c[4]);return b.join("\n")},d.writeHTML=function(){var a=-1;r=r||b.body;while(++a<g){var c=b.getElementsByTagName(f[a]),d=c.length,e=-1;while(++e<d)c[e].className.indexOf("iepp_")<0&&(c[e].className+=" iepp_"+f[a])}l.appendChild(r),m.appendChild(o),o.className=r.className,o.id=r.id,o.innerHTML=r.innerHTML.replace(i,"<$1font")},d._beforePrint=function(){p.styleSheet.cssText=d.parseCSS(d.getCSS(b.styleSheets,"all")),d.writeHTML()},d.restoreHTML=function(){o.innerHTML="",m.removeChild(o),m.appendChild(r)},d._afterPrint=function(){d.restoreHTML(),p.styleSheet.cssText=""},s(b),s(l);if(d.disablePP)return;n.insertBefore(p,n.firstChild),p.media="print",p.className="iepp-printshim",a.attachEvent("onbeforeprint",d._beforePrint),a.attachEvent("onafterprint",d._afterPrint)}(a,b),e._version=d,e._prefixes=o,e._domPrefixes=p,e.mq=x,e.hasEvent=y,e.testProp=function(a){return F([a])},e.testAllProps=G,e.testStyles=w,e.prefixed=function(a){return G(a,"pfx")},g.className=g.className.replace(/\bno-js\b/,"")+(f?" js "+u.join(" "):""),e}(this,this.document);
